SystemOrganization addCategory: #'XPath-Tests'!

TestCase subclass: #XPathBooleanTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathBooleanTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:49'!
testAsXPathBoolean
	self
		assert: true asXPathBoolean;
		deny: false asXPathBoolean! !

!XPathBooleanTest methodsFor: 'tests' stamp: 'monty 2/11/2017 16:00'!
testAsXPathComparable
	| comparable |

	comparable := true asXPathComparable.
	self
		assert: comparable class == XPathBooleanComparable;
		assert: comparable value.! !

!XPathBooleanTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:51'!
testAsXPathNodeSet
	self
		should: [true asXPathNodeSet]
		raise: XPathTypeException.
	self
		should: [false asXPathNodeSet]
		raise: XPathTypeException.! !

!XPathBooleanTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:50'!
testAsXPathNumber
	self
		assert: true asXPathNumber = 1.0;
		assert: true asXPathNumber isFloat;
		assert: false asXPathNumber isXPathPositiveZero;
		assert: false asXPathNumber isFloat! !

!XPathBooleanTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:51'!
testAsXPathString
	self
		assert: true asXPathString = 'true';
		assert: false asXPathString = 'false'! !

TestCase subclass: #XPathComparableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathComparableTest commentStamp: 'monty 2/7/2017 17:14' prior: 0!
Abstract; do not run!

XPathComparableTest subclass: #XPathBooleanComparableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathBooleanComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 16:47'!
isAbstract
	^ false! !

!XPathBooleanComparableTest methodsFor: 'accessing' stamp: 'monty 2/11/2017 16:03'!
defaultComparable
	^ self comparableTrueValue! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToBoolean
	self assert:
		self comparableTrueValue =
			self comparableTrueValue.
	self deny:
		self comparableFalseValue =
			self comparableTrueValue.
	self deny:
		self comparableTrueValue =
			self comparableFalseValue.
	self assert:
		self comparableFalseValue =
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNodeSet
	self assert:
		self comparableTrueValue =
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableFalseValue =
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableTrueValue =
			self comparableEmptyNodeSet.
	self assert:
		self comparableFalseValue =
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNumber
	self assert:
		self comparableTrueValue =
			self comparableNumberValue.
	self deny:
		self comparableFalseValue =
			self comparableNumberValue.
	self assert:
		self comparableTrueValue =
			self comparableInfinityValue.
	self deny:
		self comparableFalseValue =
			self comparableInfinityValue.
	self assert:
		self comparableTrueValue =
			self comparableNegativeInfinityValue.
	self deny:
		self comparableFalseValue =
			self comparableNegativeInfinityValue.

	self deny:
		self comparableTrueValue =
			self comparableZeroValue.
	self assert:
		self comparableFalseValue =
			self comparableZeroValue.
	self deny:
		self comparableTrueValue =
			self comparableNegativeZeroValue.
	self assert:
		self comparableFalseValue =
			self comparableNegativeZeroValue.
	self deny:
		self comparableTrueValue =
			self comparableNaNValue.
	self assert:
		self comparableFalseValue =
			self comparableNaNValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToString
	self assert:
		self comparableTrueValue =
			self comparableStringValue.
	self deny:
		self comparableFalseValue =
			self comparableStringValue.
	self deny:
		self comparableTrueValue =
			self comparableEmptyStringValue.
	self assert:
		self comparableFalseValue =
			self comparableEmptyStringValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:23'!
testGreaterThanBoolean
	self deny:
		self comparableTrueValue >
			self comparableTrueValue.
	self deny:
		self comparableFalseValue >
			self comparableTrueValue.
	self assert:
		self comparableTrueValue >
			self comparableFalseValue.
	self deny:
		self comparableFalseValue >
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:53'!
testGreaterThanNodeSet
	self deny:
		self comparableTrueValue >
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableFalseValue >
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableTrueValue >
			self comparableEmptyNodeSet.
	self deny:
		self comparableFalseValue >
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:48'!
testGreaterThanNumber
	self deny:
		self comparableTrueValue >
			self comparableNumberValue.
	self deny:
		self comparableFalseValue >
			self comparableNumberValue.
	self deny:
		self comparableTrueValue >
			self comparableInfinityValue.
	self deny:
		self comparableFalseValue >
			self comparableInfinityValue.
	self assert:
		self comparableTrueValue >
			self comparableNegativeInfinityValue.
	self assert:
		self comparableFalseValue >
			self comparableNegativeInfinityValue.

	self assert:
		self comparableTrueValue >
			self comparableZeroValue.
	self deny:
		self comparableFalseValue >
			self comparableZeroValue.
	self assert:
		self comparableTrueValue >
			self comparableNegativeZeroValue.
	self deny:
		self comparableFalseValue >
			self comparableNegativeZeroValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:23'!
testGreaterThanOrEqualToBoolean
	self assert:
		self comparableTrueValue >=
			self comparableTrueValue.
	self deny:
		self comparableFalseValue >=
			self comparableTrueValue.
	self assert:
		self comparableTrueValue >=
			self comparableFalseValue.
	self assert:
		self comparableFalseValue >=
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:54'!
testGreaterThanOrEqualToNodeSet
	self assert:
		self comparableTrueValue >=
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableFalseValue >=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableTrueValue >=
			self comparableEmptyNodeSet.
	self assert:
		self comparableFalseValue >=
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:49'!
testGreaterThanOrEqualToNumber
	self assert:
		self comparableTrueValue >=
			self comparableNumberValue.
	self deny:
		self comparableFalseValue >=
			self comparableNumberValue.
	self deny:
		self comparableTrueValue >=
			self comparableInfinityValue.
	self deny:
		self comparableFalseValue >=
			self comparableInfinityValue.
	self assert:
		self comparableTrueValue >=
			self comparableNegativeInfinityValue.
	self assert:
		self comparableFalseValue >=
			self comparableNegativeInfinityValue.

	self assert:
		self comparableTrueValue >=
			self comparableZeroValue.
	self assert:
		self comparableFalseValue >=
			self comparableZeroValue.
	self assert:
		self comparableTrueValue >=
			self comparableNegativeZeroValue.
	self assert:
		self comparableFalseValue >=
			self comparableNegativeZeroValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:21'!
testGreaterThanOrEqualToString
	self assert:
		self comparableTrueValue >=
			self comparableNumberStringValue.
	self deny:
		self comparableFalseValue >=
			self comparableNumberStringValue.
	self assert:
		self comparableTrueValue >=
			self comparableZeroStringValue.
	self assert:
		self comparableFalseValue >=
			self comparableZeroStringValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:21'!
testGreaterThanString
	self deny:
		self comparableTrueValue >
			self comparableNumberStringValue.
	self deny:
		self comparableFalseValue >
			self comparableNumberStringValue.
	self assert:
		self comparableTrueValue >
			self comparableZeroStringValue.
	self deny:
		self comparableFalseValue >
			self comparableZeroStringValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:21'!
testLessThanBoolean
	self deny:
		self comparableTrueValue <
			self comparableTrueValue.
	self assert:
		self comparableFalseValue <
			self comparableTrueValue.
	self deny:
		self comparableTrueValue <
			self comparableFalseValue.
	self deny:
		self comparableFalseValue <
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:54'!
testLessThanNodeSet
	self deny:
		self comparableTrueValue <
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableFalseValue <
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableTrueValue <
			self comparableEmptyNodeSet.
	self deny:
		self comparableFalseValue <
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:48'!
testLessThanNumber
	self deny:
		self comparableTrueValue <
			self comparableNumberValue.
	self assert:
		self comparableFalseValue <
			self comparableNumberValue.
	self assert:
		self comparableTrueValue <
			self comparableInfinityValue.
	self assert:
		self comparableFalseValue <
			self comparableInfinityValue.
	self deny:
		self comparableTrueValue <
			self comparableNegativeInfinityValue.
	self deny:
		self comparableFalseValue <
			self comparableNegativeInfinityValue.

	self deny:
		self comparableTrueValue <
			self comparableZeroValue.
	self deny:
		self comparableFalseValue <
			self comparableZeroValue.
	self deny:
		self comparableTrueValue <
			self comparableNegativeZeroValue.
	self deny:
		self comparableFalseValue <
			self comparableNegativeZeroValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:22'!
testLessThanOrEqualToBoolean
	self assert:
		self comparableTrueValue <=
			self comparableTrueValue.
	self assert:
		self comparableFalseValue <=
			self comparableTrueValue.
	self deny:
		self comparableTrueValue <=
			self comparableFalseValue.
	self assert:
		self comparableFalseValue <=
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:55'!
testLessThanOrEqualToNodeSet
	self assert:
		self comparableTrueValue <=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableFalseValue <=
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableTrueValue <=
			self comparableEmptyNodeSet.
	self assert:
		self comparableFalseValue <=
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:51'!
testLessThanOrEqualToNumber
	self assert:
		self comparableTrueValue <=
			self comparableNumberValue.
	self assert:
		self comparableFalseValue <=
			self comparableNumberValue.
	self assert:
		self comparableTrueValue <=
			self comparableInfinityValue.
	self assert:
		self comparableFalseValue <=
			self comparableInfinityValue.
	self deny:
		self comparableTrueValue <=
			self comparableNegativeInfinityValue.
	self deny:
		self comparableFalseValue <=
			self comparableNegativeInfinityValue.

	self deny:
		self comparableTrueValue <=
			self comparableZeroValue.
	self assert:
		self comparableFalseValue <=
			self comparableZeroValue.
	self deny:
		self comparableTrueValue <=
			self comparableNegativeZeroValue.
	self assert:
		self comparableFalseValue <=
			self comparableNegativeZeroValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:21'!
testLessThanOrEqualToString
	self assert:
		self comparableTrueValue <=
			self comparableNumberStringValue.
	self assert:
		self comparableFalseValue <=
			self comparableNumberStringValue.
	self deny:
		self comparableTrueValue <=
			self comparableZeroStringValue.
	self assert:
		self comparableFalseValue <=
			self comparableZeroStringValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:21'!
testLessThanString
	self deny:
		self comparableTrueValue <
			self comparableNumberStringValue.
	self assert:
		self comparableFalseValue <
			self comparableNumberStringValue.
	self deny:
		self comparableTrueValue <
			self comparableZeroStringValue.
	self deny:
		self comparableFalseValue <
			self comparableZeroStringValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToBoolean
	self deny:
		self comparableTrueValue ~=
			self comparableTrueValue.
	self assert:
		self comparableFalseValue ~=
			self comparableTrueValue.
	self assert:
		self comparableTrueValue ~=
			self comparableFalseValue.
	self deny:
		self comparableFalseValue ~=
			self comparableFalseValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNodeSet
	self deny:
		self comparableTrueValue ~=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableFalseValue ~=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableTrueValue ~=
			self comparableEmptyNodeSet.
	self deny:
		self comparableFalseValue ~=
			self comparableEmptyNodeSet.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNumber
	self deny:
		self comparableTrueValue ~=
			self comparableNumberValue.
	self assert:
		self comparableFalseValue ~=
			self comparableNumberValue.
	self deny:
		self comparableTrueValue ~=
			self comparableInfinityValue.
	self assert:
		self comparableFalseValue ~=
			self comparableInfinityValue.
	self deny:
		self comparableTrueValue ~=
			self comparableNegativeInfinityValue.
	self assert:
		self comparableFalseValue ~=
			self comparableNegativeInfinityValue.

	self assert:
		self comparableTrueValue ~=
			self comparableZeroValue.
	self deny:
		self comparableFalseValue ~=
			self comparableZeroValue.
	self assert:
		self comparableTrueValue ~=
			self comparableNegativeZeroValue.
	self deny:
		self comparableFalseValue ~=
			self comparableNegativeZeroValue.
	self assert:
		self comparableTrueValue ~=
			self comparableNaNValue.
	self deny:
		self comparableFalseValue ~=
			self comparableNaNValue.! !

!XPathBooleanComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToString
	self deny:
		self comparableTrueValue ~=
			self comparableStringValue.
	self assert:
		self comparableFalseValue ~=
			self comparableStringValue.
	self assert:
		self comparableTrueValue ~=
			self comparableEmptyStringValue.
	self deny:
		self comparableFalseValue ~=
			self comparableEmptyStringValue.! !

!XPathComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 15:10'!
isAbstract
	^ true! !

!XPathComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 15:10'!
shouldInheritSelectors
	^ true! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:36'!
comparableDisjointNumberStringValue
	^ self disjointNumberValues first asString asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:15'!
comparableDisjointNumberValue
	^ self disjointNumberValues first asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:56'!
comparableDisjointStringValue
	^ self disjointStringValues first asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:31'!
comparableEmptyNodeSet
	^ self nodeSetClass new asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/9/2017 22:59'!
comparableEmptyStringValue
	^ '' asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:29'!
comparableFalseValue
	^ false asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:28'!
comparableInfinityValue
	^ Float infinity asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:28'!
comparableNaNValue
	^ Float nan asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 3/14/2017 22:29'!
comparableNegativeInfinityValue
	^ Float xpathNegativeInfinity asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 3/14/2017 22:29'!
comparableNegativeZeroValue
	^ Float xpathNegativeZero asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:39'!
comparableNodeSetWithDisjointNumberValues
	^ (self nodeSetClass newFrom:
		(self disjointNumberValues collect: [:each | each asString asXMLStringNode]))
			asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:39'!
comparableNodeSetWithDisjointStringValues
	^ (self nodeSetClass newFrom:
		(self disjointStringValues collect: [:each | each asXMLStringNode]))
			asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:38'!
comparableNodeSetWithNumberValues
	^ (self nodeSetClass newFrom:
		(self numberValues collect: [:each | each asString asXMLStringNode]))
			asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:32'!
comparableNodeSetWithSameNumberValue
	| nodeSet |

	nodeSet := self nodeSetClass new.
	self numberValues size timesRepeat: [
		nodeSet addLast:
			self numberValues first asString asXMLStringNode].
	^ nodeSet asXPathComparable.! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:32'!
comparableNodeSetWithSameStringValue
	| nodeSet |

	nodeSet := self nodeSetClass new.
	self stringValues size timesRepeat: [
		nodeSet addLast: self stringValues first asXMLStringNode].
	^ nodeSet asXPathComparable.! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:38'!
comparableNodeSetWithStringValues
	^ (self nodeSetClass newFrom:
		(self stringValues collect: [:each | each asXMLStringNode]))
			asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:36'!
comparableNumberStringValue
	^ self numberValues first asString asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:14'!
comparableNumberValue
	^ self numberValues first asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:56'!
comparableStringValue
	^ self stringValues first asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:28'!
comparableTrueValue
	^ true asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 19:45'!
comparableZeroStringValue
	^ '0' asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 16:29'!
comparableZeroValue
	^ 0 asXPathComparable! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/11/2017 16:04'!
defaultComparable
	self subclassResponsibility! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:37'!
disjointNumberValues
	^ #(5 6 7 8)! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:38'!
disjointStringValues
	^ #('five' 'six' 'seven' 'eight')! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:31'!
nodeSetClass
	^ XPathNodeSet! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:27'!
numberValues
	^ #(1 2 3 4)! !

!XPathComparableTest methodsFor: 'accessing' stamp: 'monty 2/7/2017 15:26'!
stringValues
	^ #('one' 'two' 'three' 'four')! !

!XPathComparableTest methodsFor: 'tests' stamp: 'monty 2/11/2017 16:05'!
testAsXPathComparable
	| comparable |

	comparable := self defaultComparable.
	self assert: comparable asXPathComparable == comparable.! !

XPathComparableTest subclass: #XPathNodeSetComparableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNodeSetComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 15:23'!
isAbstract
	^ false! !

!XPathNodeSetComparableTest methodsFor: 'accessing' stamp: 'monty 2/11/2017 16:04'!
defaultComparable
	^ self comparableNodeSetWithStringValues! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToBoolean
	self assert:
		self comparableNodeSetWithStringValues =
			self comparableTrueValue.
	self deny:
		self comparableEmptyNodeSet =
			self comparableTrueValue.
	self deny:
		self comparableNodeSetWithStringValues =
			self comparableFalseValue.
	self assert:
		self comparableEmptyNodeSet =
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	"as long as two node sets have one string value in common, they are equal"
	self assert:
		self comparableNodeSetWithStringValues =
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableNodeSetWithStringValues =
			self comparableNodeSetWithSameStringValue.
	self assert:
		self comparableNodeSetWithSameStringValue =
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableNodeSetWithSameStringValue =
			self comparableNodeSetWithSameStringValue.

	"if they don't have at least one string value in common, they aren't equal"
	self deny:
		self comparableNodeSetWithStringValues =
			self comparableNodeSetWithDisjointStringValues.
	self deny:
		self comparableNodeSetWithDisjointStringValues =
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableNodeSetWithSameStringValue =
			self comparableNodeSetWithDisjointStringValues.
	self deny:
		self comparableNodeSetWithDisjointStringValues =
			self comparableNodeSetWithSameStringValue.

	"no node set equals the empty node set, even itself"
	self deny:
		self comparableEmptyNodeSet =
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithStringValues =
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet =
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableNodeSetWithSameStringValue =
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet =
			self comparableNodeSetWithSameStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:55'!
testEqualToNumber
	self assert:
		self comparableNodeSetWithNumberValues =
			self comparableNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue =
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet =
			self comparableNumberValue.

	self deny:
		self comparableNodeSetWithNumberValues =
			self comparableDisjointNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue =
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet =
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToString
	"From the spec: 
			'If one object to be compared is a node-set and the other is a string,
		then the comparison will be true if and only if there is a node in the
		node-set such that the result of performing the comparison on the
		string-value of the node and the other string is true.'"
	self assert:
		self comparableNodeSetWithStringValues =
			self comparableStringValue.
	self assert:
		self comparableNodeSetWithSameStringValue =
			self comparableStringValue.
	self deny:
		self comparableNodeSetWithDisjointStringValues =
			self comparableStringValue.
	self deny:
		self comparableEmptyNodeSet =
			self comparableStringValue.
	self deny:
		self comparableEmptyNodeSet =
			self comparableEmptyStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:00'!
testGreaterThanBoolean
	self deny:
		self comparableNodeSetWithStringValues >
			self comparableTrueValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableTrueValue.
	self assert:
		self comparableNodeSetWithStringValues >
			self comparableFalseValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:17'!
testGreaterThanNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	self assert:
		self comparableNodeSetWithNumberValues >
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithNumberValues >
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableNodeSetWithSameNumberValue.

	"the disjoint values are all greater than"
	self deny:
		self comparableNodeSetWithNumberValues >
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableNodeSetWithDisjointNumberValues >
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableNodeSetWithDisjointNumberValues >
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableEmptyNodeSet >
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithNumberValues >
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet >
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet >
			self comparableNodeSetWithSameNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:57'!
testGreaterThanNumber
	self assert:
		self comparableNodeSetWithNumberValues >
			self comparableNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableNumberValue.

	self deny:
		self comparableNodeSetWithNumberValues >
			self comparableDisjointNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:00'!
testGreaterThanOrEqualToBoolean
	self assert:
		self comparableNodeSetWithStringValues >=
			self comparableTrueValue.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableTrueValue.
	self assert:
		self comparableNodeSetWithStringValues >=
			self comparableFalseValue.
	self assert:
		self comparableEmptyNodeSet >=
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:18'!
testGreaterThanOrEqualToNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	self assert:
		self comparableNodeSetWithNumberValues >=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithNumberValues >=
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue >=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithSameNumberValue >=
			self comparableNodeSetWithSameNumberValue.

	"the disjoint values are all greater than"
	self deny:
		self comparableNodeSetWithNumberValues >=
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableNodeSetWithDisjointNumberValues >=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue >=
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableNodeSetWithDisjointNumberValues >=
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableEmptyNodeSet >=
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithNumberValues >=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue >=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableNodeSetWithSameNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:57'!
testGreaterThanOrEqualToNumber
	self assert:
		self comparableNodeSetWithNumberValues >=
			self comparableNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue >=
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableNumberValue.

	self deny:
		self comparableNodeSetWithNumberValues >=
			self comparableDisjointNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >=
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:11'!
testGreaterThanOrEqualToString
	self assert:
		self comparableNodeSetWithNumberValues >=
			self comparableNumberStringValue.
	self assert:
		self comparableNodeSetWithSameNumberValue >=
			self comparableNumberStringValue.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableNumberStringValue.

	self deny:
		self comparableNodeSetWithNumberValues >=
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >=
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableEmptyNodeSet >=
			self comparableDisjointNumberStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:07'!
testGreaterThanString
	self assert:
		self comparableNodeSetWithNumberValues >
			self comparableNumberStringValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableNumberStringValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableNumberStringValue.

	self deny:
		self comparableNodeSetWithNumberValues >
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableNodeSetWithSameNumberValue >
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableEmptyNodeSet >
			self comparableDisjointNumberStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:00'!
testLessThanBoolean
	self deny:
		self comparableNodeSetWithStringValues <
			self comparableTrueValue.
	self assert:
		self comparableEmptyNodeSet <
			self comparableTrueValue.
	self deny:
		self comparableNodeSetWithStringValues <
			self comparableFalseValue.
	self deny:
		self comparableEmptyNodeSet <
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:18'!
testLessThanNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	self assert:
		self comparableNodeSetWithNumberValues <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithNumberValues <
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue <
			self comparableNodeSetWithSameNumberValue.

	"the disjoint values are all greater than"
	self assert:
		self comparableNodeSetWithNumberValues <
			self comparableNodeSetWithDisjointNumberValues.
	self deny:
		self comparableNodeSetWithDisjointNumberValues <
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithSameNumberValue <
			self comparableNodeSetWithDisjointNumberValues.
	self deny:
		self comparableNodeSetWithDisjointNumberValues <
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableEmptyNodeSet <
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithNumberValues <
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue <
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet <
			self comparableNodeSetWithSameNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:54'!
testLessThanNumber
	self deny:
		self comparableNodeSetWithNumberValues <
			self comparableNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue <
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet <
			self comparableNumberValue.

	self assert:
		self comparableNodeSetWithNumberValues <
			self comparableDisjointNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet <
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:00'!
testLessThanOrEqualToBoolean
	self assert:
		self comparableNodeSetWithStringValues <=
			self comparableTrueValue.
	self assert:
		self comparableEmptyNodeSet <=
			self comparableTrueValue.
	self deny:
		self comparableNodeSetWithStringValues <=
			self comparableFalseValue.
	self assert:
		self comparableEmptyNodeSet <=
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:19'!
testLessThanOrEqualToNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableNodeSetWithSameNumberValue.

	"the disjoint values are all greater than"
	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableNodeSetWithDisjointNumberValues.
	self deny:
		self comparableNodeSetWithDisjointNumberValues <=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableNodeSetWithDisjointNumberValues.
	self deny:
		self comparableNodeSetWithDisjointNumberValues <=
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableEmptyNodeSet <=
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithNumberValues <=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNodeSetWithSameNumberValue <=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableNodeSetWithSameNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:58'!
testLessThanOrEqualToNumber
	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableNumberValue.

	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableDisjointNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:10'!
testLessThanOrEqualToString
	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableNumberStringValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableNumberStringValue.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableNumberStringValue.

	self assert:
		self comparableNodeSetWithNumberValues <=
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <=
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableEmptyNodeSet <=
			self comparableDisjointNumberStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:09'!
testLessThanString
	self deny:
		self comparableNodeSetWithNumberValues <
			self comparableNumberStringValue.
	self deny:
		self comparableNodeSetWithSameNumberValue <
			self comparableNumberStringValue.
	self deny:
		self comparableEmptyNodeSet <
			self comparableNumberStringValue.

	self assert:
		self comparableNodeSetWithNumberValues <
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableNodeSetWithSameNumberValue <
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableEmptyNodeSet <
			self comparableDisjointNumberStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToBoolean
	self deny:
		self comparableNodeSetWithStringValues ~=
			self comparableTrueValue.
	self assert:
		self comparableEmptyNodeSet ~=
			self comparableTrueValue.
	self assert:
		self comparableNodeSetWithStringValues ~=
			self comparableFalseValue.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableFalseValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNodeSet
	"From the spec:
			'If both objects to be compared are node-sets, then the comparison will
		be true if and only if there is a node in the first node-set and a node in
		the second node-set such that the result of performing the comparison on
		the string-values of the two nodes is true'"

	"as long as two node sets have more than one string value, even if they have
	the same string values, they are not equal"
	self assert:
		self comparableNodeSetWithStringValues ~=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableNodeSetWithStringValues ~=
			self comparableNodeSetWithSameStringValue.
	self assert:
		self comparableNodeSetWithSameStringValue ~=
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableNodeSetWithSameStringValue ~=
			self comparableNodeSetWithSameStringValue.

	"if they are non empty and have no string values in common, they are
	not equal"
	self assert:
		self comparableNodeSetWithStringValues ~=
			self comparableNodeSetWithDisjointStringValues.
	self assert:
		self comparableNodeSetWithDisjointStringValues ~=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableNodeSetWithSameStringValue ~=
			self comparableNodeSetWithDisjointStringValues.
	self assert:
		self comparableNodeSetWithDisjointStringValues ~=
			self comparableNodeSetWithSameStringValue.

	"no node is not equal to the empty node set, even itself"
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableEmptyNodeSet.
	self deny:
		self comparableNodeSetWithStringValues ~=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableNodeSetWithSameStringValue ~=
			self comparableEmptyNodeSet.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableNodeSetWithSameStringValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:56'!
testNotEqualToNumber
	self assert:
		self comparableNodeSetWithNumberValues ~=
			self comparableNumberValue.
	self deny:
		self comparableNodeSetWithSameNumberValue ~=
			self comparableNumberValue.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableNumberValue.

	self assert:
		self comparableNodeSetWithNumberValues ~=
			self comparableDisjointNumberValue.
	self assert:
		self comparableNodeSetWithSameNumberValue ~=
			self comparableDisjointNumberValue.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableDisjointNumberValue.! !

!XPathNodeSetComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToString
	"From the spec: 
			'If one object to be compared is a node-set and the other is a string,
		then the comparison will be true if and only if there is a node in the
		node-set such that the result of performing the comparison on the
		string-value of the node and the other string is true.'"
	self assert:
		self comparableNodeSetWithStringValues ~=
			self comparableStringValue.
	self deny:
		self comparableNodeSetWithSameStringValue ~=
			self comparableStringValue.
	self assert:
		self comparableNodeSetWithDisjointStringValues ~=
			self comparableStringValue.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableStringValue.
	self deny:
		self comparableEmptyNodeSet ~=
			self comparableEmptyStringValue.! !

XPathComparableTest subclass: #XPathNumberComparableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNumberComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 16:16'!
isAbstract
	^ false! !

!XPathNumberComparableTest methodsFor: 'accessing' stamp: 'monty 2/11/2017 16:04'!
defaultComparable
	^ self comparableNumberValue! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self assert:
		self comparableNumberValue =
			self comparableTrueValue.
	self assert:
		self comparableInfinityValue =
			self comparableTrueValue.
	self assert:
		self comparableNegativeInfinityValue =
			self comparableTrueValue.
	self deny:
		self comparableZeroValue =
			self comparableTrueValue.
	self deny:
		self comparableNegativeZeroValue =
			self comparableTrueValue.
	self deny:
		self comparableNaNValue =
			self comparableTrueValue.

	self deny:
		self comparableNumberValue =
			self comparableFalseValue.
	self deny:
		self comparableInfinityValue =
			self comparableFalseValue.
	self deny:
		self comparableNegativeInfinityValue =
			self comparableFalseValue.
	self assert:
		self comparableZeroValue =
			self comparableFalseValue.
	self assert:
		self comparableNegativeZeroValue =
			self comparableFalseValue.
	self assert:
		self comparableNaNValue =
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNodeSet
	self assert:
		self comparableNumberValue =
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableDisjointNumberValue =
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNumberValue =
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableDisjointNumberValue =
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue =
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:00'!
testEqualToNumber
	self assert:
		self comparableNumberValue =
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberValue =
			self comparableNumberValue.
	self deny:
		self comparableNumberValue =
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToString
	self assert:
		self comparableNumberValue =
			self comparableNumberStringValue.
	self deny:
		self comparableDisjointNumberValue =
			self comparableNumberStringValue.
	self deny:
		self comparableNumberValue =
			self comparableEmptyStringValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:34'!
testGreaterThanBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self deny:
		self comparableNumberValue >
			self comparableTrueValue.
	self assert:
		self comparableInfinityValue >
			self comparableTrueValue.
	self deny:
		self comparableNegativeInfinityValue >
			self comparableTrueValue.
	self deny:
		self comparableZeroValue >
			self comparableTrueValue.
	self deny:
		self comparableNegativeZeroValue >
			self comparableTrueValue.

	self assert:
		self comparableNumberValue >
			self comparableFalseValue.
	self assert:
		self comparableInfinityValue >
			self comparableFalseValue.
	self deny:
		self comparableNegativeInfinityValue >
			self comparableFalseValue.
	self deny:
		self comparableZeroValue >
			self comparableFalseValue.
	self deny:
		self comparableNegativeZeroValue >
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/10/2017 22:49'!
testGreaterThanNodeSet
	self deny:
		self comparableNumberValue >
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableDisjointNumberValue >
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNumberValue >
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableDisjointNumberValue >
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue >
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:01'!
testGreaterThanNumber
	self deny:
		self comparableNumberValue >
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberValue >
			self comparableNumberValue.
	self deny:
		self comparableNumberValue >
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:35'!
testGreaterThanOrEqualToBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self assert:
		self comparableNumberValue >=
			self comparableTrueValue.
	self assert:
		self comparableInfinityValue >=
			self comparableTrueValue.
	self deny:
		self comparableNegativeInfinityValue >=
			self comparableTrueValue.
	self deny:
		self comparableZeroValue >=
			self comparableTrueValue.
	self deny:
		self comparableNegativeZeroValue >=
			self comparableTrueValue.

	self assert:
		self comparableNumberValue >=
			self comparableFalseValue.
	self assert:
		self comparableInfinityValue >=
			self comparableFalseValue.
	self deny:
		self comparableNegativeInfinityValue >=
			self comparableFalseValue.
	self assert:
		self comparableZeroValue >=
			self comparableFalseValue.
	self assert:
		self comparableNegativeZeroValue >=
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/10/2017 22:49'!
testGreaterThanOrEqualToNodeSet
	self assert:
		self comparableNumberValue >=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableDisjointNumberValue >=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNumberValue >=
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableDisjointNumberValue >=
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue >=
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:01'!
testGreaterThanOrEqualToNumber
	self assert:
		self comparableNumberValue >=
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberValue >=
			self comparableNumberValue.
	self deny:
		self comparableNumberValue >=
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:16'!
testGreaterThanOrEqualToString
	self assert:
		self comparableNumberValue >=
			self comparableNumberStringValue.
	self assert:
		self comparableDisjointNumberValue >=
			self comparableNumberStringValue.
	self deny:
		self comparableNumberValue >=
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableDisjointNumberValue >=
			self comparableDisjointNumberStringValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:16'!
testGreaterThanString
	self deny:
		self comparableNumberValue >
			self comparableNumberStringValue.
	self assert:
		self comparableDisjointNumberValue >
			self comparableNumberStringValue.
	self deny:
		self comparableNumberValue >
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableDisjointNumberValue >
			self comparableDisjointNumberStringValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:32'!
testLessThanBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self deny:
		self comparableNumberValue <
			self comparableTrueValue.
	self deny:
		self comparableInfinityValue <
			self comparableTrueValue.
	self assert:
		self comparableNegativeInfinityValue <
			self comparableTrueValue.
	self assert:
		self comparableZeroValue <
			self comparableTrueValue.
	self assert:
		self comparableNegativeZeroValue <
			self comparableTrueValue.

	self deny:
		self comparableNumberValue <
			self comparableFalseValue.
	self deny:
		self comparableInfinityValue <
			self comparableFalseValue.
	self assert:
		self comparableNegativeInfinityValue <
			self comparableFalseValue.
	self deny:
		self comparableZeroValue <
			self comparableFalseValue.
	self deny:
		self comparableNegativeZeroValue <
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/10/2017 22:49'!
testLessThanNodeSet
	self assert:
		self comparableNumberValue <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableDisjointNumberValue <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNumberValue <
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableDisjointNumberValue <
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue <
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:00'!
testLessThanNumber
	self deny:
		self comparableNumberValue <
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberValue <
			self comparableNumberValue.
	self assert:
		self comparableNumberValue <
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:40'!
testLessThanOrEqualToBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self assert:
		self comparableNumberValue <=
			self comparableTrueValue.
	self deny:
		self comparableInfinityValue <=
			self comparableTrueValue.
	self assert:
		self comparableNegativeInfinityValue <=
			self comparableTrueValue.
	self assert:
		self comparableZeroValue <=
			self comparableTrueValue.
	self assert:
		self comparableNegativeZeroValue <=
			self comparableTrueValue.

	self deny:
		self comparableNumberValue <=
			self comparableFalseValue.
	self deny:
		self comparableInfinityValue <=
			self comparableFalseValue.
	self assert:
		self comparableNegativeInfinityValue <=
			self comparableFalseValue.
	self assert:
		self comparableZeroValue <=
			self comparableFalseValue.
	self assert:
		self comparableNegativeZeroValue <=
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/10/2017 22:49'!
testLessThanOrEqualToNodeSet
	self assert:
		self comparableNumberValue <=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableDisjointNumberValue <=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableNumberValue <=
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableDisjointNumberValue <=
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue <=
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:01'!
testLessThanOrEqualToNumber
	self assert:
		self comparableNumberValue <=
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberValue <=
			self comparableNumberValue.
	self assert:
		self comparableNumberValue <=
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:17'!
testLessThanOrEqualToString
	self assert:
		self comparableNumberValue <=
			self comparableNumberStringValue.
	self deny:
		self comparableDisjointNumberValue <=
			self comparableNumberStringValue.
	self assert:
		self comparableNumberValue <=
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableDisjointNumberValue <=
			self comparableDisjointNumberStringValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:15'!
testLessThanString
	self deny:
		self comparableNumberValue <
			self comparableNumberStringValue.
	self deny:
		self comparableDisjointNumberValue <
			self comparableNumberStringValue.
	self assert:
		self comparableNumberValue <
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableDisjointNumberValue <
			self comparableDisjointNumberStringValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToBoolean
	"from the spec:
			'a number is true if and only if it is neither positive or negative
		zero nor NaN'"
	self deny:
		self comparableNumberValue ~=
			self comparableTrueValue.
	self deny:
		self comparableInfinityValue ~=
			self comparableTrueValue.
	self deny:
		self comparableNegativeInfinityValue ~=
			self comparableTrueValue.
	self assert:
		self comparableZeroValue ~=
			self comparableTrueValue.
	self assert:
		self comparableNegativeZeroValue ~=
			self comparableTrueValue.
	self assert:
		self comparableNaNValue ~=
			self comparableTrueValue.

	self assert:
		self comparableNumberValue ~=
			self comparableFalseValue.
	self assert:
		self comparableInfinityValue ~=
			self comparableFalseValue.
	self assert:
		self comparableNegativeInfinityValue ~=
			self comparableFalseValue.
	self deny:
		self comparableZeroValue ~=
			self comparableFalseValue.
	self deny:
		self comparableNegativeZeroValue ~=
			self comparableFalseValue.
	self deny:
		self comparableNaNValue ~=
			self comparableFalseValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNodeSet
	self assert:
		self comparableNumberValue ~=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableDisjointNumberValue ~=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableNumberValue ~=
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableDisjointNumberValue ~=
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableNumberValue ~=
			self comparableEmptyNodeSet.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:00'!
testNotEqualToNumber
	self deny:
		self comparableNumberValue ~=
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberValue ~=
			self comparableNumberValue.
	self assert:
		self comparableNumberValue ~=
			self comparableDisjointNumberValue.! !

!XPathNumberComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToString
	self deny:
		self comparableNumberValue ~=
			self comparableNumberStringValue.
	self assert:
		self comparableDisjointNumberValue ~=
			self comparableNumberStringValue.
	self assert:
		self comparableNumberValue ~=
			self comparableEmptyStringValue.! !

XPathComparableTest subclass: #XPathStringComparableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathStringComparableTest class methodsFor: 'testing' stamp: 'monty 2/7/2017 16:05'!
isAbstract
	^ false! !

!XPathStringComparableTest methodsFor: 'accessing' stamp: 'monty 2/11/2017 16:04'!
defaultComparable
	^ self comparableStringValue! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToBoolean
	"From the spec:
		'If at least one object to be compared is a boolean, then each object
	to be compared is converted to a boolean as if by applying the boolean
	function'"
	self assert:
		self comparableStringValue =
			self comparableTrueValue.
	self deny:
		self comparableStringValue =
			self comparableFalseValue.
	self deny:
		self comparableEmptyStringValue =
			self comparableTrueValue.
	self assert:
		self comparableEmptyStringValue =
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNodeSet
	self assert:
		self comparableStringValue =
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableDisjointStringValue =
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableStringValue =
			self comparableNodeSetWithSameStringValue.
	self deny:
		self comparableDisjointStringValue =
			self comparableNodeSetWithSameStringValue.
	self deny:
		self comparableStringValue =
			self comparableEmptyNodeSet.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToNumber
	self assert:
		self comparableNumberStringValue =
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberStringValue =
			self comparableNumberValue.
	self deny:
		self comparableEmptyStringValue =
			self comparableNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:29'!
testEqualToString
	self assert:
		self comparableStringValue =
			self comparableStringValue.
	self deny:
		self comparableStringValue =
			self comparableDisjointStringValue.
	self deny:
		self comparableDisjointStringValue =
			self comparableStringValue.
	self deny:
		self comparableStringValue =
			self comparableEmptyStringValue.
	self deny:
		self comparableEmptyStringValue =
			self comparableStringValue.
	self assert:
		self comparableEmptyStringValue =
			self comparableEmptyStringValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:46'!
testGreaterThanBoolean
	self deny:
		self comparableNumberStringValue >
			self comparableTrueValue.
	self deny:
		self comparableZeroStringValue >
			self comparableTrueValue.
	self assert:
		self comparableNumberStringValue >
			self comparableFalseValue.
	self deny:
		self comparableZeroStringValue >
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 22:24'!
testGreaterThanNodeSet
	self deny:
		self comparableNumberStringValue >
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableDisjointNumberStringValue >
			self comparableNodeSetWithNumberValues.

	self deny:
		self comparableNumberStringValue >
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableDisjointNumberStringValue >
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableNumberStringValue >
			self comparableNodeSetWithDisjointNumberValues.
	self deny:
		self comparableDisjointNumberStringValue >
			self comparableNodeSetWithDisjointNumberValues.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:34'!
testGreaterThanNumber
	self deny:
		self comparableNumberStringValue >
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberStringValue >
			self comparableNumberValue.
	self deny:
		self comparableNumberStringValue >
			self comparableDisjointNumberValue.
	self deny:
		self comparableDisjointNumberStringValue >
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:47'!
testGreaterThanOrEqualToBoolean
	self assert:
		self comparableNumberStringValue >=
			self comparableTrueValue.
	self deny:
		self comparableZeroStringValue >=
			self comparableTrueValue.
	self assert:
		self comparableNumberStringValue >=
			self comparableFalseValue.
	self assert:
		self comparableZeroStringValue >=
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 22:25'!
testGreaterThanOrEqualToNodeSet
	self assert:
		self comparableNumberStringValue >=
			self comparableNodeSetWithNumberValues.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableNodeSetWithNumberValues.

	self assert:
		self comparableNumberStringValue >=
			self comparableNodeSetWithSameNumberValue.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableNodeSetWithSameNumberValue.

	self deny:
		self comparableNumberStringValue >=
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableNodeSetWithDisjointNumberValues.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:34'!
testGreaterThanOrEqualToNumber
	self assert:
		self comparableNumberStringValue >=
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableNumberValue.
	self deny:
		self comparableNumberStringValue >=
			self comparableDisjointNumberValue.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:25'!
testGreaterThanOrEqualToString
	self assert:
		self comparableNumberStringValue >=
			self comparableNumberStringValue.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableNumberStringValue.
	self deny:
		self comparableNumberStringValue >=
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableDisjointNumberStringValue >=
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:24'!
testGreaterThanString
	self deny:
		self comparableNumberStringValue >
			self comparableNumberStringValue.
	self assert:
		self comparableDisjointNumberStringValue >
			self comparableNumberStringValue.
	self deny:
		self comparableNumberStringValue >
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableDisjointNumberStringValue >
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 19:46'!
testLessThanBoolean
	self deny:
		self comparableNumberStringValue <
			self comparableTrueValue.
	self assert:
		self comparableZeroStringValue <
			self comparableTrueValue.
	self deny:
		self comparableNumberStringValue <
			self comparableFalseValue.
	self deny:
		self comparableZeroStringValue <
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 22:24'!
testLessThanNodeSet
	self assert:
		self comparableNumberStringValue <
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableNodeSetWithNumberValues.

	self deny:
		self comparableNumberStringValue <
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableNodeSetWithSameNumberValue.

	self assert:
		self comparableNumberStringValue <
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableDisjointNumberStringValue <
			self comparableNodeSetWithDisjointNumberValues.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:32'!
testLessThanNumber
	self deny:
		self comparableNumberStringValue <
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableNumberValue.
	self assert:
		self comparableNumberStringValue <
			self comparableDisjointNumberValue.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/7/2017 20:14'!
testLessThanOrEqualToBoolean
	self assert:
		self comparableNumberStringValue <=
			self comparableTrueValue.
	self assert:
		self comparableZeroStringValue <=
			self comparableTrueValue.
	self deny:
		self comparableNumberStringValue <=
			self comparableFalseValue.
	self assert:
		self comparableZeroStringValue <=
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 22:23'!
testLessThanOrEqualToNodeSet
	self assert:
		self comparableNumberStringValue <=
			self comparableNodeSetWithNumberValues.
	self deny:
		self comparableDisjointNumberStringValue <=
			self comparableNodeSetWithNumberValues.

	self assert:
		self comparableNumberStringValue <=
			self comparableNodeSetWithSameNumberValue.
	self deny:
		self comparableDisjointNumberStringValue <=
			self comparableNodeSetWithSameNumberValue.

	self assert:
		self comparableNumberStringValue <=
			self comparableNodeSetWithDisjointNumberValues.
	self assert:
		self comparableDisjointNumberStringValue <=
			self comparableNodeSetWithDisjointNumberValues.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 16:33'!
testLessThanOrEqualToNumber
	self assert:
		self comparableNumberStringValue <=
			self comparableNumberValue.
	self deny:
		self comparableDisjointNumberStringValue <=
			self comparableNumberValue.
	self assert:
		self comparableNumberStringValue <=
			self comparableDisjointNumberValue.
	self assert:
		self comparableDisjointNumberStringValue <=
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:25'!
testLessThanOrEqualToString
	self assert:
		self comparableNumberStringValue <=
			self comparableNumberStringValue.
	self deny:
		self comparableDisjointNumberStringValue <=
			self comparableNumberStringValue.
	self assert:
		self comparableNumberStringValue <=
			self comparableDisjointNumberStringValue.
	self assert:
		self comparableDisjointNumberStringValue <=
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/9/2017 00:25'!
testLessThanString
	self deny:
		self comparableNumberStringValue <
			self comparableNumberStringValue.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableNumberStringValue.
	self assert:
		self comparableNumberStringValue <
			self comparableDisjointNumberStringValue.
	self deny:
		self comparableDisjointNumberStringValue <
			self comparableDisjointNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToBoolean
	"From the spec:
		'If at least one object to be compared is a boolean, then each object
	to be compared is converted to a boolean as if by applying the boolean
	function'"
	self deny:
		self comparableStringValue ~=
			self comparableTrueValue.
	self assert:
		self comparableStringValue ~=
			self comparableFalseValue.
	self assert:
		self comparableEmptyStringValue ~=
			self comparableTrueValue.
	self deny:
		self comparableEmptyStringValue ~=
			self comparableFalseValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNodeSet
	self assert:
		self comparableStringValue ~=
			self comparableNodeSetWithStringValues.
	self assert:
		self comparableDisjointStringValue ~=
			self comparableNodeSetWithStringValues.
	self deny:
		self comparableStringValue ~=
			self comparableNodeSetWithSameStringValue.
	self assert:
		self comparableDisjointStringValue ~=
			self comparableNodeSetWithSameStringValue.
	self deny:
		self comparableStringValue ~=
			self comparableEmptyNodeSet.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToNumber
	self deny:
		self comparableNumberStringValue ~=
			self comparableNumberValue.
	self assert:
		self comparableDisjointNumberStringValue ~=
			self comparableNumberValue.
	self assert:
		self comparableEmptyStringValue ~=
			self comparableNumberValue.! !

!XPathStringComparableTest methodsFor: 'tests' stamp: 'monty 2/8/2017 15:30'!
testNotEqualToString
	self deny:
		self comparableStringValue ~=
			self comparableStringValue.
	self assert:
		self comparableStringValue ~=
			self comparableDisjointStringValue.
	self assert:
		self comparableDisjointStringValue ~=
			self comparableStringValue.
	self assert:
		self comparableStringValue ~=
			self comparableEmptyStringValue.
	self assert:
		self comparableEmptyStringValue ~=
			self comparableStringValue.
	self deny:
		self comparableEmptyStringValue ~=
			self comparableEmptyStringValue.! !

TestCase subclass: #XPathContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:10'!
contextClass
	^ XPathContext! !

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:07'!
functionSetClass
	^ XPathFunctionSet! !

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:10'!
functions
	^ self contextClass defaultFunctions! !

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 3/6/2016 15:28'!
namespaces
	^ Dictionary new
		at: 'prefix1' put: 'ns1';
		at: 'prefix2' put: 'ns2';
		yourself! !

!XPathContextTest methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:10'!
newContext
	^ self contextClass new! !

!XPathContextTest methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:08'!
newFunctionSet
	^ self functionSetClass new! !

!XPathContextTest methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:09'!
newNodeSet
	^ self nodeSetClass new! !

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:07'!
nodeSetClass
	^ XPathNodeSet! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:08'!
testAddFunction
	| context |

	context := self newContext.
	context functions: self newFunctionSet.
	self functions do: [:each | | oldFunctionSet |
		"test copy-on-write"
		oldFunctionSet := context functions.
		self
			deny: (context includesFunction: each);
			assert: (context addFunction: each) == each;
			assert: (context includesFunction: each);
			deny: context functions == oldFunctionSet;
			deny: context functions = oldFunctionSet].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 17:53'!
testDeclarePrefixURI
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self assert:
			(context
				declarePrefix: key
				uri: value) == context.
		self assert: (context resolvePrefix: key) = value.
		self assert:
			(context
				declarePrefix: key
				uri: 'newValue') == context.
		self assert: (context resolvePrefix: key) = 'newValue'].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 1/9/2017 09:47'!
testFunctionNamed
	| context |

	context := self newContext.
	self functions do: [:each |
		self assert: (context functionNamed: each prototypeName) == each.
		context removeFunction: each.
		self assert: (context functionNamed: each prototypeName) isNil].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 1/9/2017 09:47'!
testFunctionNamedIfAbsent
	| context |

	context := self newContext.
	self functions do: [:each |
		self assert:
			(context
				functionNamed: each prototypeName
				ifAbsent: [#absent]) == each.
		context removeFunction: each.
		self assert:
			(context
				functionNamed: each prototypeName
				ifAbsent: [#absent]) = #absent].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:08'!
testFunctions
	| context functions |

	context := self newContext.
	functions := self functions.
	self
		assert: context functions = functions;
		assert: context functions == functions.

	functions := self functionSetClass default.
	self
		assert: (context functions: functions) == context;
		assert: context functions = functions;
		assert: context functions == functions.

	self
		assert: (context functions: functions asArray) == context;
		assert: context functions = functions;
		deny: context functions == functions.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:08'!
testHasFunctions
	| context |

	context := self newContext.
	self assert: context hasFunctions.

	context functions: self newFunctionSet.
	self deny: context hasFunctions.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 15:26'!
testHasNamespaces
	| context |

	context := self newContext.
	self deny: context hasNamespaces.

	context declareNamespaces: self namespaces.
	self assert: context hasNamespaces.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 11:29'!
testHasVariables
	| context |

	context := self newContext.
	self deny: context hasVariables.

	context variables: self variables.
	self assert: context hasVariables.

	context removeVariables.
	self deny: context hasVariables.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 14:21'!
testIncludesFunction
	| context |

	context := self newContext.
	self functions do: [:each |
		self assert: (context includesFunction: each).
		context removeFunction: each.
		self deny: (context includesFunction: each)].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 13:32'!
testIncludesVariable
	| context |

	context := self newContext.
	self variables keysAndValuesDo: [:key :value |
		self deny: (context includesVariable: key).
		context
			variableAt: key
			put: value.
		self assert: (context includesVariable: key)].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 15:29'!
testIsDeclaredPrefix
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self deny: (context isDeclaredPrefix: key).
		context
			declarePrefix: key
			uri: value.
		self assert: (context isDeclaredPrefix: key)].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 15:30'!
testIsDeclaredPrefixURI
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self deny:
			(context
				isDeclaredPrefix: key
				uri: value).
		context
			declarePrefix: key
			uri: value.
		self assert:
			(context
				isDeclaredPrefix: key
				uri: value).
		self deny:
			(context
				isDeclaredPrefix: key
				uri: 'newNS')].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 14:20'!
testRemoveFunction
	| context |

	context := self newContext.
	self functions do: [:each | | oldFunctionSet |
		"test copy-on-write"
		oldFunctionSet := context functions.
		self
			assert: (context includesFunction: each);
			assert: (context removeFunction: each) == each;
			deny: (context includesFunction: each);
			deny: context functions == oldFunctionSet;
			deny: context functions = oldFunctionSet.
	
		self
			should: [context removeFunction: each]
			raise: Error].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 14:28'!
testRemoveFunctionIfAbsent
	| context |

	context := self newContext.
	self functions do: [:each | | oldFunctionSet |
		"test copy-on-write"
		oldFunctionSet := context functions.
		self
			assert: (context includesFunction: each);
			assert:
				(context
					removeFunction: each
					ifAbsent: [#absent]) == each;
			deny: (context includesFunction: each);
			deny: context functions == oldFunctionSet;
			deny: context functions = oldFunctionSet.

		self
			assert:
				(context
					removeFunction: each
					ifAbsent: [#absent]) == #absent].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 14:22'!
testRemoveFunctions
	| context |

	context := self newContext.
	self
		assert: context removeFunctions == context;
		deny: context hasFunctions.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 13:28'!
testRemoveVariable
	| context |

	context := self newContext.
	context variables: self variables.
	self variables keysAndValuesDo: [:key :value |
		self assert: (context removeVariable: key) = value.
		self
			should: [context removeVariable: key]
			raise: Error].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 13:29'!
testRemoveVariableIfAbsent
	| context |

	context := self newContext.
	context variables: self variables.
	self variables keysAndValuesDo: [:key :value |
		self assert:
			(context
				removeVariable: key
				ifAbsent: [#absent]) = value.
		self assert:
			(context
				removeVariable: key
				ifAbsent: [#absent]) = #absent].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 13:31'!
testRemoveVariables
	| context |

	context := self newContext.
	context variables: self variables.
	self
		assert: context removeVariables == context;
		deny: context hasVariables.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 18:08'!
testResolvePrefix
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self assert: (context resolvePrefix: key) = ''.
		context
			declarePrefix: key
			uri: value.
		self assert: (context resolvePrefix: key) = value].

	self assert:
		(context resolvePrefix: 'xml') = XMLNamespaceScope xmlNamespaceURI.
	
	self assert:
		(context resolvePrefix: 'xmlns') = XMLNamespaceScope xmlnsNamespaceURI.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 2/26/2017 11:42'!
testResolvePrefixIfUnresolvable
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self assert:
			(context
				resolvePrefix: key
				ifUnresolvable: [#unresolvable]) = #unresolvable.
		context
			declarePrefix: key
			uri: value.
		self assert:
			(context
				resolvePrefix: key
				ifUnresolvable: [self fail]) = value].

	self assert:
		(context
			resolvePrefix: 'xml'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlNamespaceURI.
	
	self assert:
		(context
			resolvePrefix: 'xmlns'
			ifUnresolvable: [self fail]) = XMLNamespaceScope xmlnsNamespaceURI.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 18:06'!
testResolvePrefixesOfNamespaceURI
	| context |

	context := self newContext.
	self namespaces keysAndValuesDo: [:key :value |
		self assert:
			(context resolvePrefixesOfNamespaceURI: value) isEmpty.

		context
			declarePrefix: key
			uri: value.
		self assert:
			(context resolvePrefixesOfNamespaceURI: value) =
				(Set with: key).

		context
			declarePrefix: 'newPrefix'
			uri: value.
		self assert:
			(context resolvePrefixesOfNamespaceURI: value) =
				(Set with: key with: 'newPrefix')].

	self assert:
		(context resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlNamespaceURI) =
				(Set with: 'xml').

	self assert:
		(context resolvePrefixesOfNamespaceURI:
			XMLNamespaceScope xmlnsNamespaceURI) =
				(Set with: 'xmlns').! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 21:18'!
testUndeclarePrefix
	| context |

	context := self newContext.
	context declareNamespaces: self namespaces.
	self namespaces keysDo: [:each |
		self
			assert: (context isDeclaredPrefix: each);
			assert: (context undeclarePrefix: each) == context;
			deny: (context isDeclaredPrefix: each)].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 18:00'!
testUndeclarePrefixes
	| context |

	context := self newContext.
	context declareNamespaces: self namespaces.
	self
		assert: context hasNamespaces;
		assert: context undeclarePrefixes == context;
		deny: context hasNamespaces.! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 11:23'!
testVariableAt
	| context |

	context := self newContext.
	self variables keysAndValuesDo: [:key :value |
		self assert: (context variableAt: key) isNil.
		context
			variableAt: key
			put: value.
		self assert: (context variableAt: key) = value].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 11:26'!
testVariableAtIfAbsent
	| context |

	context := self newContext.
	self variables keysAndValuesDo: [:key :value |
		self assert:
			(context
				variableAt: key
				ifAbsent: [#absent]) = #absent.
		context
			variableAt: key
			put: value.
		self assert:
			(context
				variableAt: key
				ifAbsent: [#absent]) = value].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 11:27'!
testVariableAtIfAbsentPut
	| context |

	context := self newContext.
	self variables keysAndValuesDo: [:key :value |
		self assert:
			(context
				variableAt: key
				ifAbsentPut: [value]) = value.
		self assert: (context variableAt: key) = value.
		self assert:
			(context
				variableAt: key
				ifAbsentPut: [#new]) = value.
		self assert: (context variableAt: key) = value].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 11:25'!
testVariableAtPut
	| context |

	context := self newContext.
	self variables keysAndValuesDo: [:key :value |
		self assert:
			(context
				variableAt: key
				put: value) = value.
		self assert: (context variableAt: key) = value].! !

!XPathContextTest methodsFor: 'tests' stamp: 'monty 3/6/2016 14:32'!
testVariables
	| context variables |

	context := self newContext.
	self
		assert: context variables isDictionary;
		assert: context variables isEmpty.

	variables := self variables.
	self
		assert: (context variables: variables) == context;
		assert: context variables = variables;
		deny: context variables == variables.

	variables := Array with: 'newName' -> 'newValue'.
	self
		assert: (context variables: variables) == context;
		assert: context variables associations asArray = variables.! !

!XPathContextTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:09'!
variables
	^ Dictionary new
		at: 'one' put: '1';
		at: 'two' put: 2;
		at: 'three' put: self newNodeSet;
		yourself! !

TestCase subclass: #XPathNodeTestWithPredicatesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNodeTestWithPredicatesTest methodsFor: 'asserting' stamp: 'monty 2/14/2017 00:43'!
assertNodeTestWithPredicates: aNodeTestWithPredicates hasPredicates: aPredicateOrPredicateCollection
	self assert:
		aNodeTestWithPredicates predicates asArray =
			(aPredicateOrPredicateCollection isCollection
				ifTrue: [aPredicateOrPredicateCollection asArray]
				ifFalse: [Array with: aPredicateOrPredicateCollection])! !

!XPathNodeTestWithPredicatesTest methodsFor: 'accessing' stamp: 'monty 2/13/2017 23:31'!
classTested
	^ XPathNodeTestWithPredicates! !

!XPathNodeTestWithPredicatesTest methodsFor: 'instance creation' stamp: 'monty 2/13/2017 23:29'!
newNodeTestWithPredicates
	^ self newNodeTestWithPredicates: self predicates! !

!XPathNodeTestWithPredicatesTest methodsFor: 'instance creation' stamp: 'monty 2/13/2017 23:31'!
newNodeTestWithPredicates: aPredicateOrPredicateCollection
	^ self classTested
		nodeTest: self nodeTest
		predicates: aPredicateOrPredicateCollection! !

!XPathNodeTestWithPredicatesTest methodsFor: 'instance creation' stamp: 'monty 2/13/2017 23:55'!
newNodeTestWithSinglePredicate
	^ self newNodeTestWithPredicates: self singlePredicate! !

!XPathNodeTestWithPredicatesTest methodsFor: 'accessing' stamp: 'monty 2/13/2017 23:31'!
nodeTest
	^ 'test'! !

!XPathNodeTestWithPredicatesTest methodsFor: 'accessing' stamp: 'monty 2/14/2017 00:48'!
predicates
	"using block predicates here would make 'self predicates ~= self predicates'
	because '[1] ~= [1]'"
	^ Array
		with: 1
		with: 2
		with: 3
		with: 4! !

!XPathNodeTestWithPredicatesTest methodsFor: 'accessing' stamp: 'monty 2/13/2017 23:55'!
singlePredicate
	^ self predicates first! !

!XPathNodeTestWithPredicatesTest methodsFor: 'tests' stamp: 'monty 2/14/2017 01:26'!
testChainingPredicate
	| newNodeTestWithPredicates |

	newNodeTestWithPredicates := self newNodeTestWithSinglePredicate.
	self
		assert: newNodeTestWithPredicates class == self classTested;
		assert: newNodeTestWithPredicates nodeTest = self nodeTest.
	self
		assertNodeTestWithPredicates: newNodeTestWithPredicates
		hasPredicates: self singlePredicate.

	2 to: self predicates size do: [:i | | oldNodeTestWithPredicates |
		oldNodeTestWithPredicates := newNodeTestWithPredicates.
		newNodeTestWithPredicates :=
			oldNodeTestWithPredicates ?? (self predicates at: i).
		self
			assert: newNodeTestWithPredicates class == self classTested;
			assert: newNodeTestWithPredicates nodeTest = self nodeTest.
		self
			assertNodeTestWithPredicates: newNodeTestWithPredicates
			hasPredicates: (self predicates copyFrom: 1 to: i).

		self
			deny: oldNodeTestWithPredicates == newNodeTestWithPredicates;
			assert: oldNodeTestWithPredicates nodeTest = self nodeTest.
		self
			assertNodeTestWithPredicates: oldNodeTestWithPredicates
			hasPredicates: (self predicates copyFrom: 1 to: i - 1)].! !

!XPathNodeTestWithPredicatesTest methodsFor: 'tests' stamp: 'monty 2/14/2017 01:25'!
testChainingPredicates
	| newNodeTestWithPredicates oldNodeTestWithPredicates |

	newNodeTestWithPredicates := self newNodeTestWithPredicates.
	self
		assert: newNodeTestWithPredicates class == self classTested;
		assert: newNodeTestWithPredicates nodeTest = self nodeTest.
	self
		assertNodeTestWithPredicates: newNodeTestWithPredicates
		hasPredicates: self predicates.

	oldNodeTestWithPredicates := newNodeTestWithPredicates.
	newNodeTestWithPredicates :=
		oldNodeTestWithPredicates ?? self predicates.
	self
		assert: newNodeTestWithPredicates class == self classTested;
		assert: newNodeTestWithPredicates nodeTest = self nodeTest.
	self
		assertNodeTestWithPredicates: newNodeTestWithPredicates
		hasPredicates: self predicates, self predicates.

	self
		deny: oldNodeTestWithPredicates == newNodeTestWithPredicates;
		assert: oldNodeTestWithPredicates nodeTest = self nodeTest.
	self
		assertNodeTestWithPredicates: oldNodeTestWithPredicates
		hasPredicates: self predicates.! !

TestCase subclass: #XPathNumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testAsXPathBoolean
	self
		assert: 1 asXPathBoolean;
		assert: -1 asXPathBoolean;
		assert: Float infinity asXPathBoolean;
		assert: Float xpathNegativeInfinity asXPathBoolean;
		deny: 0.0 asXPathBoolean;
		deny: Float xpathNegativeZero asXPathBoolean;
		deny: Float nan asXPathBoolean! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 2/11/2017 16:01'!
testAsXPathComparable
	| comparable |

	comparable := 1 asXPathComparable.
	self
		assert: comparable class == XPathNumberComparable;
		assert: comparable value = 1.! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:47'!
testAsXPathNodeSet
	self
		should: [1.0 asXPathNodeSet]
		raise: XPathTypeException! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testAsXPathNodeSetPosition
	-10 to: 10 do: [:i | | position |
		position := i asXPathNodeSetPosition.
		self
			assert: position = i;
			assert: position isInteger.

		position := i asFloat asXPathNodeSetPosition.
		self
			assert: position = i;
			assert: position isInteger].

	"Pharo/Squeak (but not GS) OrderedCollections, which XPathNodeSets
	use internally, round float indexes down to the nearest integer, which is
	not OK because the spec doesn't require it (and LibXML2 doesn't do it), so
	fractional, NaN, and infinite positions all have to be converted to an
	always out-of-bounds index"
	-10.5 to: 10.5 do: [:i | | position |
		position := i asXPathNodeSetPosition.
		self
			assert: position isZero;
			assert: position isInteger].
	(Array
		with: Float nan
		with: Float infinity
		with: Float xpathNegativeInfinity
		with: Float xpathNegativeZero)
		do: [:each | | position |
			position := each asXPathNodeSetPosition.
			self
				assert: position isZero;
				assert: position isInteger].! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 1/27/2017 11:18'!
testAsXPathNumber
	| number |

	number := 1.0.
	self assert: number asXPathNumber == number.

	"should convert to float"
	number := 1.
	self
		assert: number asXPathNumber = number;
		assert: number asXPathNumber isFloat.! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testAsXPathString
	self
		assert: 1 asXPathString = '1';
		assert: 1.0 asXPathString = '1';
		assert: Float infinity asXPathString = 'Infinity';
		assert: Float xpathNegativeInfinity asXPathString = '-Infinity';
		assert: Float nan asXPathString = 'NaN';
		assert: 0.0 asXPathString = '0';
		assert: Float xpathNegativeZero asXPathString = '0'! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testIsXPathNegativeZero
	self
		deny: 0 isXPathNegativeZero;
		deny: 0.0 isXPathNegativeZero;
		assert: Float xpathNegativeZero isXPathNegativeZero! !

!XPathNumberTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testIsXPathPositiveZero
	self
		assert: 0 isXPathPositiveZero;
		assert: 0.0 isXPathPositiveZero;
		deny: Float xpathNegativeZero isXPathPositiveZero! !

TestCase subclass: #XPathReadStreamAdapterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/26/2016 01:31'!
badQualifiedName
	^ 'prefix: localName'! !

!XPathReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/25/2016 20:49'!
ncName
	^ 'localName'! !

!XPathReadStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/25/2016 20:53'!
newStreamAdapterOn: aStream
	^ self streamAdapterClass on: aStream! !

!XPathReadStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/25/2016 21:11'!
newStreamAdapterOnBadQualifiedName
	^ self streamAdapterClass on: self badQualifiedName readStream! !

!XPathReadStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/25/2016 20:53'!
newStreamAdapterOnNCName
	^ self streamAdapterClass on: self ncName readStream! !

!XPathReadStreamAdapterTest methodsFor: 'instance creation' stamp: 'monty 3/25/2016 20:53'!
newStreamAdapterOnQualifiedName
	^ self streamAdapterClass on: self qualifiedName readStream! !

!XPathReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/25/2016 20:51'!
prefix
	^ 'prefix'! !

!XPathReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/25/2016 18:24'!
qualifiedName
	^ 'prefix:localName'! !

!XPathReadStreamAdapterTest methodsFor: 'accessing' stamp: 'monty 3/26/2016 01:31'!
streamAdapterClass
	^ XPathReadStreamAdapter! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:16'!
testNext
	| adapter |

	adapter := self newStreamAdapterOnQualifiedName.
	self qualifiedName do: [:each |
		self assert: adapter next == each].
	self assert: adapter next isNil.! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:14'!
testNextNCName
	| adapter |

	adapter := self newStreamAdapterOnNCName.
	self
		assert: adapter nextNCName = self ncName;
		assert: adapter nextNCName isNil;
		assert: adapter atEnd.

	adapter := self newStreamAdapterOnQualifiedName.
	self
		assert: adapter nextNCName = self prefix;
		assert: adapter nextNCName isNil;
		assert: adapter next == $:.

	adapter := self newStreamAdapterOnBadQualifiedName.
	self
		assert: adapter nextNCName = self prefix;
		assert: adapter nextNCName isNil;
		assert: adapter next == $:.! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:13'!
testNextName
	| adapter namePosition |

	adapter := self newStreamAdapterOnNCName.
	self
		assert: adapter nextName = self ncName;
		assert: adapter nextName isNil;
		assert: adapter atEnd.

	adapter := self newStreamAdapterOnQualifiedName.
	self
		assert: adapter nextName = self qualifiedName;
		assert: adapter nextName isNil;
		assert: adapter atEnd.

	adapter := self newStreamAdapterOnBadQualifiedName.
	namePosition := adapter position.
	self
		assert: adapter nextName isNil;
		assert: adapter position = namePosition.! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:53'!
testNextPushedBackToken
	| adapter ncNamePosition ncName |

	adapter := self newStreamAdapterOnNCName.
	self assert: adapter nextPushedBackToken isNil.

	ncNamePosition := adapter position.
	ncName := adapter nextNCName.
	2 timesRepeat: [| token |
		adapter
			pushBackNCName: ncName
			position: ncNamePosition.
		token := adapter nextPushedBackToken.
		self
			deny: token isNil;
			assert: token value = ncName;
			assert: adapter nextPushedBackToken isNil;
			assert: adapter atEnd.

		adapter
			pushBackNCName: ncName
			position: ncNamePosition.
		"if the current position doesn't match the pushed back token position,
		then it should return nil"
		adapter next.
		self assert: adapter nextPushedBackToken isNil].! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:16'!
testPeek
	| adapter |

	adapter := self newStreamAdapterOnQualifiedName.
	self qualifiedName do: [:each |
		self assert: adapter peek == each.
		adapter next].
	self assert: adapter peek isNil.! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:55'!
testPeekPushedBackToken
	| adapter ncNamePosition ncName |

	adapter := self newStreamAdapterOnNCName.
	self assert: adapter peekPushedBackToken isNil.

	ncNamePosition := adapter position.
	ncName := adapter nextNCName.
	2 timesRepeat: [
		adapter
			pushBackNCName: ncName
			position: ncNamePosition.
		self
			assert: adapter peekPushedBackToken notNil;
			assert: adapter peekPushedBackToken value = ncName;
			assert: adapter peekPushedBackToken position = ncNamePosition.
	
		"if the current position doesn't match the pushed back token position,
		then it should return nil"
		adapter next.
		self assert: adapter peekPushedBackToken isNil].! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:07'!
testPushBackNCNamePosition
	| adapter ncNamePosition ncName |

	adapter := self newStreamAdapterOnNCName.
	ncNamePosition := adapter position.
	ncName := adapter nextNCName.
	self assert:
		(adapter
			pushBackNCName: ncName
			position: ncNamePosition) == adapter.
	self
		assert: adapter position = ncNamePosition;
		assert: adapter nextNCName = ncName;
		assert: adapter atEnd.! !

!XPathReadStreamAdapterTest methodsFor: 'tests' stamp: 'monty 3/25/2016 21:15'!
testStreamReadingPortability
	| stream adapter |

	stream := XMLExceptionRaisingReadStream on: self qualifiedName.
	adapter := self newStreamAdapterOn: stream.
	self qualifiedName do: [:each |
		self
			deny: adapter atEnd;
			assert: adapter peek = each;
			assert: adapter next = each].
	self assert: adapter atEnd.
	self
		shouldnt: [
			adapter
				peek;
				next]
		raise: Error.
	self
		assert: adapter peek isNil;
		assert: adapter next isNil.

	self assert: stream atEnd.
	self should: [stream peek] raise: Error.
	self should: [stream next] raise: Error.! !

TestCase subclass: #XPathStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathStringTest methodsFor: 'tests' stamp: 'monty 1/27/2017 11:15'!
testAsXPathBoolean
	self
		assert: 'true' asXPathBoolean;
		assert: 'false' asXPathBoolean;
		assert: '0' asXPathBoolean;
		deny: '' asXPathBoolean! !

!XPathStringTest methodsFor: 'tests' stamp: 'monty 2/11/2017 16:00'!
testAsXPathComparable
	| comparable |

	comparable := 'test' asXPathComparable.
	self
		assert: comparable class == XPathStringComparable;
		assert: comparable value = 'test'.! !

!XPathStringTest methodsFor: 'tests' stamp: 'monty 1/29/2017 13:48'!
testAsXPathNodeSet
	self
		should: ['test' asXPathNodeSet]
		raise: XPathTypeException! !

!XPathStringTest methodsFor: 'tests' stamp: 'monty 1/27/2017 11:14'!
testAsXPathNumber
	self
		assert: '1.5' asXPathNumber = 1.5;
		assert: ' -1.5 ' asXPathNumber = -1.5;
		assert: '21.25' asXPathNumber = 21.25;
		assert: ' -21.25 ' asXPathNumber = -21.25;
		assert: '321.325' asXPathNumber = 321.325;
		assert: ' -321.325 ' asXPathNumber = -321.325;
		assert: ' 	0.0 ' asXPathNumber isXPathPositiveZero;
		assert: '  -0.0   ' asXPathNumber isXPathNegativeZero;
		assert: '  .1  ' asXPathNumber = 0.1;
		assert: '  1. ' asXPathNumber = 1;
		assert: '  -.1  ' asXPathNumber = -0.1;
		assert: '  -1. ' asXPathNumber = -1;
		assert: '  .  ' asXPathNumber isNaN;
		assert: '   ' asXPathNumber isNaN.! !

!XPathStringTest methodsFor: 'tests' stamp: 'monty 1/27/2017 11:16'!
testAsXPathString
	| string |

	string := 'test'.
	self assert: string asXPathString == string.! !

TestCase subclass: #XPathTest
	instanceVariableNames: 'document namespacedDocument textDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

XPathTest subclass: #XPathLocationPathSpecificationTest
	instanceVariableNames: 'specificationDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathLocationPathSpecificationTest commentStamp: 'monty 2/17/2017 20:37' prior: 0!
This class has tests for abbreviated and unabbreviated location path expressions taken directly from the XPath 1.0 specification.!

!XPathLocationPathSpecificationTest methodsFor: 'running' stamp: 'monty 2/20/2017 03:57'!
setUp
	super setUp.

	specificationDocument := self specificationXML parseXML.! !

!XPathLocationPathSpecificationTest methodsFor: 'source XML' stamp: 'monty 2/20/2017 03:57'!
specificationXML
	"adapted from the DocBook article example in #docBookArticleSource and
	expanded so every XPath expression tested will have a non-empty result
	for at least one context node in the DOM-parsed document"
	^ '
	<doc lang="en">
		<chapter name="Chapter 1">
			<title>Introduction</title>
			<section>
				<para>Pharo''s goal is to deliver a clean, innovative, free open-source environment. Here is the to be revised Pharo vision document.</para>
				<para>By providing a stable and small core system, excellent developing tools, and maintained releases, Pharo is an attractive platform to build and deploy mission critical applications.</para>
				<para>Pharo fosters a healthy ecosystem of both private and commercial contributors who advance and maintain the core system and its external packages.</para>
			</section>
		</chapter>
		<chapter name="Chapter 2">
			<title>Pharo Features</title>
			<section>
				<para>Pharo has the following features:</para>
				<div>
					<olist>
						<item>A dynamic, pure object-oriented programming language in the tradition of Smalltalk</item>
						<item>An IDE (integrated development environment)</item>
						<item>A huge library and set of external packages</item>
					</olist>
				</div>
			</section>
			<section>
				<para>The goal of Pharo is to sustain and grow business.</para>
				<para type="warning">Pharo is supported by the industrial Pharo consortium.</para>
				<para type="warning">Pharo has also an association of users: Pharo association.</para>
				<para type="warning">Pharo is a work in progress.</para>
				<para type="warning">Pharo is continually evolving.</para>
				<para type="warning">Pharo is not always backwards compatible.</para>
		   </section>
		</chapter>
		<chapter name="Chapter 3" status="unfinished">
			<section>
				<figure>1</figure><figure>2</figure><figure>3</figure><figure>4</figure><figure>5</figure>
				<figure>6</figure><figure>7</figure><figure>8</figure><figure>9</figure><figure>10</figure>
				<figure>11</figure><figure>12</figure><figure>13</figure><figure>14</figure><figure>15</figure>
				<figure>16</figure><figure>17</figure><figure>18</figure><figure>19</figure><figure>20</figure>
				<figure>21</figure><figure>22</figure><figure>23</figure><figure>24</figure><figure>25</figure>
				<figure>26</figure><figure>27</figure><figure>28</figure><figure>29</figure><figure>30</figure>
				<figure>31</figure><figure>32</figure><figure>33</figure><figure>34</figure><figure>35</figure>
				<figure>36</figure><figure>37</figure><figure>38</figure><figure>39</figure><figure>40</figure>
				<figure>41</figure><figure>42</figure><figure>43</figure><figure>44</figure><figure>45</figure>
			</section>
		</chapter>
		<chapter name="Chapter 4" status="unfinished">
			<section><para>Unfinished.</para></section>
		</chapter>
		<chapter name="Chapter 5" status="unfinished">
			<section><para>Unfinished.</para></section>
			<section><para>Unfinished.</para></section>
		</chapter>
		<appendix name="Appendix 1">
			<title>Version History</title>
			<section>
				<div>
					<olist>
						<item>Pharo 1.0 was released April 15, 2010.</item>
						<item>Pharo 1.1 was released July 26, 2010.</item>
						<item>Pharo 1.2 was released March 29, 2011.</item>
						<item>Pharo 1.3 was released in August 2011.</item>
						<item>Pharo 1.4 was released in April 2012.</item>
						<item>Pharo 2.0 was released March 18, 2013.</item>
						<item>Pharo 3.0 was released in April 2014.</item>
						<item>Pharo 4.0 was released in April 2015.</item>
						<item>Pharo 5.0 was released in May 2016</item>
					</olist>
				</div>
			</section>
		</appendix>
	</doc>'! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedAttributeAxis
	specificationDocument allNodesDo: [:node |
		"selects the name attribute of the context node"
		self
			assertNodeSet: (node xpath: '@name')
			hasNodes:
				(node isElement
					ifTrue: [node attributeNodes select: [:each | each isNamed: 'name']]
					ifFalse: [#()]).

		"selects all the attributes of the context node"
		self
			assertNodeSet: (node xpath: '@*')
			hasNodes:
				(node isElement
					ifTrue: [node attributeNodes]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element children of the context node"
		self
			assertNodeSet: (node xpath: 'para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node elementsAt: 'para']
					ifFalse: [#()]).

		"selects all element children of the context node"
		self
			assertNodeSet: (node xpath: '*')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node elements]
					ifFalse: [#()]).

		"selects all text node children of the context node"
		self
			assertNodeSet: (node xpath: 'text()')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node stringNodes]
					ifFalse: [#()]).

		"selects all the children of the context node, whatever their node type"
		self
			assertNodeSet: (node xpath: 'node()')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node nodes]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisAttributePredicate
	specificationDocument allNodesDo: [:node |
		"selects all para children of the context node that have a type
		attribute with value warning"
		self
			assertNodeSet: (node xpath: 'para[@type="warning"]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						(node elementsAt: 'para') select: [:each |
							each hasAttributes
								and: [(each attributeAt: 'type') = 'warning']]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisAttributePredicatePositionPredicate
	specificationDocument allNodesDo: [:node |
		"selects the fifth para child of the context node that has a type
		attribute with value warning"
		self
			assertNodeSet: (node xpath: 'para[@type=''warning''][5]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						(((node elementsAt: 'para') select: [:each |
							each hasAttributes
								and: [(each attributeAt: 'type') = 'warning']])
							at: 5)
								ifNil: [#()]
								ifNotNil: [:para | Array with: para]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisChildAxis
	specificationDocument allNodesDo: [:node |
		"selects all para grandchildren of the context node"
		self
			assertNodeSet: (node xpath: '*/para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [| paras |
						paras := OrderedCollection new.
						node elementsDo: [:each |
							paras addAll:
								(each elementsAt: 'para')].
						paras]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisChildPredicate
	specificationDocument allNodesDo: [:node |
		"selects the chapter children of the context node that have one or more
		title children with string-value equal to Introduction"
		self
			assertNodeSet:
				(node xpath: 'child::chapter[child::title=''Introduction'']')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						(node elementsAt: 'chapter') select: [:chapter |
							(chapter elementsAt: 'title') anySatisfy: [:each |
								each stringValue = 'Introduction']]]
					ifFalse: [#()]).

		"selects the chapter children of the context node that have one or more title children"
		self
			assertNodeSet:
				(node xpath: 'child::chapter[child::title]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						node elementsSelect: [:chapter |
							(chapter isNamed: 'chapter')
								and: [(chapter elementAt: 'title') notNil]]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisDescendantAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element descendants of the chapter element children
		of the context node"
		self
			assertNodeSet: (node xpath: 'chapter//para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [| paras |
						paras := OrderedCollection new.
						node
							elementsAt: 'chapter'
							do: [:each |
								paras addAll:
									(each descendantElementsNamed: 'para')].
						paras]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | paras |
		paras :=
			node canHaveChildren
				ifTrue: [node elementsAt: 'para']
				ifFalse: [#()].

		"selects the first para child of the context node"
		self
			assertNodeSet: (node xpath: 'para[1]')
			hasNodes:
				(paras size > 0
					ifTrue: [Array with: paras first]
					ifFalse: [#()]).

		"selects the last para child of the context node"
		self
			assertNodeSet: (node xpath: 'para[last()]')
			hasNodes:
				(paras size > 0
					ifTrue: [Array with: paras last]
					ifFalse: [#()]).

		"selects the last but one para child of the context node"
		self
			assertNodeSet: (node xpath: 'para[last()-1]')
			hasNodes:
				(paras size > 1
					ifTrue: [Array with: (paras at: paras size - 1)]
					ifFalse: [#()]).

		"selects all the para children of the context node other than
		the first para child of the context node"
		self
			assertNodeSet: (node xpath: 'para[position()>1]')
			hasNodes:
				(paras size > 1
					ifTrue: [paras allButFirst]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedChildAxisPositionPredicateAttributePredicate
	specificationDocument allNodesDo: [:node | | paras |
		paras :=
			node canHaveChildren
				ifTrue: [node elementsAt: 'para']
				ifFalse: [#()].

		"selects the fifth para child of the context node if that child
		has a type attribute with value warning"
		self
			assertNodeSet: (node xpath: 'para[5][@type="warning"]')
			hasNodes:
				((paras size >= 5
					and: [(paras at: 5) hasAttributes
						and: [((paras at: 5) attributeAt: 'type') = 'warning']])
					ifTrue: [paras copyFrom: 5 to: 5]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedDescendantAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element descendants of the context node"
		self
			assertNodeSet: (node xpath: './/para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node descendantElementsNamed: 'para']
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedParentAxis
	specificationDocument allNodesDo: [:node |
		"selects the parent of the context node"
		self
			assertNodeSet: (node xpath: '..')
			hasNodes:
				(node hasParent
					ifTrue: [Array with: node parent]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedParentAxisAttribute
	specificationDocument allNodesDo: [:node |
		"selects the lang attribute of the parent of the context node"
		self
			assertNodeSet: (node xpath: '../@lang')
			hasNodes:
				((node hasParent
					and: [node parent isElement
						and: [node parent hasAttributes]])
					ifTrue: [
						(node parent attributeNodes select: [:each |
							each isNamed: 'lang'])]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedRootChildAxisChildAxisChildAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | sections |
		sections := OrderedCollection new.
		((specificationDocument root elementsAt: 'chapter')
			at: 5)
			ifNotNil: [:chapter |
				((chapter elementsAt: 'section')
					at: 2)
					ifNotNil: [:section |
						sections addLast: section]].

		"selects the second section of the fifth chapter of the doc
		document element"
		self
			assertNodeSet: (node xpath: '/doc/chapter[5]/section[2]')
			hasNodes: sections]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedRootDescendantAxis
	specificationDocument allNodesDo: [:node |
		"para selects all the para descendants of the document root and thus
		selects all para elements in the same document as the context node"
		self
			assertNodeSet: (node xpath: '//para')
			hasNodes: (specificationDocument descendantElementsNamed: 'para')]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedRootDescendantAxisChildAxis
	specificationDocument allNodesDo: [:node |
		"selects all the item elements in the same document as the
		context node that have an olist parent"
		self
			assertNodeSet: (node xpath: '//olist/item')
			hasNodes:
				((specificationDocument descendantElementsNamed: 'item')
					select: [:each |
						each hasParent
							and: [each parent isElementNamed: 'olist']])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedRootDescendantAxisPositionPredicate
	specificationDocument allNodesDo: [:node |
		"selects the forty-second figure element in the document"
		self
			assertNodeSet: (node xpath: '//figure[42]')
			hasNodes:
				(((specificationDocument descendantElementsNamed: 'figure')
					at: 42)
						ifNil: [#()]
						ifNotNil: [:figure | Array with: figure])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAbbreviatedSelfAxis
	specificationDocument allNodesDo: [:node |
		"selects the context node"
		self
			assertNodeSet: (node xpath: '.')
			hasNode: node]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedAncestorAxis
	specificationDocument allNodesDo: [:node |
		"selects all div ancestors of the context node"
		self
			assertNodeSet: (node xpath: 'ancestor::div')
			hasNodes:
				(node ancestorElements select: [:each |
					each isNamed: 'div'])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedAncestorOrSelfAxis
	specificationDocument allNodesDo: [:node |
		"selects the div ancestors of the context node and, if the context node is
		a div element, the context node as well"
		self
			assertNodeSet: (node xpath: 'ancestor-or-self::div ')
			hasNodes:
				((node ancestorNodes copyWith: node) select: [:each |
					each isElementNamed: 'div'])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedAttributeAxis
	specificationDocument allNodesDo: [:node |
		"selects the name attribute of the context node"
		self
			assertNodeSet: (node xpath: 'attribute::name')
			hasNodes:
				((node isElement
					and: [node hasAttributes])
					ifTrue: [
						node attributeNodes select: [:each |
							each isNamed: 'name']]
					ifFalse: [#()]).

		"selects all the attributes of the context node"
		self
			assertNodeSet: (node xpath: 'attribute::*')
			hasNodes:
				(node isElement
					ifTrue: [node attributeNodes]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element children of the context node"
		self
			assertNodeSet: (node xpath: 'child::para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node elementsAt: 'para']
					ifFalse: [#()]).

		"selects all element children of the context node"
		self
			assertNodeSet: (node xpath: 'child::*')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node elements]
					ifFalse: [#()]).

		"selects all text node children of the context node"
		self
			assertNodeSet: (node xpath: 'child::text()')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node stringNodes]
					ifFalse: [#()]).

		"selects all the children of the context node, whatever their node type"
		self
			assertNodeSet: (node xpath: 'child::node()')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node nodes]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisAttributePredicate
	specificationDocument allNodesDo: [:node |
		"selects all para children of the context node that have a type
		attribute with value warning"
		self
			assertNodeSet: (node xpath: 'child::para[attribute::type="warning"]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						(node elementsAt: 'para') select: [:each |
							each hasAttributes
								and: [(each attributeAt: 'type') = 'warning']]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisAttributePredicatePositionPredicate
	specificationDocument allNodesDo: [:node |
		"selects the fifth para child of the context node that has a type
		attribute with value warning"
		self
			assertNodeSet:
				(node xpath: 'child::para[attribute::type=''warning''][position()=5]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						(((node elementsAt: 'para') select: [:each |
							each hasAttributes
								and: [(each attributeAt: 'type') = 'warning']])
							at: 5)
								ifNil: [#()]
								ifNotNil: [:para | Array with: para]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisChildAxis
	specificationDocument allNodesDo: [:node |
		"selects all para grandchildren of the context node"
		self
			assertNodeSet: (node xpath: 'child::*/child::para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [| paras |
						paras := OrderedCollection new.
						node elementsDo: [:element |
							paras addAll:
								(element elementsAt: 'para')].
						paras]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisChildPredicate
	specificationDocument allNodesDo: [:node |
		"selects the chapter children of the context node that have one or more
		title children with string-value equal to Introduction"
		self
			assertNodeSet:
				(node xpath: 'child::chapter[child::title=''Introduction'']')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						node elementsSelect: [:chapter |
							chapter name = 'chapter'
								and: [
									(chapter elementsAt: 'title') anySatisfy: [:each |
										each stringValue = 'Introduction']]]]
					ifFalse: [#()]).

		"selects the chapter children of the context node that have one or more title children"
		self
			assertNodeSet:
				(node xpath: 'child::chapter[child::title]')
			hasNodes:
				(node canHaveChildren
					ifTrue: [
						node elementsSelect: [:chapter |
							(chapter isNamed: 'chapter')
								and: [(chapter elementAt: 'title') notNil]]]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisDescendantAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element descendants of the chapter element children
		of the context node"
		self
			assertNodeSet: (node xpath: 'child::chapter/descendant::para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [| paras |
						paras := OrderedCollection new.
						node
							elementsAt: 'chapter'
							do: [:each |
								paras addAll:
									(each descendantElementsNamed:  'para')].
						paras]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | paras |
		paras :=
			node canHaveChildren
				ifTrue: [node elementsAt: 'para']
				ifFalse: [#()].

		"selects the first para child of the context node"
		self
			assertNodeSet: (node xpath: 'child::para[position()=1]')
			hasNodes:
				(paras size > 0
					ifTrue: [Array with: paras first]
					ifFalse: [#()]).

		"selects the last para child of the context node"
		self
			assertNodeSet: (node xpath: 'child::para[position()=last()]')
			hasNodes:
				(paras size > 0
					ifTrue: [Array with: paras last]
					ifFalse: [#()]).

		"selects the last but one para child of the context node"
		self
			assertNodeSet: (node xpath: 'child::para[position()=last()-1]')
			hasNodes:
				(paras size > 1
					ifTrue: [Array with: (paras at: paras size - 1)]
					ifFalse: [#()]).

		"selects all the para children of the context node other than
		the first para child of the context node"
		self
			assertNodeSet: (node xpath: 'child::para[position()>1]')
			hasNodes:
				(paras size > 1
					ifTrue: [paras allButFirst]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisPositionPredicateAttributePredicate
	specificationDocument allNodesDo: [:node | | paras |
		paras :=
			node canHaveChildren
				ifTrue: [node elementsAt: 'para']
				ifFalse: [#()].

		"selects the fifth para child of the context node if that child
		has a type attribute with value warning"
		self
			assertNodeSet:
				(node xpath: 'child::para[position()=5][attribute::type="warning"]')
			hasNodes:
				((paras size >= 5
					and: [(paras at: 5) hasAttributes
						and: [((paras at: 5) attributeAt: 'type') = 'warning']])
					ifTrue: [paras copyFrom: 5 to: 5]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedChildAxisSelfPredicate
	specificationDocument allNodesDo: [:node | | elements |
		elements :=
			node canHaveChildren
				ifTrue: [
					node elementsSelect: [:each |
						each isNamedAny: #('chapter' 'appendix')]]
				ifFalse: [#()].

		"selects the chapter and appendix children of the context node"
		self
			assertNodeSet:
				(node xpath: 'child::*[self::chapter or self::appendix]')
			hasNodes: elements.

		"selects the last chapter or appendix child of the context node"
		self
			assertNodeSet:
				(node xpath:
					'child::*[self::chapter or self::appendix][position()=last()]')
			hasNodes:
				(elements size > 0
					ifTrue: [Array with: elements last]
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedDescendantAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element descendants of the context node"
		self
			assertNodeSet: (node xpath: 'descendant::para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node descendantElementsNamed: 'para']
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedDescendantOrSelfAxis
	specificationDocument allNodesDo: [:node |
		"selects the para element descendants of the context node and, if
		the context node is a para element, the context node as well"
		self
			assertNodeSet: (node xpath: 'descendant-or-self::para')
			hasNodes:
				(node canHaveChildren
					ifTrue: [node allElementsNamed: 'para']
					ifFalse: [#()])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedFollowingSiblingAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | chapters |
		chapters := OrderedCollection new.
		node followingSiblingNodesDo: [:each |
			((each isElementNamed: 'chapter')
				and: [chapters isEmpty])
				ifTrue: [chapters addLast: each]].

		"selects the next chapter sibling of the context node"
		self
			assertNodeSet: (node xpath: 'following-sibling::chapter[position()=1]')
			hasNodes: chapters]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedPrecedingSiblingAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | chapters |
		chapters := OrderedCollection new.
		node precedingSiblingNodesDo: [:each |
			((each isElementNamed: 'chapter')
				and: [chapters isEmpty])
				ifTrue: [chapters addLast: each]].

		"selects the next chapter sibling of the context node"
		self
			assertNodeSet: (node xpath: 'preceding-sibling::chapter[position()=1]')
			hasNodes: chapters]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedRootAxis
	specificationDocument allNodesDo: [:node |
		"selects the document root (which is always the parent of the document element)"
		self
			assertNodeSet: (node xpath: '/')
			hasNodes: (Array with: specificationDocument)]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedRootChildAxisChildAxisChildAxisPositionPredicate
	specificationDocument allNodesDo: [:node | | sections |
		sections := OrderedCollection new.
		((specificationDocument root elementsAt: 'chapter')
			at: 5)
			ifNotNil: [:chapter |
				((chapter elementsAt: 'section')
					at: 2)
					ifNotNil: [:section |
						sections addLast: section]].

		"selects the second section of the fifth chapter of the doc
		document element"
		self
			assertNodeSet:
				(node xpath:
					'/child::doc/child::chapter[position()=5]/child::section[position()=2]')
			hasNodes: sections]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedRootDescendantAxis
	specificationDocument allNodesDo: [:node |
		"selects all the para elements in the same document as the context node"
		self
			assertNodeSet: (node xpath: '/descendant::para')
			hasNodes: (specificationDocument descendantElementsNamed: 'para')]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedRootDescendantAxisChildAxis
	specificationDocument allNodesDo: [:node |
		"selects all the item elements that have an olist parent and that
		are in the same document as the context node"
		self
			assertNodeSet: (node xpath: '/descendant::olist/child::item')
			hasNodes:
				((specificationDocument descendantElementsNamed: 'item')
					select: [:each |
						each hasParent
							and: [each parent isElementNamed: 'olist']])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedRootDescendantAxisPositionPredicate
	specificationDocument allNodesDo: [:node |
		"selects the forty-second figure element in the document"
		self
			assertNodeSet: (node xpath: '/descendant::figure[position()=42]')
			hasNodes:
				(((specificationDocument descendantElementsNamed: 'figure')
					at: 42)
						ifNil: [#()]
						ifNotNil: [:figure | Array with: figure])]! !

!XPathLocationPathSpecificationTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testUnabbreviatedSelfAxis
	specificationDocument allNodesDo: [:node | | result |
		"selects the context node if it is a para element, and otherwise
		selects nothing"
		result := node xpath: 'self::para'.
		(node isElementNamed: 'para')
			ifTrue: [
				self
					assertNodeSet: result
					hasNode: node]
			ifFalse: [self assert: result isEmpty]]! !

!XPathTest methodsFor: 'asserting' stamp: 'monty 3/17/2017 22:30'!
assertNodeSet: aNodeSet hasNode: aNode
	self
		assertNodeSet: aNodeSet
		hasNodes: (self nodeSetClass with: aNode)! !

!XPathTest methodsFor: 'asserting' stamp: 'monty 3/17/2017 22:29'!
assertNodeSet: aNodeSet hasNodes: aNodeCollection
	self
		assert: aNodeSet size = aNodeCollection size;
		assert: aNodeSet = (XPathNodeSet newFrom: aNodeCollection) sort;
		assert: (aNodeSet sortOrder isKindOf: XPathDocumentSortOrder)! !

!XPathTest methodsFor: 'asserting' stamp: 'monty 3/17/2017 22:33'!
assertNodeSet: aNodeSet hasSortOrder: aSortOrder
	self assert: aNodeSet sortOrder class == aSortOrder! !

!XPathTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:13'!
contextClass
	^ XPathContext! !

!XPathTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:13'!
functionSetClass
	^ XPathFunctionSet! !

!XPathTest methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:25'!
newContext
	^ self contextClass new! !

!XPathTest methodsFor: 'instance creation' stamp: 'monty 9/22/2016 17:00'!
newNodeSet
	^ self nodeSetClass new! !

!XPathTest methodsFor: 'accessing' stamp: 'monty 9/22/2016 17:00'!
nodeSetClass
	^ XPathNodeSet! !

!XPathTest methodsFor: 'running' stamp: 'monty 2/20/2017 02:06'!
setUp
	document :=
		(XMLDOMParser on: XMLParserTest addressBookXML)
			preservesCommentNodes: true;
			parseDocument.
	namespacedDocument := 
		(XMLDOMParser on: XMLParserTest addressBookNamespacePrefixedXML)
			preservesCommentNodes: true;
			parseDocument.
	textDocument :=
		(XMLDOMParser on: self textDocumentXML)
			preservesCommentNodes: true;
			parseDocument.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:31'!
testAbbreviatedSteps
	| expected |

	self
		assertNodeSet: (document xpath: '.')
		hasNode: document.
	self
		assertNodeSet: (document xpath: './.')
		hasNode: document.
	self
		assert: (document xpath: './..') isEmpty;
		assert: (document xpath: '..') isEmpty;
		assert: (document xpath: '../..') isEmpty.
	self
		assertNodeSet: (document xpath: '/.')
		hasNode: document.
	self
		assertNodeSet: (document xpath: '/./.')
		hasNode: document.
	self
		assert: (document xpath: '/./..') isEmpty;
		assert: (document xpath: '/..') isEmpty;
		assert: (document xpath: '/../..') isEmpty.

	expected := document allElementsNamed: 'person'.
	self
		assertNodeSet: (document xpath: './addressbook/./person/.')
		hasNodes: expected.
	self
		assertNodeSet: (document xpath: '././addressbook/././person/./.')
		hasNodes: expected.
	self
		assertNodeSet: (document xpath: './addressbook/../addressbook/person/../person')
		hasNodes: expected.
	self
		assertNodeSet: (document xpath: './addressbook/./../addressbook/./person/./../person')
		hasNodes: expected.

	"abbreviated steps can't have predicates"
	self
		should: [document xpath: '.[true()]']
		raise: XPathSyntaxException.
	self
		should: [document xpath: '..[true()]']
		raise: XPathSyntaxException.
	self
		should: [document xpath: '/.[true()]']
		raise: XPathSyntaxException.
	self
		should: [document xpath: '/..[true()]']
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:33'!
testAbsoluteLocationPaths
	document allNodesDo: [:each |
		self
			assertNodeSet: (XPath for: '/' in: each)
			hasNode: document.
		self
			assertNodeSet: (XPath for: '/*' in: each)
			hasNode: document root.
		self
			assertNodeSet: (XPath for: '/self::node()' in: each)
			hasNode: document.
		self
			assertNodeSet: (XPath for: '/addressbook/person' in: each)
			hasNodes: (document allElementsNamed: 'person')]! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:14'!
testAddFunction
	| path functionsWithoutCeiling context |

	path := XPath for: 'ceiling(1.9)'.

	functionsWithoutCeiling :=
		self functionSetClass default copyWithout:
			XPathCeilingFunction.
	context := self contextClass functions: functionsWithoutCeiling.
	self deny: (context includesFunction: XPathCeilingFunction).
	self
		should: [
			path
				in: nil
				context: context]
		raise: XPathUndeclaredFunctionException.

	(context := self contextClass functions: functionsWithoutCeiling)
		addFunction: XPathCeilingFunction.
	self assert: (context includesFunction: XPathCeilingFunction).
	"adding should modify an internal copy, not the original"
	self deny: (functionsWithoutCeiling includes: XPathCeilingFunction).
	self assert:
		(path
			in: nil
			context: context) = 2.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/19/2017 07:07'!
testAncestorAxis
	| ancestors |

	ancestors := document allNodesSelect: [:each | each hasChildren].
	self
		assertNodeSet: (XPath for: '//ancestor::node()' in: document)
		hasNodes: ancestors.

	ancestors := ancestors select: [:ancestor |
		ancestor nodes anySatisfy: [:each | each hasChildren]].
	self
		assertNodeSet: (XPath for: '//ancestor::node()/ancestor::node()' in: document)
		hasNodes: ancestors.

	ancestors
		removeAll;
		addAll: (document allElementsNamed: 'person');
		addAll: ancestors last ancestorNodes.
	self
		assertNodeSet: (XPath for: '*/person/node()/ancestor::node()' in: document)
		hasNodes: ancestors.

	self
		assertNodeSet: (XPath for: 'addressbook/ancestor::node()' in: document)
		hasNode: document.
	self
		assertNodeSet: (XPath for: 'addressbook/person/ancestor::*' in: document)
		hasNode: document root.

	self
		assert: (XPath for: 'addressbook/ancestor::*' in: document) isEmpty;
		assert: (XPath for: 'ancestor::node()' in: document) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/19/2017 07:08'!
testAncestorOrSelfAxis
	| nodes |

	nodes := document allNodesSelect: [:each | each hasChildren not].
	self
		assertNodeSet:
			(XPath
				for: '//node() [ count( child::node() ) = 0]'
				in: document)
		hasNodes: nodes.

	nodes := document allNodes.
	self
		assertNodeSet:
			(XPath
				for: '//node( )[count(child::node( ))=0]/ancestor-or-self::node( )'
				in: document)
		hasNodes: nodes.

	nodes := (document allElementsNamed: 'person') allButLast.
	nodes addAll: nodes last ancestorNodes.
	self
		assertNodeSet:
			(XPath
				for: '//person[last()]/preceding-sibling::person/ancestor-or-self::node()'
				in: document)
		hasNodes: nodes.

	nodes removeAll.
	(document allElementsNamed: 'person') do: [:each |
		nodes
			addLast: each;
			addAll: each nodes].
	nodes addAll: nodes first ancestorNodes.
	self
		assertNodeSet: (XPath for: '*/person/node()/ancestor-or-self::node()' in: document)
		hasNodes: nodes.

	nodes
		removeAll;
		addLast: document root;
		addAll: (document allElementsNamed: 'person').
	self
		assertNodeSet: (XPath for: 'addressbook/person/ancestor-or-self::*' in: document)
		hasNodes: nodes.

	self
		assertNodeSet: (XPath for: 'addressbook/ancestor-or-self::*' in: document)
		hasNode: document root.
	self
		assertNodeSet: (XPath for: 'ancestor-or-self::node()' in: document)
		hasNode: document.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAsXPath
	| path |

	path := '/addressbook' asXPath.
	self
		assert: path class == XPath;
		assert: (document xpath: path) = (self nodeSetClass with: document root);
		assert: path asXPath == path.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:46'!
testAttributeAxis
	| result expected |

	result :=
		XPath
			for: 'addressbook/person/address/@city'
			in: document.
	expected := XMLNodeList new.
	document root
		elementsAt: 'person'
		do: [:person |
			person
				elementsAt: 'address'
				do: [:each |
					(each includesAttribute: 'city')
						ifTrue: [
							expected addLast:
								(each attributeNodeAt: 'city')]]].
	self
		assertNodeSet: result
		hasNodes: expected.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	"attribute nodes don't have attributes"
	self assert: 
		(XPath
			for: 'addressbook/person/address/@city/@city'
			in: document) isEmpty.

	expected removeAll.
	(document allElementsNamed: 'person') allButLast do: [:each |
		expected addAll: each attributeNodes].
	result :=
		(document allElementsNamed: 'person') last xpath:
			'preceding-sibling::node()/attribute::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:36'!
testAttributeNameTest
	| results |

	results :=
		document xpath:
			'addressbook/person/attribute::node()/self::attribute(employee-number)'.
	self
		assertNodeSet: results
		hasNodes:
			((document allElementsNamed: 'person') collect: [:each |
				each attributeNodeAt: 'employee-number']).

	results :=
		document xpath:
			'addressbook/person/attribute::node()/self::attribute(absent)'.
	self assert: results isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAttributePredicates
	| persons |

	persons := (document allElementsNamed: 'person') copyFrom: 2 to: 3.
	self
		assertNodeSet: (document xpath: 'addressbook/person[ @ middle-initial ]')
		hasNodes: persons;
		assertNodeSet: (document xpath: 'addressbook/person[ @ middle-initial and position() > 1 ]')
		hasNodes: persons;
		assertNodeSet: (document xpath: 'addressbook/person[ @ * [ local-name() = "middle-initial" ] ]')
		hasNodes: persons;
		assertNodeSet: (document xpath: 'addressbook/person[ @ * [ self::attribute(middle-initial) ] ]')
		hasNodes: persons;
		assertNodeSet:
			(document xpath:
				'addressbook/person[ @ * [ local-name() = "middle-initial" ] and position() < 4 ]')
		hasNodes: persons.

	self
		assert: (document xpath: 'addressbook/person[ @ middle-initial and position() < 2 ]') isEmpty;
		assert:
			(document xpath:
				'addressbook/person[ @ * [ local-name() = "middle-initial" ] and position() > 3 ]') isEmpty;
		assert: (document xpath: 'addressbook/person[ @ absent ]') isEmpty;
		assert: (document xpath: 'addressbook/person[ @ * [ self::attribute(absent) ] ]') isEmpty;
		assert: (document xpath: 'addressbook/person[ @ * [ local-name() = "absent" ] ]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAttributePredicatesComparison
	| addresses |

	addresses := document allElementsNamed: 'address'.
	self
		assertNodeSet: (document xpath: '//address[ @ number >= 344 ]')
		hasNodes: addresses.

	addresses := addresses copyReplaceFrom: 2 to: 2 with: #().
	self
		assertNodeSet: (document xpath: '//address[ @ number > 344 ]')
		hasNodes: addresses.

	self
		assertNodeSet: (document xpath: '//address[ @ number <= 344 ]')
		hasNode: (document allElementsNamed: 'address') second.
	self assert: (document xpath: '//address[ @ number < 344 ]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAttributePredicatesEquals
	| person |

	person := (document allElementsNamed: 'person') first.
	self
		assertNodeSet: (document xpath: 'addressbook/person[ @ employee-number = "A0000" ]')
		hasNode: person;
		assertNodeSet: (document xpath: 'addressbook/person[ @ employee-number = ''A0000'' ]')
		hasNode: person;
		assertNodeSet:
			(document xpath: 'addressbook/person[ @ employee-number = "A0000" and position() = 1]')
		hasNode: person.
	self assert:
		(document xpath:
			'addressbook/person[ @ employee-number = ''A0000'' and position() > 1]') isEmpty.

	self
		assertNodeSet: (document xpath: '//address[ @ number = 344 ]')
		hasNode: (document allElementsNamed: 'address') second.
	self assert:
		(document xpath: '//address[ @ number = 1 ]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testAttributePredicatesNotEquals
	| persons addresses |

	persons := (document allElementsNamed: 'person') allButFirst.
	self
		assertNodeSet: (document xpath: 'addressbook/person[ @ employee-number !!= "A0000" ]')
		hasNodes: persons;
		assertNodeSet: (document xpath: 'addressbook/person[ @ employee-number !!= ''A0000'' ]')
		hasNodes: persons;
		assertNodeSet:
			(document xpath: 'addressbook/person[ @ employee-number !!= "A0000"  and position() > 1]')
		hasNodes: persons.
	self assert:
		(document xpath:
			'addressbook/person[ @ employee-number !!= ''A0000'' and position() = 1]') isEmpty.

	addresses := document allElementsNamed: 'address'.
	self
		assertNodeSet: (document xpath: '//address[ @ number !!= 1 ]')
		hasNodes: addresses.
	addresses := addresses copyReplaceFrom: 2 to: 2 with: #().
	self
		assertNodeSet: (document xpath: '//address[ @ number !!= 344 ]')
		hasNodes: addresses.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:52'!
testAttributeTypeTest
	| expected |

	expected := XMLNodeList new.
	document allNodesDo: [:each |
		each isElement
			ifTrue: [expected addAll: each attributeNodes]
			ifFalse: [
				each isStringNode
					ifTrue: [expected addLast: each]]].
	self
		assertNodeSet: (document xpath: '//attribute::* | //text()')
		hasNodes: expected.
	
	expected := expected select: [:each | each isAttribute].
	self
		assertNodeSet:
			(document xpath: '(//attribute::* | //text())/ self :: attribute()')
		hasNodes: expected.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 23:58'!
testChildAxis
	| children result |

	children := document allElementsNamed: 'person'.
	result :=
		XPath
			for: 'child::addressbook/child::person'
			in: document.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	children removeAll.
	document
		allElementsNamed: 'person'
		do: [:each |
			children addAll: each nodes].
	result :=
		XPath
			for: '/addressbook/person/node()'
			in: document.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	children := document root nodes copy.
	(document allElementsNamed: 'person') third nodesDo: [:each |
		each hasChildren
			ifTrue: [children addAll: each nodes]].
	result :=
		XPath
			for: '(/addressbook | //person[3]/*)/node()'
			in: document.
	self
		assertNodeSet: result
		hasNodes: children.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 04:49'!
testCommentTypeTest
	| comments |

	comments := document allNodesSelect: [:each | each isComment].
	self
		assertNodeSet: (document xpath: '//comment()')
		hasNodes: comments.
	self
		assertNodeSet: (document xpath: '//comment()/self::comment()')
		hasNodes: comments.
	self assert: (document xpath: '//comment()/comment()') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/19/2015 06:25'!
testConcatFunction
	self
		assert: (XPath for: 'concat("one", "two")' in: nil) = 'onetwo';
		assert: (XPath for: 'concat("one", "two", true())' in: nil) = 'onetwotrue'.
	self
		should: [XPath for: 'concat("one")' in: nil]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2015 07:04'!
testCountFunction
	self assert:
		(XPath for: 'count(addressbook/person)' in: document) =
			(document allElementsNamed: 'person') size.
	self assert:
		(XPath for: 'addressbook/person[count(@*) >= 4]' in: document) =
			((document allElementsNamed: 'person') copyFrom: 2 to: 3).
	self
		should: [XPath for: 'count()' in: nil]
		raise: XPathArgumentNumberException.
	self
		should: [XPath for: 'count(1)' in: nil]
		raise: XPathTypeException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/19/2017 07:14'!
testDescendantAxis
	| path results |

	path := XPath for: '//address/@city'.
	results := path in: document.
	self
		assert: results size = 4;
		assert: results first value = 'Los Angeles'.

	path := XPath for: 'addressbook/person//address'.
	self
		assertNodeSet: (path in: document)
		hasNodes: (document allElementsNamed: 'address').

	path := XPath for: 'addressbook/person//address//absent'.
	self assert: (path in: document) isEmpty.

	path := XPath for: 'addressbook/person//*'.
	self
		assertNodeSet: (path in: document)
		hasNodes:
			(document root descendantElementsSelect: [:each |
				(each isNamed: 'person') not]).

	path := XPath for: 'addressbook/person//*/descendant::*'.
	self
		assertNodeSet: (path in: document)
		hasNodes:
			(document root descendantElementsSelect: [:each |
				((each isNamed: 'person')
					or: [each parent isNamed: 'person']) not]).

	path := XPath for: 'addressbook/person[last()]/preceding-sibling::person/descendant::*'.
	self
		assertNodeSet: (path in: document)
		hasNodes:
			(document root descendantElementsSelect: [:each |
				((each isNamed: 'person')
					or: [each ancestorElements includes: document root lastElement]) not]).

	path := XPath for: 'addressbook/descendant::comment()'.
	self
		assertNodeSet: (path in: document)
		hasNodes: (document allNodesSelect: [:each | each isComment]).

	path := XPath for: 'addressbook/descendant::comment()/descendant::node()'.
	self assert: (path in: document) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 12/23/2016 21:08'!
testDescendantOrSelfAxis
	self
		assertNodeSet: (XPath for: '//.' in: document)
		hasNodes: document allNodes.
	self
		assertNodeSet: (XPath for: '//./node()' in: document)
		hasNodes: document descendantNodes.
	self
		assertNodeSet: (XPath for: '// self :: node()' in: document)
		hasNodes: document allNodes.
	self
		assertNodeSet: (XPath for: '/ descendant-or-self ::node()' in: document)
		hasNodes: document allNodes.
	self
		assertNodeSet: (XPath for: '//*' in: document)
		hasNodes: document allElements.
	self
		assertNodeSet:
			(XPath for: '//comment()/descendant-or-self::comment()' in: document)
		hasNodes: (document allNodesSelect: [:each | each isComment]).
	self
		assertNodeSet:
			(XPath for: 'addressbook/person/descendant-or-self::element()' in: document)
		hasNodes: document root descendantElements.
	self
		assertNodeSet:
			(XPath for: 'addressbook/person/descendant-or-self::address' in: document)
		hasNodes: (document allElementsNamed: 'address').
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person[last()]/preceding-sibling::person/descendant-or-self::*'
				in: document)
		hasNodes: (document root descendantElements copyUpTo: document root lastElement).
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/contact-info/comment()/descendant-or-self::node()'
				in: document)
		hasNodes: (document allNodesSelect: [:each | each isComment]).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/17/2017 22:34'!
testDocumentOrderLosing
	| expected result |

	expected := document allNodesSelect: [:each | each hasChildren].
	result := document xpath: 'descendant::node()/ancestor::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected := document allNodes.
	result := document xpath: 'descendant::node()/ancestor-or-self::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected :=
		document root descendantNodesSelect: [:each |
			each previousNode isNil].
	result := document xpath: 'descendant::node()/descendant::node()[1]'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document descendantNodesDo: [:each |
		each hasChildren
			ifTrue: [expected add: each firstNode]].
	result := document xpath: 'descendant::node()/descendant-or-self::node()[2]'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected := document root descendantNodesSelect: [:each | each hasParent].
	result := document xpath: 'descendant::node()/node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected := self newNodeSet.
	document descendantNodesDo: [:node |
		node followingSiblingNodesDo: [:each |
			expected addIfNotPresent: each]].
	result := document xpath: 'descendant::node()/following-sibling::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document descendantNodesDo: [:node |
		node followingNodesDo: [:each |
			expected addIfNotPresent: each]].
	result := document xpath: '/descendant::node()/following::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document descendantNodesDo: [:node |
		node precedingSiblingNodesDo: [:each |
			expected addIfNotPresent: each]].
	result := document xpath: 'descendant::node()/preceding-sibling::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document descendantNodesDo: [:node |
		node precedingNodesDo: [:each |
			expected addIfNotPresent: each]].
	result := document xpath: 'descendant::node()/preceding::node()'.
	self
		assertNodeSet: result
		hasNodes: expected.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/17/2017 22:35'!
testDocumentOrderPreserving
	| expected result |

	expected := document allNodesSelect: [:each | each hasChildren].
	result := document xpath: 'descendant::node()/parent::node()[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected := document allNodes allButFirst.
	result := document xpath: 'descendant::node()/self::node()[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document allElementsDo: [:each | expected addAll: each attributeNodes].
	result := document xpath: 'descendant::*/@*[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	namespacedDocument allElementsDo: [:each | expected addAll: each namespaceNodes].
	result := namespacedDocument xpath: 'descendant::*/namespace::*[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:21'!
testDot
	| path results |

	path := XPath for: 'addressbook/person/address/./@city'.
	results := path in: document.
	self assert: results size = 4.
	self assert: (results at: 1) value = 'Los Angeles'.
! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:21'!
testDotDot
	| path results |
	path := XPath for: 'addressbook/person/address/../address/@city'.
	results := path in: document.
	self assert: results size = 4.
	self assert: (results at: 1) value = 'Los Angeles'.
! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:21'!
testDotDotTooHigh
	| path results |
	path := XPath for: 'person/address/../../../address/@city'.
	results := path in: document.
	self assert: results isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:15'!
testDoubleWildcard
	self
		assertNodeSet: (XPath for: 'addressbook/*:*' in: document)
		hasNodes: (document allElementsNamed: 'person').
	self
		assertNodeSet: (XPath for: 'book:addressbook/*:*' in: namespacedDocument)
		hasNodes: (namespacedDocument allElementsNamed: 'person').
	self
		assertNodeSet: 
			(XPath
				for: '*:*/*:*'
				in: namespacedDocument
				context: (self newContext declarePrefix: 'two' uri: 'personNS'))
		hasNodes: (namespacedDocument allElementsNamed: 'person').! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:16'!
testElementDoubleWildcard
	self
		assertNodeSet: (XPath for: 'addressbook/element(*:*)' in: document)
		hasNodes: (document allElementsNamed: 'person').
	self
		assertNodeSet: (XPath for: 'book:addressbook/element(*:*)' in: namespacedDocument)
		hasNodes: (namespacedDocument allElementsNamed: 'person').
	self
		assertNodeSet:
			(XPath
				for: 'element(*:*)/element(*:*)'
				in: namespacedDocument
				context: (self newContext declarePrefix: 'two' uri: 'personNS')) 
		hasNodes: (namespacedDocument allElementsNamed: 'person').! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementExpandedNameTest
	self
		assertNodeSet:
			(namespacedDocument xpath: 'element( Q{bookNS}addressbook ) / element( Q{personNS}person )')
		hasNodes: (namespacedDocument allElementsNamed: 'person').
	self assert: (namespacedDocument xpath: 'element(Q{undeclared}addressbook)') isEmpty.

	self
		should: [namespacedDocument xpath: 'element(Q{bookNS} addressbook)']
		raise: XPathSyntaxException.
	self
		should: [namespacedDocument xpath: 'element(Q {bookNS}addressbook)']
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementExpandedNameWildcardTest
	self
		assertNodeSet: (namespacedDocument xpath: 'element( Q{bookNS}* ) / element( Q{personNS}* )')
		hasNodes: (namespacedDocument allElementsNamed: 'person').
	self assert: (namespacedDocument xpath: 'element(Q{undeclared}*)') isEmpty.

	self
		should: [namespacedDocument xpath: 'element(Q{bookNS} *)']
		raise: XPathSyntaxException.
	self
		should: [namespacedDocument xpath: 'element(Q {bookNS}*)']
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementLocalNameWildcardTest
	| persons mappings |

	persons := namespacedDocument allElementsNamed: 'person'.
	mappings := 
		Array
			with: 'one' -> 'bookNS'
			with: 'two' -> 'personNS'.
	self
		assertNodeSet: (namespacedDocument xpath: 'element(book:*)/element(ps:*)')
		hasNodes: persons.
	self assert: (namespacedDocument xpath: 'element(book:*)/element(undeclared:*)') isEmpty.
	self
		assertNodeSet:
			(XPath
				for: 'element(one:*)/element(two:*)'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))
		hasNodes: persons.
	self assert:
		(XPath
			for: 'element(one:*)/element(one:*)'
			in: namespacedDocument
			context: (self contextClass namespaces: mappings)) isEmpty.
	self
		should: [
			(XPath
				for: 'element(undeclared:*)'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))]
		raise: XPathUndeclaredPrefixException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementNameTest
	self
		assertNodeSet: (document xpath: 'element(addressbook)/element(person)')
		hasNodes: (document allElementsNamed: 'person').
	self assert:
		(namespacedDocument xpath: 'element(addressbook)/element(person)') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementPrefixWildcardTest
	| persons |

	persons := namespacedDocument allElementsNamed: 'person'.
	self
		assertNodeSet: (namespacedDocument xpath: 'element(*:addressbook)/element(*:person)')
		hasNodes: persons.
	self assert: (namespacedDocument xpath: 'element(*:addressbook)/element(*:contaxt-info)') isEmpty.
	self
		assertNodeSet:
			(XPath
				for: 'element(one:addressbook)/element(*:person)'
				in: namespacedDocument
				context: (self newContext declarePrefix: 'one' uri: 'bookNS'))
		hasNodes: persons.
	self assert:
		(XPath
			for: 'element(one:addressbook)/element(*:contact-info)'
			in: namespacedDocument
			context: (self newContext declarePrefix: 'one' uri: 'bookNS')) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementQualfiedNameTest
	| persons mappings |

	persons := namespacedDocument allElementsNamed: 'person'.
	mappings := 
		Array
			with: 'zero' -> 'defaultNS'
			with: 'one' -> 'bookNS'
			with: 'two' -> 'personNS'.
	self
		assertNodeSet:
			(namespacedDocument xpath:
				'element(book:addressbook)/element(ps:person)')
		hasNodes: persons.
	self assert:
		(namespacedDocument xpath:
			'element(book:addressbook)/element(undeclared:person)') isEmpty.
	self
		assertNodeSet:
			(XPath
				for: '//element(zero:*)'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))
		hasNodes:
			(namespacedDocument allElementsSelect: [:each |
				each namespaceURI = 'defaultNS']).
	self
		assertNodeSet:
			(XPath
				for: 'element(one:addressbook)/element(two:person)'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))
		hasNodes: persons.
	self assert:
		(XPath
			for: 'element(one:addressbook)/element(one:person)'
			in: namespacedDocument
			context: (self contextClass namespaces: mappings)) isEmpty.

	self
		should: [
			(XPath
				for: 'element(undeclared:addressbook)'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))]
		raise: XPathUndeclaredPrefixException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testElementTypeTest
	self
		assertNodeSet: (document xpath: '//element()')
		hasNodes: document allElements.
	self
		assertNodeSet: (document xpath: '//node()/self::element()')
		hasNodes: document allElements! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testExpandedNameTest
	self
		assertNodeSet:
			(namespacedDocument xpath: 'Q{bookNS}addressbook/Q{personNS}person')
		hasNodes: (namespacedDocument allElementsNamed: 'person').
	self assert: (namespacedDocument xpath: 'Q{undeclared}addressbook') isEmpty.

	self
		should: [namespacedDocument xpath: 'Q{bookNS} addressbook']
		raise: XPathSyntaxException.
	self
		should: [namespacedDocument xpath: 'Q {bookNS}addressbook']
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2017 19:53'!
testExpressionSource
	| query compiled newCompiled |

	query := 'test' asXPath.
	self assert: query expressionSource = 'test'.

	compiled := query compiledExpression.
	self
		assert: compiled notNil;
		assert: query compiledExpression == compiled.

	self
		assert: (query expressionSource: 'test/new') == query;
		assert: query expressionSource = 'test/new'.

	newCompiled := query compiledExpression.
	self
		assert: newCompiled notNil;
		deny: newCompiled == compiled;
		assert: query compiledExpression == newCompiled! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/25/2015 03:32'!
testFalseFunction
	self deny: 'false()' asXPath evaluate.
	self
		should: ['false(1)' asXPath evaluate]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testFileterExpressionPredicates
	self
		assertNodeSet:
			(document xpath: '(./addressbook/*)[position() <= 3 and position() > 1]')
		hasNodes: ((document allElementsNamed: 'person') copyFrom: 2 to: 3).
	self
		assertNodeSet: (document xpath: '(addressbook/*)[true()] / address')
		hasNodes: (document allElementsNamed: 'address').
	self
		assertNodeSet:
			(document xpath: '(addressbook)[true()] // email')
		hasNodes: (document allElementsNamed: 'email').
	self
		assertNodeSet: (document xpath: '(//person[position()>1])[position()<=2]')
		hasNodes: ((document allElementsNamed: 'person') copyFrom: 2 to: 3).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:01'!
testFollowingAxis
	| persons following |

	persons := document allElementsNamed: 'person'.
	following := self newNodeSet.
	persons first followingNodesDo: [:each |
		following addLast: each].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/following::node()'
				in: document)
		hasNodes: following.

	following removeAll.
	persons do: [:person |
		 person firstNode followingNodesDo: [:each |
			following add: each]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/node()/following::node()'
				in: document)
		hasNodes: following.

	following removeAll.
	document descendantNodesDo: [:node |
		node followingNodesDo: [:each |
			following addIfNotPresent: each]].
	self
		assertNodeSet: (XPath for: '//following::node()' in: document)
		hasNodes: following.

	following removeAll.
	persons first followingNodesDo: [:each |
		following addIfNotPresent: each].
	persons third firstNode followingNodesDo: [:each |
		following addIfNotPresent: each].
	self
		assertNodeSet:
			(XPath
				for: '(//person[1]|//person[3]/node()[1])/following::node()'
				in: document)
		hasNodes: following.
	self
		assertNodeSet:
			(XPath
				for: '(//person[1]|//person[last()])/following::node()'
				in: document)
		hasNodes: following.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:01'!
testFollowingSiblingAxis
	| persons siblings |

	persons := document allElementsNamed: 'person'.
	siblings := self newNodeSet.
	siblings addAll: persons allButFirst.
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/following-sibling::person'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons do: [:each | 
		each hasChildren
			ifTrue: [siblings addAll: each nodes allButFirst]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/node()/following-sibling::node()'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons first allNodesDo: [:node |
		node followingSiblingNodesDo: [:each |
			siblings addIfNotPresent: each]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person[1]//following-sibling::node()'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	document allNodesDo: [:node |
		node followingSiblingNodesDo: [:each |
			siblings addIfNotPresent: each]].
	self
		assertNodeSet:
			(XPath
				for: '//following-sibling::node()'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons first followingSiblingNodesDo: [:each |
		siblings addLast: each].
	persons third nodes first followingSiblingNodesDo: [:each |
		siblings addIfNotPresent: each].
	self
		assertNodeSet:
			(XPath
				for: '(//person[1]|//person[3]/node()[1])/following-sibling::node()'
				in: document)
		hasNodes: siblings.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:17'!
testFunctions
	| functionSet |

	functionSet := self functionSetClass default.
	self
		assert: self newContext functions = functionSet;
		deny: self newContext functions == functionSet;
		assert: (self contextClass functions: functionSet) functions == functionSet;
		assert: (self newContext functions: functionSet) functions == functionSet.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/25/2017 02:58'!
testIDFunction
	| dtdWithIDs contentWithIDs contentWithIDsAndUndeclaredAttributes documentWithIDs idElements |

	dtdWithIDs :=
		'<!!DOCTYPE one [
			<!!ELEMENT one ANY>
			<!!ATTLIST one id ID #REQUIRED>
			<!!ELEMENT two ANY>
			<!!ATTLIST two id2 ID #IMPLIED>
			<!!ELEMENT three ANY>
			<!!ATTLIST three
				xml:id ID #REQUIRED
				id3 CDATA #IMPLIED>
			<!!ELEMENT four ANY>
			<!!ATTLIST four id4 ID #REQUIRED>
			<!!ELEMENT five ANY>
			<!!ATTLIST five id CDATA #IMPLIED>
			<!!ELEMENT six ANY>
			<!!ATTLIST six id2 CDATA #IMPLIED>
			<!!ELEMENT seven ANY>
			<!!ATTLIST seven id4 CDATA #IMPLIED>
		]>'.
	contentWithIDs := '
		<one id="first">
			<two/>
			<three xml:id="third" id3="non-id">
				<four id4="fourth">
					<five id="non-id">first</five>
					<six id2="non-id">third</six>
					<seven id4="non-id">non-id</seven>
				</four>
			</three>
		</one>'.
	contentWithIDsAndUndeclaredAttributes := '
		<one id="first">
			<two/>
			<three xml:id="third" id3="non-id">
				<four id4="fourth">
					<five id="non-id">first</five>
					<six id2="non-id">third</six>
					<seven id4="non-id" undeclared="non-id">non-id</seven>
				</four>
			</three>
		</one>'.

	#(true false) do: [:isValidating |
		documentWithIDs :=
			XMLDOMParser
				parse:
					(isValidating
						ifTrue: [dtdWithIDs, contentWithIDs]
						ifFalse: [dtdWithIDs, contentWithIDsAndUndeclaredAttributes])
				usingNamespaces: true
				validation: isValidating.
		idElements :=
			documentWithIDs allElementsSelect: [:each |
				each isNamedAny: #('one' 'three')].
		self
			assertNodeSet: (documentWithIDs xpath: 'id("   third  first non-id  ")')
			hasNodes: idElements.
		self
			assertNodeSet: (documentWithIDs xpath: 'id("first third non-id")')
			hasNodes: idElements.
		self
			assertNodeSet: (documentWithIDs xpath: 'id(//*)')
			hasNodes: idElements].

	"xml:id attributes should always be recognized, even without a DTD"
	#(true false) do: [:isValidating |
		documentWithIDs :=
			XMLDOMParser
				parse: contentWithIDsAndUndeclaredAttributes
				usingNamespaces: true
				validation: isValidating.
		idElements :=
			documentWithIDs allElementsSelect: [:each |
				each isNamedAny: #('three')].
		self
			assertNodeSet: (documentWithIDs xpath: 'id("  third  first  non-id  ")')
			hasNodes: idElements.
		self
			assertNodeSet: (documentWithIDs xpath: 'id("first third non-id")')
			hasNodes: idElements.
		self
			assertNodeSet: (documentWithIDs xpath: 'id(//*)')
			hasNodes: idElements].! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2017 20:18'!
testInvalidAbbreviatedLocationPath
	self
		should: ['/ /one' asXPath compileExpression]
		raise: XPathSyntaxException.
	self
		should: ['one/ /two' asXPath compileExpression]
		raise: XPathSyntaxException.
	self
		should: ['//' asXPath compileExpression]
		raise: XPathSyntaxException.
	self
		should: ['//one/' asXPath compileExpression]
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testInvalidFilterExpressionRootType
	#('1[1]' '"string"[position()=1]' 'true()[true()]'
		'(1)[1]' '("string")[position()=1]' '(true())[true()]'
		'1/addressbook' '"string"/addressbook' 'true()/addressbook'
		'(1)/addressbook' '("string")/addressbook' '(true())/addressbook')
		do: [:each |
			self
				should: [document xpath: each]
				raise: XPathTypeException]! !

!XPathTest methodsFor: 'tests' stamp: 'monty 4/12/2015 12:55'!
testInvalidNumberTokenizing
	self
		should: ['. 1' asXPath evaluate]
		raise: XPathSyntaxException.
	self
		should: ['1 .' asXPath evaluate]
		raise: XPathSyntaxException.
	self
		should: ['.1.2' asXPath evaluate]
		raise: XPathSyntaxException.
	self
		should: ['1.2.' asXPath evaluate]
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testInvalidUnionExpressionType
	#('//person | 1' '1 | //person'
		'//person | true()' 'true() | //person'
		'//person | "string"' '"string" | //person') do: [:each |
		self
			should: [document xpath: each]
			raise: XPathTypeException].! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testLangFunction
	| langElement docWithLangElements |

	(langElement := XMLElement named: 'test')
		attributeAt: 'xml:lang' put: 'en-us'.
	self
		assert: ('lang("En")' asXPath in: langElement);
		assert: ('lang("en-US")' asXPath in: langElement);
		deny: ('lang("en-UK")' asXPath in: langElement);
		deny: ('lang("DE")' asXPath in: langElement).

	langElement attributeAt: 'xml:lang' put: 'En'.
	self
		assert: ('lang("En")' asXPath in: langElement);
		deny: ('lang("en-US")' asXPath in: langElement);
		deny: ('lang("en-UK")' asXPath in: langElement);
		deny: ('lang("DE")' asXPath in: langElement).

	"from the spec"
	docWithLangElements :=
		XMLDOMParser parse:
			'<doc>
				<para xml:lang="en"/>
				<div xml:lang="en"><para/></div>
				<para xml:lang="EN"/>
				<para xml:lang="en-us"/>
			</doc>'.
	self
		assertNodeSet:
			(docWithLangElements xpath: '/descendant-or-self::*[lang("en")]')
		hasNodes:
			docWithLangElements root descendantElements.
	self
		assertNodeSet:
			(docWithLangElements xpath: '/descendant-or-self::*[lang("en-us")]')
		hasNodes:
			(XMLNodeList with: docWithLangElements descendantElements last).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:39'!
testLastFunction
	| path elements |

	path := XPath for: 'last()'.
	self assert: (path in: document) = 1.

	path := XPath for: 'last()'.
	elements := document allElementsNamed: 'person'.
	elements do: [:each | self assert: (path in: each) = 1].

	path := XPath for: 'addressbook/person[last()]'.
	self
		assertNodeSet: (path in: document)
		hasNodes: (XMLNodeList with: elements last).

	path := XPath for: 'addressbook/descendant::node()[last()]'.
	self
		assertNodeSet: (path in: document)
		hasNodes: (XMLNodeList with: document allNodes last).

	path := XPath for: 'addressbook//node()[last()]'.
	self
		assertNodeSet: (path in: document)
		hasNodes: (document root descendantNodesSelect: [:each | each nextNode isNil]).

	self
		should: ['last(0)' asXPath evaluate]
		raise: XPathException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/18/2015 16:17'!
testLocalNameFunction
	self assert:
		(XPath
			for: 'local-name(addressbook/person[1]/*[last()]/preceding::*)'
			in: document) = 'contact-info'.
	self assert:
		(XPath
			for: 'local-name(addressbook/absent)'
			in: document) isEmpty.
	self assert:
		(XPath
			for: 'local-name(//comment())'
			in: document) isEmpty.
	self assert:
		(XPath
			for: 'local-name()'
			in: document root) = 'addressbook'.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testLocalNameWildcardTest
	| persons mappings |

	persons := namespacedDocument allElementsNamed: 'person'.
	mappings := 
		Array
			with: 'one' -> 'bookNS'
			with: 'two' -> 'personNS'.
	self
		assertNodeSet: (namespacedDocument xpath: 'book:*/ps:*')
		hasNodes: persons.
	self assert: (namespacedDocument xpath: 'book:*/undeclared:*') isEmpty.
	self
		assertNodeSet:
			(XPath
				for: 'one:*/two:*'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))
		hasNodes: persons.
	self assert:
		(XPath
			for: 'one:*/one:*'
			in: namespacedDocument
			context: (self contextClass namespaces: mappings)) isEmpty.

	self
		should: [
			(XPath
				for: 'undeclared:*'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))]
		raise: XPathUndeclaredPrefixException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testLocationPathPredicates
	self
		assertNodeSet:
			(document xpath: '/descendant::home-phone[1][2 - 1][position() = 1]')
		hasNodes:
			(XMLNodeList with: (document allElementsNamed: 'home-phone') first).
	self assert:
		(document xpath: '/descendant::home-phone[1][position() + 1]') isEmpty.

	self
		assertNodeSet:
			(document xpath: '//home-phone[1][1 + 0][position() = 1]')
		hasNodes:
			(document allElementsNamed: 'home-phone') allButLast.
	self
		assertNodeSet:
			(document xpath: '//home-phone[1 + 1][1][position() = 1]')
		hasNodes:
			(XMLNodeList with: (document allElementsNamed: 'home-phone') third).
	self assert:
		(document xpath: '//home-phone[position() = 1][1 + 1]') isEmpty.

	self
		assertNodeSet:
			(document xpath: '/descendant::home-phone[2][1 + 0][position() = 1]')
		hasNodes:
			(XMLNodeList with: (document allElementsNamed: 'home-phone') second).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/8/2017 21:28'!
testLogicalOperators
	self
		deny: '0 or 0 or 0' asXPath evaluate;
		assert: '0 or 0 or 1' asXPath evaluate;
		deny: '1 and 1 and 0' asXPath evaluate;
		assert: '1 and 1 and 2' asXPath evaluate;
		deny: '0 or 1 and 0' asXPath evaluate;
		assert: '1 and (0 or 1)' asXPath evaluate;
		assert: '0 and 0 or 1 and 1' asXPath evaluate;
		deny: '0 and 1 or 1 and 0' asXPath evaluate! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testModulus
	#('5 mod 2' '5 mod -2' '$var mod 2' '$var mod -2') do: [:each |
		self assert:
			(each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: 5;
						yourself)) = 1].

	#('-5 mod 2' '-5 mod -2' '$var mod 2' '$var mod -2') do: [:each |
		self assert:
			(each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: -5;
						yourself)) = -1].

	#('6 mod 3' '6 mod -3' '$var mod 3' '$var mod -3') do: [:each | | result |
		result :=
			each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: 6.0;
						yourself).
		self assert: result isXPathPositiveZero].

	#('-6 mod 3' '-6 mod -3' '$var mod 3' '$var mod -3') do: [:each | | result |
		result :=
			each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: -6.0;
						yourself).
		self assert: result isXPathNegativeZero].

	#('0.0 mod 0' '0.0 mod -.0' '$var mod 0' '$var mod -.0') do: [:each |
		self assert:
			(each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: 0.0;
						yourself)) isNaN].

	#('-0.0 mod 0' '-0.0 mod -.0' '$var mod 0' '$var mod -.0') do: [:each |
		self assert:
			(each asXPath
				in: nil
				context:
					(XPathContext new
						variableAt: 'var' put: Float xpathNegativeZero;
						yourself)) isNaN].! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:15'!
testNameFunction
	| element |

	(element := XMLElement named: 'test')
		addNode: (XMLElement named: 'test-two');
		addNode: 'test-three' asXMLStringNode.
	self
		assert: (XPath for: 'name()' in: element) = 'test';
		assert: (XPath for: 'name(//.)' in: element) = 'test'.

	element name: 'test' namespaceURI: 'defaultNS'.
	self assert: (XPath for: 'name()' in: element) = 'test'.
	self assert:
		(XPath
			for: 'name()'
			in: element
			context:
				(self newContext
					declarePrefix: 'one'
					uri: 'defaultNS')) = 'test'.

	element name: 'prefix:test' namespaceURI: 'prefixNS'.
	self assert: (XPath for: 'name()' in: element) = 'prefix:test'.
	self assert:
		(XPath
			for: 'name()'
			in: element
			context:
				(self newContext
					declarePrefix: 'two'
					uri: 'prefixNS')) = 'two:test'.

	self assert: (XPath for: 'name(//text())' in: element) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNamespaceAxis
	| nodes |

	nodes := self newNodeSet.
	namespacedDocument allElementsDo: [:each |
		nodes
			add: (XPathNamespaceNode withXMLNamespaceOnElement: each);
			add: (XPathNamespaceNode element: each name: '' uri: 'defaultNS');
			add: (XPathNamespaceNode element: each name: 'book' uri: 'bookNS');
			add: (XPathNamespaceNode element: each name: 'ps' uri: 'personNS')].
	self assert: nodes size = (namespacedDocument allElements size * 4).
	self
		assertNodeSet: (namespacedDocument xpath: '//namespace::*')
		hasNodes: nodes.
	self
		assertNodeSet: (namespacedDocument xpath: '//namespace::book')
		hasNodes: (nodes select: [:each | each name ='book']).

	"namespace nodes can't be prefixed or namespaced themselves:"
	self
		assert: (namespacedDocument xpath: '//namespace::book:*') isEmpty;
		assert: (namespacedDocument xpath: '//namespace::book/namespace::book') isEmpty.

	self
		assertNodeSet: (document xpath: '//namespace::*')
		hasNodes:
			(document allElementsCollect: [:each |
				XPathNamespaceNode withXMLNamespaceOnElement: each]).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNamespaceNameTest
	self
		assertNodeSet: (document xpath: '//namespace::namespace( xml )')
		hasNodes: (document allElements collect: [:each | each namespaceNodes first]).

	self assert: (document xpath: '//namespace::namespace( undeclared )') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNamespaceTypeTest
	| results |

	results := XMLNodeList new.
	namespacedDocument allNodesDo: [:each |
		each isElement
			ifTrue: [results addAll: each namespaceNodes]
			ifFalse: [
				each isStringNode
					ifTrue: [results addLast: each]]].
	self
		assertNodeSet:
			(namespacedDocument xpath: '//namespace::node() | //text()')
		hasNodes: results.
	self
		assertNodeSet:
			(namespacedDocument xpath:
				'(//namespace::node() | //text())/ self :: namespace()')
		hasNodes: (results select: [:each | each isNamespace]).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNamespaceURIFunction
	self
		assert: (document xpath: 'namespace-uri(/*)') isEmpty;
		assert: (document root xpath: 'namespace-uri()') isEmpty;
		assert: (document xpath: 'namespace-uri(/*/*)') isEmpty;
		assert: (namespacedDocument xpath: 'namespace-uri(/*)') = 'bookNS';
		assert: (namespacedDocument root xpath: 'namespace-uri()') = 'bookNS';
		assert: (namespacedDocument xpath: 'namespace-uri(/*/*)') = 'personNS'! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testNegation
	self
		assert: '-0.0' asXPath evaluate isXPathNegativeZero;
		assert: '--0.0' asXPath evaluate isXPathPositiveZero;
		assert: '---0.0' asXPath evaluate isXPathNegativeZero;
		assert: '-1.0' asXPath evaluate = -1.0;
		assert: '--1.0' asXPath evaluate = 1.0;
		assert: '---1.0' asXPath evaluate = -1.0;
		assert: '-(1 div 0)' asXPath evaluate = Float xpathNegativeInfinity;
		assert: '--(1 div 0)' asXPath evaluate = Float infinity;
		assert: '---(1 div 0)' asXPath evaluate = Float xpathNegativeInfinity;
		assert: '-"test"' asXPath evaluate isNaN;
		assert: '--"test"' asXPath evaluate isNaN;
		assert: '---"test"' asXPath evaluate isNaN! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/13/2015 21:33'!
testNestedFunctionCalls
	self
		assert: 'number(ceiling(3.5) + floor(1.5))' asXPath evaluate = 5;
		assert: 'contains(concat(concat("one", "two"), string("three")), "two")' asXPath evaluate! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetAndBooleanComparing
	self assert:
		('<list><a>not-empty</a></list>' parseXML xpath:
			'list/b < true()
				and list/b <= true()
				and list/a > false()
				and list/a >= false()
				and false() < list/a
				and true() <= list/a
				and true() > list/b
				and false() >= list/b
				and not(list/b < false())
				and not(list/a <= false())
				and not(list/b > true())
				and not(list/b >= true())
				and not(true() < list/a)
				and not(true() <= list/b)
				and not(true() > list/a)
				and not(false() >= list/a)')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetAndNonNodeSetEquality
	self assert:
		('<list><a>1</a><a>two</a></list>' parseXML xpath:
			'list/a = 1.0
				and 1.0 = list/a
				and not(list/a = 2.0)
				and not(2.0 = list/a)
				and list/a = "two"
				and "two" = list/a
				and not(list/a = "one")
				and not("one" = list/a)
				and list/a = true()
				and true() = list/a
				and not(list/absent = true())
				and not(true() = list/absent)')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetAndNonNodeSetInequality
	self assert:
		('<list><a>1</a><b>two</b></list>' parseXML xpath:
			'list/a !!= 2.0
				and 2.0 !!= list/a
				and not(list/a !!= 1.0)
				and not(1.0 !!= list/a)
				and list/b !!= "one"
				and "one" !!= list/b
				and not(list/b !!= "two")
				and not("two" !!= list/b)
				and list/a !!= false()
				and false() !!= list/a
				and list/absent !!= true()
				and true() !!= list/absent')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetAndNumberComparing
	self assert:
		('<list><a>1</a><a>2</a></list>' parseXML xpath:
			'list/a < 2
				and list/a <= 1
				and list/a > 1
				and list/a >= 2
				and 1 < list/a
				and 2 <= list/a
				and 2 > list/a
				and 2 >= list/a
				and not(list/a < 1)
				and not(list/a <= 0)
				and not(list/a > 3)
				and not(list/a >= 3)
				and not(3 < list/a)
				and not(3 <= list/a)
				and not(0 > list/a)
				and not(0 >= list/a)')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetComparing
	self assert:
		('<list>
			<a>1</a><a>2</a><a>3</a>
			<b>0</b>
			<c>4</c>
		</list>' parseXML xpath:
			'list/a < list/a
				and list/a <= list/a
				and list/a > list/a
				and list/a >= list/a
				and list/b < list/a
				and list/b <= list/a
				and not(list/b > list/a)
				and not(list/b >= list/a)
				and not(list/c < list/a)
				and not(list/c <= list/a)
				and list/c > list/a
				and list/c >= list/a')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNodeSetEquality
	self assert:
		('<list>
			<a>one</a><a>two</a><a>three</a>
			<b>four</b>
		</list>' parseXML xpath:
			'list/a = list/a
				and list/a !!= list/a
				and not(list/b = list/a)
				and list/b !!= list/a
				and not(list/absent = list/a)
				and not(list/absent = list/absent)
				and not(list/absent !!= list/a)
				and not(list/absent !!= list/absent)')! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/28/2017 08:31'!
testNormalizeSpaceFunction
	self assert:
		'normalize-space("
		    one		  
		    two
		    three
		")' asXPath evaluate = 'one two three'.
	self assert: 'normalize-space(" 	")' asXPath evaluate = ''.

	"if the argument is omitted, use a node set with the context node"
	self assert:
		('normalize-space()' asXPath in:
			'<test>
			    one		  
			    two
			    three
			</test>' parseXML) = 'one two three'.
	self assert:
		('normalize-space()' asXPath in: '<test> 	</test>' parseXML) = ''.

	self
		should: ['normalize-space("one","two three")' asXPath evaluate]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testNotFunction
	self	
		deny: 'not(true())' asXPath evaluate;
		assert: 'not(false())' asXPath evaluate;
		deny: 'not(1) or not("1")' asXPath evaluate;
		assert: 'not(0) and not("")' asXPath evaluate;
		deny: (document xpath: 'not(/node())');
		assert: (document xpath: 'not(/text())').
	self
		should: ['not()' asXPath evaluate]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/28/2017 08:23'!
testNumberFunction
	self
		assert: 'number("123")' asXPath evaluate = 123;
		assert: 'number(123)' asXPath evaluate = 123;
		assert: 'number(true())' asXPath evaluate = 1;
		assert: 'number(false())' asXPath evaluate = 0.

	"if the argument is omitted, use a node set with the context node"
	self assert:
		('number()' asXPath in: '<test>123</test>' parseXML) = 123.

	self
		should: ['number(1, 23)' asXPath evaluate]
		raise: XPathArgumentNumberException.
! !

!XPathTest methodsFor: 'tests' stamp: 'monty 4/13/2015 06:02'!
testNumberTokenizing
	self
		assert: ' 1 ' asXPath evaluate = 1;
		assert: ' 12 ' asXPath evaluate = 12;
		assert: ' 1.5 ' asXPath evaluate = 1.5;
		assert: ' 12.5 ' asXPath evaluate = 12.5;
		assert: ' -1 ' asXPath evaluate = -1;
		assert: ' -12 ' asXPath evaluate = -12;
		assert: ' -1.5 ' asXPath evaluate = -1.5;
		assert: ' -12.5 ' asXPath evaluate = -12.5;
		assert: ' .1 ' asXPath evaluate = 0.1;
		assert: ' .12 ' asXPath evaluate = 0.12;
		assert: ' -.1 ' asXPath evaluate = -0.1;
		assert: ' -.12 ' asXPath evaluate = -0.12! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/15/2015 04:12'!
testOneLevel
	| path results |
	path := XPath for: 'addressbook/person'.
	results := path in: document.
	self assert: (results size = 4).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedAttributeAxis
	| attributes |

	attributes := (document findElementNamed: 'person') attributeNodes.
	self
		assertNodeSet: (document xpath: 'addressbook/person[1]/@node()')
		hasNodes: attributes.
	self
		assertNodeSet: (document xpath: 'addressbook/person[1]/@*')
		hasNodes: attributes.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:00'!
testOptimizedAttributeAxisWithPositionPredicate
	| result attributes |

	attributes :=
		(document allElementsNamed: 'person')
			collect: [:each | each attributeNodes first].
	result := document xpath: '//person/@employee-number[1]'.
	self
		assertNodeSet: result
		hasNodes: attributes.
	result := document xpath: '//person/@employee-number[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: attributes.
	self
		assert: (document xpath: '//person/@employee-number[0]') isEmpty;
		assert: (document xpath: '//person/@employee-number[1.2]') isEmpty;
		assert: (document xpath: '//person/@employee-number[1][2]') isEmpty.

	attributes :=
		(document allElementsNamed: 'person')
			collect: [:each | each attributeNodes second].
	result := document xpath: '//person/@*[2]'.
	self
		assertNodeSet: result
		hasNodes: attributes.
	result := document xpath: '//person/@*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: attributes.
	self
		assert: (document xpath: '//person/@*[0]') isEmpty;
		assert: (document xpath: '//person/@*[2.2]') isEmpty;
		assert: (document xpath: '//person/@*[2][2]') isEmpty.

	attributes :=
		(document allElementsNamed: 'person') first attributeNodes.
	result :=
		document xpath:
			'addressbook/person[1]/@*[', attributes size asString, ']'.
	self
		assertNodeSet: result
		hasNodes: (XMLNodeList with: attributes last).
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	result :=
		document xpath:
			'addressbook/person[1]/@*[', (attributes size + 1) asString, ']'.
	self assert: result isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/15/2017 20:03'!
testOptimizedChildAxisWithPositionPredicate
	| result children |

	children :=
		XMLNodeList with:
			(document allElementsNamed: 'person') first.
	result := document xpath: 'addressbook/person[1]'.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: 'addressbook/person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: 'addressbook/person[0]') isEmpty;
		assert: (document xpath: 'addressbook/person[1.2]') isEmpty;
		assert: (document xpath: 'addressbook/person[1][2]') isEmpty.

	children :=
		XMLNodeList with:
			(document allElementsNamed: 'person') second.
	result := document xpath: 'addressbook/*[2]'.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: 'addressbook/*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: children.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: 'addressbook/*[0]') isEmpty;
		assert: (document xpath: 'addressbook/*[2.2]') isEmpty;
		assert: (document xpath: 'addressbook/*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:00'!
testOptimizedDescendantAxisWithPositionPredicate
	| result descendants |

	descendants :=
		XMLNodeList with:
			(document allElementsNamed: 'person') first.
	result := document xpath: 'descendant::person[1]'.
	self
		assertNodeSet: result
		hasNodes: descendants.
	result := document xpath: 'descendant::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: descendants.
	self
		assert: (document xpath: 'descendant::person[0]') isEmpty;
		assert: (document xpath: 'descendant::person[1.2]') isEmpty;
		assert: (document xpath: 'descendant::person[1][2]') isEmpty.

	descendants :=
		XMLNodeList with:
			document descendantElements second.
	result := document xpath: 'descendant::*[2]'.
	self
		assertNodeSet: result
		hasNodes: descendants.
	result := document xpath: 'descendant::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: descendants.
	self
		assert: (document xpath: 'descendant::*[0]') isEmpty;
		assert: (document xpath: 'descendant::*[2.2]') isEmpty;
		assert: (document xpath: 'descendant::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:01'!
testOptimizedDescendantOrSelfAxisWithPositionPredicate
	| result nodes |

	nodes :=
		XMLNodeList with:
			(document allElementsNamed: 'person') first.
	result := document xpath: 'descendant-or-self::person[1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	result := document xpath: 'descendant-or-self::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	self
		assert: (document xpath: 'descendant-or-self::person[0]') isEmpty;
		assert: (document xpath: 'descendant-or-self::person[1.2]') isEmpty;
		assert: (document xpath: 'descendant-or-self::person[1][2]') isEmpty.

	nodes :=
		XMLNodeList with:
			document allElements second.
	result := document xpath: 'descendant-or-self::*[2]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	result := document xpath: 'descendant-or-self::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	self
		assert: (document xpath: 'descendant-or-self::*[0]') isEmpty;
		assert: (document xpath: 'descendant-or-self::*[2.2]') isEmpty;
		assert: (document xpath: 'descendant-or-self::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:07'!
testOptimizedFollowingAxisWithPositionPredicate
	| result following |

	following :=
		XMLNodeList with:
			(document allElementsNamed: 'address') second.
	result := document xpath: '//person[1]/following::address[1]'.
	self
		assertNodeSet: result
		hasNodes: following.
	result := document xpath: '//person[1]/following::address[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: following.
	self
		assert: (document xpath: '//person[1]/following::address[0]') isEmpty;
		assert: (document xpath: '//person[1]/following::address[1.2]') isEmpty;
		assert: (document xpath: '//person[1]/following::address[1][2]') isEmpty.

	following :=
		XMLNodeList with:
			(document allElementsNamed: 'person') second firstElement.
	result := document xpath: '//person[1]/following::*[2]'.
	self
		assertNodeSet: result
		hasNodes: following.
	result := document xpath: '//person[1]/following::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: following.
	self
		assert: (document xpath: '//person[1]/following::*[0]') isEmpty;
		assert: (document xpath: '//person[1]/following::*[2.2]') isEmpty;
		assert: (document xpath: '//person[1]/following::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/15/2017 23:01'!
testOptimizedFollowingSiblingAxisWithPositionPredicate
	| result followingSiblings |

	followingSiblings :=
		XMLNodeList with:
			(document allElementsNamed: 'person') second.
	result := document xpath: '//person[1]/following-sibling::person[1]'.
	self
		assertNodeSet: result
		hasNodes: followingSiblings.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: '//person[1]/following-sibling::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: followingSiblings.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: '//person[1]/following-sibling::address[1]') isEmpty;
		assert: (document xpath: '//person[1]/following-sibling::person[0]') isEmpty;
		assert: (document xpath: '//person[1]/following-sibling::person[1.2]') isEmpty;
		assert: (document xpath: '//person[1]/following-sibling::person[1][2]') isEmpty.

	followingSiblings :=
		XMLNodeList with:
			(document allElementsNamed: 'person') third.
	result := document xpath: '//person[1]/following-sibling::*[2]'.
	self
		assertNodeSet: result
		hasNodes: followingSiblings.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: '//person[1]/following-sibling::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: followingSiblings.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: '//person[1]/following-sibling::*[0]') isEmpty;
		assert: (document xpath: '//person[1]/following-sibling::*[2.2]') isEmpty;
		assert: (document xpath: '//person[1]/following-sibling::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:07'!
testOptimizedNamespaceAxisWithPositionPredicate
	| result namespaces |

	namespaces :=
		(namespacedDocument allElementsNamed: 'person')
			collect: [:element |
				element namespaceNodes detect: [:each | each name = 'ps']].
	result := namespacedDocument xpath: '//ps:person/namespace::ps[1]'.
	self
		assertNodeSet: result
		hasNodes: namespaces.
	result := namespacedDocument xpath: '//ps:person/namespace::ps[1]'.
	self
		assertNodeSet: result
		hasNodes: namespaces.
	self
		assert: (namespacedDocument xpath: '//ps:person/namespace::ps[0]') isEmpty;
		assert: (namespacedDocument xpath: '//ps:person/namespace::ps[1.2]') isEmpty;
		assert: (namespacedDocument xpath: '//ps:person/namespace::ps[1][2]') isEmpty.

	namespaces :=
		(namespacedDocument allElementsNamed: 'person')
			collect: [:each | each namespaceNodes second].
	result := namespacedDocument xpath: '//ps:person/namespace::*[2]'.
	self
		assertNodeSet: result
		hasNodes: namespaces.
	result := namespacedDocument xpath: '//ps:person/namespace::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: namespaces.
	self
		assert: (namespacedDocument xpath: '//ps:person/namespace::*[0]') isEmpty;
		assert: (namespacedDocument xpath: '//ps:person/namespace::*[2.2]') isEmpty;
		assert: (namespacedDocument xpath: '//ps:person/namespace::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:07'!
testOptimizedParentAxisWithPositionPredicate
	| result parents |

	parents := document allElementsNamed: 'person'.
	result := document xpath: '//address/parent::person[1]'.
	self
		assertNodeSet: result
		hasNodes: parents.
	result := document xpath: '//address/parent::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: parents.
	self
		assert: (document xpath: '//address/parent::person[0]') isEmpty;
		assert: (document xpath: '//address/parent::person[1.2]') isEmpty;
		assert: (document xpath: '//address/parent::person[1][2]') isEmpty.

	result := document xpath: '//address/parent::*[1]'.
	self
		assertNodeSet: result
		hasNodes: parents.
	result := document xpath: '//address/parent::*[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: parents.
	self
		assert: (document xpath: '//address/parent::*[0]') isEmpty;
		assert: (document xpath: '//address/parent::*[1.2]') isEmpty;
		assert: (document xpath: '//address/parent::*[1][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/17/2017 22:27'!
testOptimizedPrecedingAxisWithPositionPredicate
	| result preceding |

	preceding :=
		XMLNodeList with:
			(document allElementsNamed: 'address') first.
	result := document xpath: '//person[2]/preceding::address[1]'.
	self
		assertNodeSet: result
		hasNodes: preceding.
	result := document xpath: '//person[2]/preceding::address[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: preceding.
	self
		assert: (document xpath: '//person[2]/preceding::address[0]') isEmpty;
		assert: (document xpath: '//person[2]/preceding::address[1.2]') isEmpty;
		assert: (document xpath: '//person[2]/preceding::address[1][2]') isEmpty.

	preceding :=
		XMLNodeList with:
			(document allElementsNamed: 'person')
				first allElements reversed second.
	result := document xpath: '//person[2]/preceding::*[2]'.
	self
		assertNodeSet: result
		hasNodes: preceding.
	result := document xpath: '//person[2]/preceding::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: preceding.
	self
		assert: (document xpath: '//person[2]/preceding::*[0]') isEmpty;
		assert: (document xpath: '//person[2]/preceding::*[2.2]') isEmpty;
		assert: (document xpath: '//person[2]/preceding::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/17/2017 22:31'!
testOptimizedPrecedingSiblingAxisWithPositionPredicate
	| result precedingSibling |

	precedingSibling :=
		XMLNodeList with:
			(document allElementsNamed: 'person') first.
	result := document xpath: '//person[2]/preceding-sibling::person[1]'.
	self
		assertNodeSet: result
		hasNodes: precedingSibling.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: '//person[2]/preceding-sibling::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: precedingSibling.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: '//person[2]/preceding-sibling::address[1]') isEmpty;
		assert: (document xpath: '//person[2]/preceding-sibling::person[0]') isEmpty;
		assert: (document xpath: '//person[2]/preceding-sibling::person[1.2]') isEmpty;
		assert: (document xpath: '//person[2]/preceding-sibling::person[1][2]') isEmpty.

	result := document xpath: '//person[3]/preceding-sibling::*[2]'.
	self
		assertNodeSet: result
		hasNodes: precedingSibling.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	result := document xpath: '//person[3]/preceding-sibling::*[2.0][1]'.
	self
		assertNodeSet: result
		hasNodes: precedingSibling.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self
		assert: (document xpath: '//person[3]/preceding-sibling::*[0]') isEmpty;
		assert: (document xpath: '//person[3]/preceding-sibling::*[2.2]') isEmpty;
		assert: (document xpath: '//person[3]/preceding-sibling::*[2][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateAttributeAxis
	| attributes |

	attributes :=
		document allElementsSelect: [:each |
			(each isNamed: 'address')
				and: [(each attributeAt: 'city') notEmpty]].
	self
		assertNodeSet: (document xpath: '//address[@city]')
		hasNodes: attributes.
	self
		assertNodeSet: (document xpath: '//address[@city[true()]]')
		hasNodes: attributes.
	self
		assertNodeSet: (document xpath: '//address[./@city]')
		hasNodes: attributes.
	self
		assert: (document xpath: '//address[@absent]') isEmpty;
		assert: (document xpath: '//address[@city[false()]]') isEmpty;
		assert: (document xpath: '//address[./@absent]') isEmpty.

	attributes :=
		document allElementsSelect: [:each |
			(each isNamed: 'address')
				and: [each hasAttributes
					and: [(each attributeAt: 'city') = 'New York']]].
	self
		assertNodeSet: (document xpath: '//address[@city = "New York"]')
		hasNodes: attributes.
	self
		assertNodeSet: (document xpath: '//address[@city[true()] = "New York"]')
		hasNodes: attributes.
	self
		assertNodeSet: (document xpath: '//address[./@city = "New York"]')
		hasNodes: attributes.
	self
		assert: (document xpath: '//address[@city = "Absent"]') isEmpty;
		assert: (document xpath: '//address[@city[false()] = "New York"]') isEmpty;
		assert: (document xpath: '//address[./@city = "Absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateChildAxis
	| children |

	children := document allElementsNamed: 'person'.
	self
		assertNodeSet: (document xpath: '//*[address]')
		hasNodes: children.
	self
		assertNodeSet: (document xpath: '//*[address[true()]]')
		hasNodes: children.
	self
		assertNodeSet: (document xpath: '//*[./address]')
		hasNodes: children.
	self
		assert: (document xpath: '//*[absent]') isEmpty;
		assert: (document xpath: '//*[address[false()]]') isEmpty;
		assert: (document xpath: '//*[./absent]') isEmpty.

	children :=
		textDocument allElementsSelect: [:element |
			(element isNamed: 'b')
				and: [
					(element elementsAt: 'c') anySatisfy: [:each |
						each stringValue = 'two']]].
	self
		assertNodeSet: (textDocument xpath: '//b[c = "two"]')
		hasNodes: children.
	self
		assertNodeSet: (textDocument xpath: '//b[c[true()] = "two"]')
		hasNodes: children.
	self
		assertNodeSet: (textDocument xpath: '//b[./c = "two"]')
		hasNodes: children.
	self
		assert: (textDocument xpath: '//b[c = "absent"]') isEmpty;
		assert: (textDocument xpath: '//b[c[false()] = "two"]') isEmpty;
		assert: (textDocument xpath: '//b[./c = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateDescendantAxis
	| descendants |

	descendants :=
		document allElementsSelect: [:element |
			(element descendantElementsDetect: [:each |
				each isNamed: 'address']) notNil].
	self
		assertNodeSet: (document xpath: '//*[descendant::address]')
		hasNodes: descendants.
	self
		assertNodeSet: (document xpath: '//*[descendant::address[true()]]')
		hasNodes: descendants.
	self
		assertNodeSet: (document xpath: '//*[./descendant::address]')
		hasNodes: descendants.
	self
		assert: (document xpath: '//*[descendant::absent]') isEmpty;
		assert: (document xpath: '//*[descendant::address[false()]]') isEmpty;
		assert: (document xpath: '//*[./descendant::absent]') isEmpty.

	descendants :=
		textDocument descendantNodesSelect: [:node |
			node hasChildren
				and: [
					(node descendantNodesDetect: [:each |
						each stringValue = 'two']) notNil]].
	self
		assertNodeSet:
			(textDocument xpath: '//node()[descendant::node() = "two"]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[descendant::node()[true()] = "two"]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[./descendant::node() = "two"]')
		hasNodes: descendants.
	self
		assert:
			(textDocument xpath: '//node()[descendant::node() = "absent"]') isEmpty;
		assert:
			(textDocument xpath: '//node()[descendant::node()[false()] = "two"]') isEmpty;
		assert:
			(textDocument xpath: '//node()[./descendant::node() = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateDescendantOrSelfAxis
	| descendants |

	descendants :=
		document allElementsSelect: [:element |
			(element allElementsDetect: [:each |
				each isNamed: 'address']) notNil].
	self
		assertNodeSet:
			(document xpath: '//*[descendant-or-self::address]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(document xpath: '//*[descendant-or-self::address[true()]]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(document xpath: '//*[./descendant-or-self::address]')
		hasNodes: descendants.
	self
		assert:
			(document xpath: '//*[descendant-or-self::absent]') isEmpty;
		assert:
			(document xpath: '//*[descendant-or-self::address[false()]]') isEmpty;
		assert:
			(document xpath: '//*[./descendant-or-self::absent]') isEmpty.

	descendants :=
		textDocument descendantNodesSelect: [:node |
			node hasChildren
				ifTrue: [
					(node allNodesDetect: [:each |
						each stringValue = 'two']) notNil]
				ifFalse: [node stringValue = 'two']].
	self
		assertNodeSet:
			(textDocument xpath:
				'//node()[descendant-or-self::node() = "two"]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(textDocument xpath:
				'//node()[descendant-or-self::node()[true()] = "two"]')
		hasNodes: descendants.
	self
		assertNodeSet:
			(textDocument xpath:
				'//node()[./descendant-or-self::node() = "two"]')
		hasNodes: descendants.
	self
		assert:
			(textDocument xpath:
				'//node()[descendant-or-self::node() = "absent"]') isEmpty;
		assert:
			(textDocument xpath:
				'//node()[descendant-or-self::node()[false()] = "two"]') isEmpty;
		assert:
			(textDocument xpath:
				'//node()[./descendant-or-self::node() = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateFollowingAxis
	| following |

	following :=
		document allElements select: [:element |
			element followingNodes anySatisfy: [:each |
				each isElementNamed: 'address']].
	self
		assertNodeSet: (document xpath: '//*[following::address]')
		hasNodes: following.
	self
		assertNodeSet: (document xpath: '//*[following::address[true()]]')
		hasNodes: following.
	self
		assertNodeSet: (document xpath: '//*[./following::address]')
		hasNodes: following.
	self
		assert: (document xpath: '//*[following::absent]') isEmpty;
		assert: (document xpath: '//*[following::node()[false()]]') isEmpty;
		assert: (document xpath: '//*[./following::absent]') isEmpty.

	following :=
		textDocument allNodesSelect: [:node |
			(node followingNodes collect: [:each | each stringValue])
				includes: 'two'].
	self
		assertNodeSet:
			(textDocument xpath: '//node()[following::node() = "two"]')
		hasNodes: following.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[following::node()[true()] = "two"]')
		hasNodes: following.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[./following::node() = "two"]')
		hasNodes: following.
	self
		assert:
			(document xpath: '//node()[following::node() = "absent"]') isEmpty;
		assert:
			(document xpath: '//node()[following::node()[false()] = "two"]') isEmpty;
		assert:
			(document xpath: '//node()[./following::node() = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateFollowingSiblingAxis
	| followingSiblings |

	followingSiblings :=
		document allElements select: [:element |
			element followingSiblingNodes anySatisfy: [:each |
				each isElementNamed: 'address']].
	self
		assertNodeSet: (document xpath: '//*[following-sibling::address]')
		hasNodes: followingSiblings.
	self
		assertNodeSet: (document xpath: '//*[following-sibling::address[true()]]')
		hasNodes: followingSiblings.
	self
		assertNodeSet: (document xpath: '//*[./following-sibling::address]')
		hasNodes: followingSiblings.
	self
		assert: (document xpath: '//*[following-sibling::absent]') isEmpty;
		assert: (document xpath: '//*[following-sibling::node()[false()]]') isEmpty;
		assert: (document xpath: '//*[./following-sibling::absent]') isEmpty.

	followingSiblings :=
		textDocument allNodesSelect: [:node |
			(node followingSiblingNodes collect: [:each | each stringValue])
				includes: 'two'].
	self
		assertNodeSet:
			(textDocument xpath: '//node()[following-sibling::node() = "two"]')
		hasNodes: followingSiblings.
	self
		assertNodeSet:
			(textDocument xpath:
				'//node()[following-sibling::node()[true()] = "two"]')
		hasNodes: followingSiblings.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[./following-sibling::node() = "two"]')
		hasNodes: followingSiblings.
	self
		assert:
			(document xpath: '//node()[following-sibling::node() = "absent"]')
				isEmpty;
		assert:
			(document xpath: '//node()[following-sibling::node()[false()] = "two"]')
				isEmpty;
		assert:
			(document xpath: '//node()[./following-sibling::node() = "absent"]')
				isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateParentAxis
	| parents |

	parents := document allElementsNamed: 'person'.
	self
		assertNodeSet: (document xpath: '//*[parent::addressbook]')
		hasNodes: parents.
	self
		assertNodeSet: (document xpath: '//*[parent::addressbook[true()]]')
		hasNodes: parents.
	self
		assertNodeSet: (document xpath: '//*[./parent::addressbook]')
		hasNodes: parents.
	self
		assert: (document xpath: '//*[parent::absent]') isEmpty;
		assert: (document xpath: '//*[parent::addressbook[false()]]') isEmpty;
		assert: (document xpath: '//*[./parent::absent]') isEmpty.

	parents :=
		textDocument allNodesSelect: [:each |
			each isStringNode
				and: [(each parent isElementNamed: 'c')
					and: [each parent rawContentString = 'two']]].
	self
		assertNodeSet: (textDocument xpath: '//text()[parent::c = "two"]')
		hasNodes: parents.
	self
		assertNodeSet: (textDocument xpath: '//text()[parent::c[true()] = "two"]')
		hasNodes: parents.
	self
		assertNodeSet: (textDocument xpath: '//text()[./parent::c = "two"]')
		hasNodes: parents.
	self
		assert:
			(textDocument xpath: '//text()[parent::c = "absent"]') isEmpty;
		assert:
			(textDocument xpath: '//text()[parent::c[false()] = "two"]') isEmpty;
		assert:
			(textDocument xpath: '//text()[./parent::c = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicatePrecedingAxis
	| preceding |

	preceding :=
		document allElements select: [:element |
			element precedingNodes anySatisfy: [:each |
				each isElementNamed: 'address']].
	self
		assertNodeSet: (document xpath: '//*[preceding::address]')
		hasNodes: preceding.
	self
		assertNodeSet: (document xpath: '//*[preceding::address[true()]]')
		hasNodes: preceding.
	self
		assertNodeSet: (document xpath: '//*[./preceding::address]')
		hasNodes: preceding.
	self
		assert: (document xpath: '//*[preceding::absent]') isEmpty;
		assert: (document xpath: '//*[preceding::node()[false()]]') isEmpty;
		assert: (document xpath: '//*[./preceding::absent]') isEmpty.

	preceding :=
		textDocument allNodesSelect: [:node |
			(node precedingNodes collect: [:each | each stringValue])
				includes: 'two'].
	self
		assertNodeSet:
			(textDocument xpath: '//node()[preceding::node() = "two"]')
		hasNodes: preceding.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[preceding::node()[true()] = "two"]')
		hasNodes: preceding.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[./preceding::node() = "two"]')
		hasNodes: preceding.
	self
		assert:
			(document xpath: '//node()[preceding::node() = "absent"]') isEmpty;
		assert:
			(document xpath: '//node()[preceding::node()[false()] = "two"]') isEmpty;
		assert:
			(document xpath: '//node()[./preceding::node() = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicatePrecedingSiblingAxis
	| precedingSiblings |

	precedingSiblings :=
		document allElements select: [:element |
			element precedingSiblingNodes anySatisfy: [:each |
				each isElementNamed: 'address']].
	self
		assertNodeSet: (document xpath: '//*[preceding-sibling::address]')
		hasNodes: precedingSiblings.
	self
		assertNodeSet: (document xpath: '//*[preceding-sibling::address[true()]]')
		hasNodes: precedingSiblings.
	self
		assertNodeSet: (document xpath: '//*[./preceding-sibling::address]')
		hasNodes: precedingSiblings.
	self
		assert: (document xpath: '//*[preceding-sibling::absent]') isEmpty;
		assert: (document xpath: '//*[preceding-sibling::node()[false()]]') isEmpty;
		assert: (document xpath: '//*[./preceding-sibling::absent]') isEmpty.

	precedingSiblings :=
		textDocument allNodesSelect: [:node |
			(node precedingSiblingNodes collect: [:each | each stringValue])
				includes: 'two'].
	self
		assertNodeSet:
			(textDocument xpath: '//node()[preceding-sibling::node() = "two"]')
		hasNodes: precedingSiblings.
	self
		assertNodeSet:
			(textDocument xpath:
				'//node()[preceding-sibling::node()[true()] = "two"]')
		hasNodes: precedingSiblings.
	self
		assertNodeSet:
			(textDocument xpath: '//node()[./preceding-sibling::node() = "two"]')
		hasNodes: precedingSiblings.
	self
		assert:
			(document xpath: '//node()[preceding-sibling::node() = "absent"]')
				isEmpty;
		assert:
			(document xpath: '//node()[preceding-sibling::node()[false()] = "two"]')
				isEmpty;
		assert:
			(document xpath: '//node()[./preceding-sibling::node() = "absent"]')
				isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testOptimizedPredicateSelfAxis
	| nodes |

	nodes := document allElementsNamed: 'person'.
	self
		assertNodeSet: (document xpath: '//*[self::person]')
		hasNodes: nodes.
	self
		assertNodeSet: (document xpath: '//*[self::person[true()]]')
		hasNodes: nodes.
	self
		assertNodeSet: (document xpath: '//*[./self::person]')
		hasNodes: nodes.
	self
		assert: (document xpath: '//*[self::absent]') isEmpty;
		assert: (document xpath: '//*[self::person[false()]]') isEmpty;
		assert: (document xpath: '//*[./self::absent]') isEmpty.

	nodes :=
		textDocument allNodesSelect: [:each |
			each isStringNode: 'two'].
	self
		assertNodeSet:
			(textDocument xpath: '//text()[self::text() = "two"]')
		hasNodes: nodes.
	self
		assertNodeSet:
			(textDocument xpath: '//text()[self::text()[true()] = "two"]')
		hasNodes: nodes.
	self
		assertNodeSet:
			(textDocument xpath: '//text()[./self::text() = "two"]')
		hasNodes: nodes.
	self
		assert: (document xpath: '//text()[self::text() = "absent"]') isEmpty;
		assert: (document xpath: '//text()[self::text()[false()] = "two"]') isEmpty;
		assert: (document xpath: '//text()[./self::text() = "absent"]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:05'!
testOptimizedSelfAxisWithPositionPredicate
	| result nodes |

	nodes := document allElementsNamed: 'person'.
	result := document xpath: '//person/self::person[1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	result := document xpath: '//person/self::person[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	self
		assert: (document xpath: '//person/self::person[0]') isEmpty;
		assert: (document xpath: '//person/self::person[1.1]') isEmpty;
		assert: (document xpath: '//person/self::person[1][2]') isEmpty.

	result := document xpath: '//person/self::*[1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	result := document xpath: '//person/self::*[1.0][1]'.
	self
		assertNodeSet: result
		hasNodes: nodes.
	self
		assert: (document xpath: '//person/self::*[0]') isEmpty;
		assert: (document xpath: '//person/self::*[1.2]') isEmpty;
		assert: (document xpath: '//person/self::*[1][2]') isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 11/20/2015 05:35'!
testParentAxis
	self
		assertNodeSet:
			(XPath
				for: '//parent::*'
				in: document)
		hasNodes: (document allElementsSelect: [:each | each hasChildren]).

	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/parent::*'
				in: document)
		hasNodes: (XMLNodeList with: document root).

	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/node()/parent::*'
				in: document)
		hasNodes: (document allElementsNamed: 'person').

	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/node()/parent::*[1][position()=1][last()=1]'
				in: document)
		hasNodes: (document allElementsNamed: 'person').
	self assert:
		(XPath
			for: 'addressbook/person/node()/parent::*[2]'
			in: document) isEmpty.
	self assert:
		(XPath
			for: 'addressbook/person/node()/parent::*[position()+1]'
			in: document) isEmpty.

	self
		assertNodeSet:
			(XPath
				for: 'parent::*[1][position()=1][last()=1]'
				in: (document findElementNamed: 'person'))
		hasNodes: (XMLNodeList with: document root).
	self assert:
		(XPath
			for: 'parent::*[2]'
			in: (document findElementNamed: 'person')) isEmpty.
	self assert:
		(XPath
			for: 'parent::*[position() + 1]'
			in: (document findElementNamed: 'person')) isEmpty.

	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/attribute::node()/parent::node()'
				in: document)
		hasNodes: (document allElementsNamed: 'person').

	self assert:
		(XPath
			for: 'parent::node()'
			in: document) isEmpty.
	self assert:
		(XPath
			for: 'addressbook/parent::*'
			in: document) isEmpty.
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/parent::node()'
				in: document)
		hasNodes: (XMLNodeList with: document)! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/17/2017 14:54'!
testPositionFunction
	self assert:
		(XPath
			for: ' position( ) '
			in: document) = 1.

	(document allElementsNamed: 'person') do: [:each |
		self assert: (XPath for: ' position() ' in: each) = 1].

	(document allElementsNamed: 'person')
		withIndexDo: [:each :i |
			self assert:
				(XPath
					for: 'addressbook/person[position() = ', i printString, ']'
					in: document) = (XMLNodeList with: each).
			self assert:
				(XPath
					for: 'addressbook/person[', i printString, '=position()]'
					in: document) = (XMLNodeList with: each).
			self assert:
				(XPath
					for: 'addressbook/person[ ', i printString, ' ]'
					in: document) = (XMLNodeList with: each)].

	self
		should: ['position(0)' asXPath evaluate]
		raise: XPathException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2015 07:08'!
testPrecedence
	self
		assert: (XPath for: '1 + 2 * 3 + 4 div 2' in: nil) rounded = 9;
		assert: (XPath for: '(1 + 2) * (3 + 4) mod 5' in: nil) rounded = 1.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:01'!
testPrecedingAxis
	| persons preceding |

	persons := document allElementsNamed: 'person'.
	preceding := self newNodeSet.
	persons last precedingNodesDo: [:each | preceding addLast: each].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/preceding::node()'
				in: document)
		hasNodes: preceding.

	preceding removeAll.
	persons do: [:person |
		person hasChildren
			ifTrue: [
				person nodes last precedingNodesDo: [:each |
					preceding addIfNotPresent: each]]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person/node()/preceding::node()'
				in: document)
		hasNodes: preceding.

	preceding removeAll.
	document allNodesDo: [:node |
		node precedingNodesDo: [:each |
			preceding addIfNotPresent: each]].
	self
		assertNodeSet:
			(XPath
				for: '//preceding::node()'
				in: document)
		hasNodes: preceding.

	preceding removeAll.
	persons last precedingNodesDo: [:each |
		preceding addLast: each].
	persons second nodes last precedingNodesDo: [:each |
		preceding addLast: each].
	self
		assertNodeSet:
			(XPath
				for: '(//person[last()]|//person[2]/node()[last()])/preceding::node()'
				in: document)
		hasNodes: preceding.
	self
		assertNodeSet:
			(XPath
				for: '(//person[last()]|//person[1])/preceding::node()'
				in: document)
		hasNodes: preceding.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:01'!
testPrecedingSiblingAxis
	| persons siblings |

	persons := document allElementsNamed: 'person'.
	siblings := self newNodeSet.
	persons fourth precedingSiblingNodesDo: [:each |
		siblings addLast: each].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person[4]/preceding-sibling::node()'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons fourth precedingSiblingNodesDo: [:node |
		node hasChildren
			ifTrue: [
				node
					elementsAt: 'manager'
					do: [:each | siblings addIfNotPresent: each]]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person[4]/preceding-sibling::node()/manager'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons fourth allNodesDo: [:node |
		node precedingSiblingNodesDo: [:each |
			siblings addIfNotPresent: each]].
	self
		assertNodeSet:
			(XPath
				for: 'addressbook/person[4]//preceding-sibling::node()'
				in: document)
		hasNodes: siblings.

	siblings removeAll.
	document allNodesDo: [:node |
		node precedingSiblingNodesDo: [:each |
			siblings addIfNotPresent: each]].
	self
		assertNodeSet:
			(XPath for: '//preceding-sibling::node()' in: document)
		hasNodes: siblings.

	siblings removeAll.
	persons last precedingSiblingNodesDo: [:each |
		siblings addLast: each].
	persons second nodes last precedingSiblingNodesDo: [:each |
		siblings addIfNotPresent: each].
	self
		assertNodeSet:
			(XPath
				for: '(//person[last()]|//person[2]/node()[last()])/preceding-sibling::node()'
				in: document)
		hasNodes: siblings.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testPrefixWildcardTest
	| persons |

	persons := namespacedDocument allElementsNamed: 'person'.
	self
		assertNodeSet: (namespacedDocument xpath: '*:addressbook/*:person')
		hasNodes: persons.
	self assert: (namespacedDocument xpath: '*:addressbook/*:contaxt-info') isEmpty.
	self
		assertNodeSet:
			(XPath
				for: 'one:addressbook/*:person'
				in: namespacedDocument
				context: (self newContext declarePrefix: 'one' uri: 'bookNS'))
		hasNodes: persons.
	self assert:
		(XPath
			for: 'one:addressbook/*:contact-info'
			in: namespacedDocument
			context: (self newContext declarePrefix: 'one' uri: 'bookNS')) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testProcessingInstructionTypeTest
	| xml |

	xml := '<root>before<?one two?><?three four?>after</root>' parseXML.
	self
		assertNodeSet: (xml xpath: '// processing-instruction ()')
		hasNodes: (xml root nodes copyFrom: 2 to: 3).
	self
		assertNodeSet: (xml xpath: '// processing-instruction ( "three" )')
		hasNodes: (xml root nodes copyFrom: 3 to: 3).
	self
		assertNodeSet: (xml xpath: '// processing-instruction ( one )')
		hasNodes: (xml root nodes copyFrom: 2 to: 2).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testQualfiedNameTest
	| persons mappings |

	persons := namespacedDocument allElementsNamed: 'person'.
	mappings := 
		Array
			with: 'one' -> 'bookNS'
			with: 'two' -> 'personNS'.
	self
		assert: (namespacedDocument xpath: 'book:addressbook/ps:person') = persons;
		assert: (namespacedDocument xpath: 'book:addressbook/undeclared:person') isEmpty.
	self assert:
		(XPath
			for: 'one:addressbook/two:person'
			in: namespacedDocument
			context: (self contextClass namespaces: mappings)) = persons.
	self assert:
		(XPath
			for: 'one:addressbook/one:person'
			in: namespacedDocument
			context: (self contextClass namespaces: mappings)) isEmpty.
	self
		should: [
			(XPath
				for: 'undeclared:addressbook'
				in: namespacedDocument
				context: (self contextClass namespaces: mappings))]
		raise: XPathUndeclaredPrefixException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/22/2017 23:05'!
testReverseDocumentOrderPreserving
	| expected result |

	result :=
		document xpath:
			'addressbook/person[last()]/preceding-sibling::node()/parent::node()[true()]'.
	self
		assertNodeSet: result
		hasNode: document root.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	expected :=
		document root nodes copyUpTo:
			(document allElementsNamed: 'person') last.
	result :=
		document xpath:
			'addressbook/person[last()]/preceding-sibling::node()/self::node()[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	expected removeAll.
	(document allElementsNamed: 'person') allButLast do: [:each |
		expected addAll: each attributeNodes].
	result :=
		document xpath:
			'addressbook/person[last()]/preceding-sibling::node()/@*[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	expected removeAll.
	(namespacedDocument allElementsNamed: 'person') allButLast do: [:each |
		expected addAll: each namespaceNodes].
	result :=
		namespacedDocument xpath:
			'book:addressbook/ps:person[last()]/preceding-sibling::node()/namespace::*[true()]'.
	self
		assertNodeSet: result
		hasNodes: expected.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:01'!
testReverseForwardAxisCombination
	| nodes |

	nodes := self newNodeSet.
	(document allElementsNamed: 'person') allButLast do: [:person |
		person descendantNodesDo: [:each |
			nodes addLast: each]].
	self
		assertNodeSet:
			(XPath for: '*/person[last()]/preceding::node()/node()' in: document)
		hasNodes: nodes.

	nodes := (document allElementsNamed: 'person') allButLast.
	self
		assertNodeSet:
			(XPath
				for: '*/person[last()]/preceding-sibling::node()/self::*[1][position()>0]'
				in: document)
		hasNodes: nodes.
	self
		assert:
			(XPath
				for: '*/person[last()]/preceding-sibling::node()/self::*[1][2]'
				in: document) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testRoundFunction
	self
		assert: 'round(1.1)' asXPath evaluate = 1;
		assert: 'round(1.9)' asXPath evaluate = 2;
		assert: 'round(1 div 0)' asXPath evaluate = Float infinity;
		assert: 'round(-1 div 0)' asXPath evaluate = Float xpathNegativeInfinity;
		assert: 'round(0 div 0)' asXPath evaluate isNaN;
		assert: 'round(0.5)' asXPath evaluate = 1;
		assert: 'round(-0.5)' asXPath evaluate isXPathNegativeZero;
		assert: 'round(0.0)' asXPath evaluate isXPathPositiveZero;
		assert: 'round(-0.0)' asXPath evaluate isXPathNegativeZero! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/10/2015 09:39'!
testSelfAxis
	self
		assertNodeSet: (XPath for: ' / self::node() ' in: document)
		hasNodes: (XMLNodeList with: document).
	self
		assertNodeSet: (XPath for: ' /*/person/self::* ' in: document)
		hasNodes: (document allElementsNamed: 'person').
	self
		assertNodeSet: (XPath for: ' /*/person/node()/self::node() ' in: document)
		hasNodes:
			(document allNodesSelect: [:each |
				each hasParent
					and: [each parent isElementNamed: 'person']]).

	self
		assertNodeSet:
			(XPath
				for: ' /*/person/self::node()[1][position() = 1][last() = 1] '
				in: document)
		hasNodes: (document allElementsNamed: 'person').
	self
		assert: (XPath for: ' /*/person/self::node()[2] ' in: document) isEmpty;
		assert: (XPath for: ' /*/person/self::node()[position() + 1] ' in: document) isEmpty.

	self
		assertNodeSet:
			(XPath
				for: 'self::node()[1][position() = 1][last() = 1]'
				in: document)
		hasNodes: (XMLNodeList with: document).
	self
		assert: (XPath for: 'self::node()[2]' in: document) isEmpty;
		assert: (XPath for: 'self::node()[position() + 1]' in: document) isEmpty.

	self
		assertNodeSet: (XPath for: ' //person[1]/attribute::node()/. ' in: document)
		hasNodes: (document findElementNamed: 'person') attributeNodes.
	self assert:
		(XPath
			for: ' //person[1]/attribute::node()/self::* '
			in: document) isEmpty.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:28'!
testSorting
	| allNodes |

	allNodes := document allNodes.
	(Array
		with: (self nodeSetClass newFrom: allNodes)
		with: (self nodeSetClass newFrom: allNodes reversed))
		do: [:nodeSet |
			self
				assert: nodeSet sorted = allNodes;
				assert: nodeSet sorted reversed sorted = allNodes].! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/2/2017 16:48'!
testStartsWithFunction
	self
		assert: 'starts-with("onetwothree", "one")' asXPath evaluate;
		deny: 'starts-with("onetwothree", "ONE")' asXPath evaluate;
		"string-type argument converts 1.0 to '1', but not 1.1 to '1'"
		assert: 'starts-with("123", 1.0)' asXPath evaluate;
		deny: 'starts-with("123", 1.1)' asXPath evaluate! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/28/2017 08:31'!
testStringFunction
	self
		assert: 'string("test")' asXPath evaluate = 'test';
		assert: 'string(1.0)' asXPath evaluate = '1';
		assert: 'string(1 div 0)' asXPath evaluate = 'Infinity';
		assert: 'string(-1 div 0)' asXPath evaluate = '-Infinity';
		assert: 'string(0 div 0)' asXPath evaluate = 'NaN';
		assert: 'string(0.0)' asXPath evaluate = '0';
		assert: 'string(-0.0)' asXPath evaluate = '0';
		assert: 'string(true())' asXPath evaluate = 'true';
		assert: 'string(false())' asXPath evaluate = 'false'.

	"if the argument is omitted, use a node set with the context node"
	self assert:
		('string()' asXPath in: '<test>test</test>' parseXML) = 'test'.

	self
		should: ['string("1", "23")' asXPath evaluate]
		raise: XPathArgumentNumberException.
! !

!XPathTest methodsFor: 'tests' stamp: 'monty 8/5/2016 16:39'!
testStringLengthFunction
	self
		assert: 'string-length("test")' asXPath evaluate = 4;
		assert: 'string-length(false())' asXPath evaluate = 5;
		assert: ('string-length()' asXPath in: 'string-value' asXMLStringNode) = 12! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2015 06:40'!
testSubstringAfterFunction
	self
		assert: 'substring-after("onetwothree", "one")' asXPath evaluate = 'twothree';
		assert: 'substring-after("onetwothree", ''two'')' asXPath evaluate = 'three';
		assert: 'substring-after("onetwothree", "three")' asXPath evaluate isEmpty;
		assert: 'substring-after("onetwothree", "four")' asXPath evaluate isEmpty! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/10/2015 06:40'!
testSubstringBeforeFunction
	self
		assert: 'substring-before("onetwothree", "one")' asXPath evaluate isEmpty;
		assert: 'substring-before("onetwothree", ''two'')' asXPath evaluate = 'one';
		assert: 'substring-before("onetwothree", "three")' asXPath evaluate = 'onetwo';
		assert: 'substring-before("onetwothree", "four")' asXPath evaluate isEmpty! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/23/2017 07:19'!
testSubstringFunction
	#('substring("onetwothree", 4, 3)'
		'substring("onetwothree", 4)'
		'substring("onetwothree", -3, 7)'
		'substring("onetwothree", 12, 2)'
		'substring("", 0, 1)'
		'substring("", 0)')
		with:
			#('two'
				'twothree'
				'one'
				''
				''
				'')
		do: [:expression :result |
			self assert: expression asXPath evaluate = result].

	"from the spec"
	#('substring("12345",2,3)'
		'substring("12345",2)'
		'substring("12345", 1.5, 2.6)'
		'substring("12345", 0, 3)'
		'substring("12345", 0 div 0, 3)'
		'substring("12345", 1, 0 div 0)'
		'substring("12345", -42, 1 div 0)'
		'substring("12345", -1 div 0, 1 div 0)')
		with:
			#('234'
				'2345'
				'234'
				'12'
				''
				''
				'12345'
				'')
		do: [:expression :result |
			self assert: expression asXPath evaluate = result].! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testSumFunction
	self assert:
		('<nums><one>1</one><two>2</two><three>3</three></nums>' parseXML
			xpath: 'sum(/nums/*)') = 6.
	self
		should: ['sum()' asXPath evaluate]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:25'!
testTextTypeTest
	self
		assertNodeSet: (document xpath: ' //text( ) ')
		hasNodes: (document allNodesSelect: [:each | each isStringNode]).
	self
		assertNodeSet: (document xpath: '//text()/self::text()')
		hasNodes: (document allNodesSelect: [:each | each isStringNode]).
	self assert: (document xpath: ' //text()/text()') isEmpty.

	self
		should: [document xpath: '//text(name)']
		raise: XPathSyntaxException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/15/2015 04:12'!
testThreeLevel
	| path results |
	path := XPath for: '*/person/contact-info/email'.
	results := path in: document.
	self assert: (results size = 2).! !

!XPathTest methodsFor: 'tests' stamp: 'hfm 5/18/2013 16:58'!
testTopLevel
	| path results elem |
	path := XPath for: 'addressbook'.
	results := path in: document.
	
	self assert: results size = 1.
	
	elem := results first.
	self assert: elem isElement.
	self assert: elem name = 'addressbook'.
	self assert: elem elements size = 4.
	self assert: elem elements first isElement.
	self assert: elem elements first name = 'person'.
	self assert: elem elements last name = 'person'.	! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/22/2017 21:48'!
testTranslateFunction
	self
		assert: 'translate("onetwothree", "oe", "O")' asXPath evaluate = 'OntwOthr';
		assert: 'translate("onetwothree", "oe", "OEN")' asXPath evaluate = 'OnEtwOthrEE';
		assert: 'translate("onetwothree", "z", "x")' asXPath evaluate = 'onetwothree'.

	"from the spec"
	self
		assert: 'translate("bar","abc","ABC")' asXPath evaluate = 'BAr';
		assert: 'translate("--aaa--","abc-","ABC")' asXPath evaluate = 'AAA'.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/25/2015 03:32'!
testTrueFunction
	self assert: 'true()' asXPath evaluate.
	self
		should: ['true(1)' asXPath evaluate]
		raise: XPathArgumentNumberException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 1/15/2015 04:12'!
testTwoLevel
	| path results |
	path := XPath for: '/*/person/address'.
	results := path in: document.
	self assert: (results size = 4).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 11/18/2015 21:45'!
testUndeclaredFunctions
	self
		should: [XPath for: 'undeclared()/addressbook' in: document]
		raise: XPathUndeclaredFunctionException.
	self
		should: [XPath for: '(undeclared())/addressbook' in: document]
		raise: XPathUndeclaredFunctionException.
	self
		should: [XPath for: 'addressbook[undeclared()]' in: document]
		raise: XPathUndeclaredFunctionException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 11/18/2015 21:45'!
testUndeclaredVariables
	self
		should: [XPath for: '$undeclared/addressbook' in: document]
		raise: XPathUndeclaredVariableException.
	self
		should: [XPath for: '($undeclared)/addressbook' in: document]
		raise: XPathUndeclaredVariableException.
	self
		should: [XPath for: 'addressbook[$undeclared]' in: document]
		raise: XPathUndeclaredVariableException.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/18/2017 00:02'!
testUnion
	| expected result |

	expected := document allElementsNamed: 'person'.
	result := 
		XPath
			for:
				'addressbook/person[position() = 1 or position() = 4] |
				(addressbook/person[4]/ preceding-sibling::* [position() < 4])'
			in: document.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	document allElementsNamed: 'person' do: [:each |
		expected
			addLast: each;
			addAll: each namespaceNodes;
			addAll: each attributeNodes;
			addAll: each elements].
	result :=
		XPath
			for:
				'addressbook/person/@* | ',
				'*/person/namespace::* | ',
				'addressbook/person | ',
				'*/person/*'
			in: document.
	self
		assertNodeSet: result
		hasNodes: expected.

	expected removeAll.
	(document allElementsNamed: 'person') first
		namespaceNodesDo: [:each | expected addLast: each];
		attributeNodesDo: [:each | expected addLast: each];
		nodesDo: [:each | expected addLast: each].
	result :=
		XPath
			for:
				'addressbook/person[1]/node() | ',
				'*/person[1]/@* | ',
				'addressbook/person[1]/namespace::*'
			in: document.
	self
		assertNodeSet: result
		hasNodes: expected.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 9/22/2016 17:17'!
testVariables
	| context result |

	(context := self newContext)
		variableAt: 'doc' put: document;
		variableAt: 'pos' ifAbsentPut: [4].
	result :=
		(XPath for: '$doc/addressbook/person[position() !!= $pos]')
			in: nil
			context: context.
	self assert: result = (document allElementsNamed: 'person') allButLast.

	context :=
		self contextClass variables:
			(Dictionary
				with: 'doc' -> document
				with: 'city' -> 'Los Angeles').
	result :=
		(XPath for: '($doc)/addressbook/person[.//address[@city=$city]]')
			in: nil
			context: context.
	self
		assert: result size = 2;
		assert:
			result =
				((document allElementsNamed: 'person') select: [:each |
					((each elementAt: 'address') attributeAt: 'city') = 'Los Angeles']).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:41'!
testWildcard
	| path results |

	path := XPath for: 'addressbook/*'.
	results := path in: document.
	self assert: results size = 4.
	self
		assertNodeSet: results
		hasNodes: (document allElementsNamed: 'person').! !

!XPathTest methodsFor: 'tests' stamp: 'monty 2/27/2016 13:39'!
testWildcardDescendant
	| path results |

	path := XPath for: '//*'.
	results := path in: document.
	self assert: (results size = 28).
	self
		assertNodeSet: results
		hasNodes: document descendantElements.! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:40'!
testWildcardDescendantAttribute
	| path results |
	path := XPath for: '//*/@city'.
	results := path in: document.
	self assert: results size = 4.
	self
		assertNodeSet: results
		hasNodes:
			((document allElementsSelect: [:each | each includesAttribute: 'city'])
				collect: [:each | each attributeNodeAt: 'city']).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 10/8/2015 02:23'!
testWildcardDescendantAttributeValue
	| path results |
	path := XPath for: ' // * [ @ city = "Los Angeles" ] '.
	results := path in: document.
	self assert: results size = 2.
	self
		assertNodeSet: results
		hasNodes:
			(document allElementsSelect: [:each |
				(each isNamed: 'address')
					and: [(each attributeAt: 'city') = 'Los Angeles']]).! !

!XPathTest methodsFor: 'tests' stamp: 'monty 3/14/2017 22:29'!
testZeroDivision
	#('0 div 0' '0.0 div 0.0' '0 div 0.0' '0.0 div 0') do: [:each |
		self assert: each asXPath evaluate isNaN].

	"ensure nan propagates"
	#('(0 div 0) div 0' '(0.0 div 0.0) div 0' '(0 div 0.0) div 0' '(0.0 div 0) div 0') do: [:each |
		self assert: each asXPath evaluate isNaN].

	"if the sign is the same, the infinity should be positive"
	#('1 div 0' '0.1 div 0.0' '1 div 0.0' '0.1 div 0'
		'-1 div -0' '-0.1 div -0.0' '-1 div -0.0' '-0.1 div -0') do: [:each |
		self assert: each asXPath evaluate = Float infinity].

	"otherwise it should be negative"
	#('-1 div 0' '-0.1 div 0.0' '1 div -0.0' '0.1 div -0') do: [:each |
		"avoid #negativeInfinity for portability"
		self assert: each asXPath evaluate = Float xpathNegativeInfinity].! !

!XPathTest methodsFor: 'source XML' stamp: 'monty 2/20/2017 02:12'!
textDocumentXML
	^ '
		<a>
			<b><c>one</c></b>
			<b><c>one</c><c>two</c></b>
			<b><c>two</c></b>
			<b><c>one</c><c>two</c><c>three</c></b>
			<b><c>three</c></b>
		</a>'! !

XMLNodeListTest subclass: #XPathNodeSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNodeSetTest methodsFor: 'testing' stamp: 'monty 1/18/2015 11:26'!
allowsDuplicates
	^ false! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 9/5/2016 22:00'!
assertList: aList copiedFrom: aSecondList equals: aThirdList
	super
		assertList: aList
		copiedFrom: aSecondList
		equals: aThirdList.
	"internal set must be copied"
	self
		assert: aList set = aThirdList set;
		deny: aList set == aSecondList set.! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 3/18/2017 22:26'!
assertList: aList copiedFrom: aSecondList hasNode: aNode
	self
		assertList: aList
		copiedFrom: aSecondList
		hasNodes: (Array with: aNode)! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 3/18/2017 22:25'!
assertList: aList copiedFrom: aSecondList hasNodes: aNodeCollection
	self
		assertList: aList
		copiedFrom: aSecondList
		equals: (self listClass newFrom: aNodeCollection) sort.
	self assert: (aList sortOrder isKindOf: XPathDocumentSortOrder).! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 3/25/2015 22:50'!
assertList: aFirstList hasSameSortOrderAs: aSecondList
	self assert: aFirstList sortOrder class == aSecondList sortOrder class! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 3/17/2017 23:05'!
assertList: aList hasSortOrder: aSortOrder
	self assert: aList sortOrder class == aSortOrder! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 9/5/2016 22:01'!
assertList: aList isCopyOf: aSecondList
	super assertList: aList isCopyOf: aSecondList.
	"internal set must be copied"
	self
		assert: aList set = aSecondList set;
		deny: aList set == aSecondList set.! !

!XPathNodeSetTest methodsFor: 'assertions' stamp: 'monty 10/18/2015 07:57'!
assertListHasUnknownSortOrder: aList
	self
		assertList: aList
		hasSortOrder: XPathUnknownSortOrder! !

!XPathNodeSetTest methodsFor: 'accessing' stamp: 'monty 1/18/2015 09:11'!
listClass
	^ XPathNodeSet! !

!XPathNodeSetTest methodsFor: 'accessing' stamp: 'monty 3/15/2017 19:55'!
listWithSortOrder
	^ self listWithItems sortOrder: XPathLevelDocumentSortOrder new! !

!XPathNodeSetTest methodsFor: 'instance creation' stamp: 'monty 1/31/2017 22:12'!
newElementWithAttributes
	^ (XMLElement named: 'test')
		attributeAt: 'one' put: '1';
		attributeAt: 'two' put: '2';
		attributeAt: 'three' put: '3';
		yourself! !

!XPathNodeSetTest methodsFor: 'instance creation' stamp: 'monty 1/31/2017 22:14'!
newElementWithNamespaces
	^ (XMLElement named: 'test')
		declarePrefix: 'one' uri: 'oneNS';
		declarePrefix: 'two' uri: 'twoNS';
		declarePrefix: 'three' uri: 'threeNS';
		yourself! !

!XPathNodeSetTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
reverseSortBlock
	^ [:a :b | (self listItems indexOf: a) >= (self listItems indexOf: b)]! !

!XPathNodeSetTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:25'!
sortBlock	
	^ [:a :b | (self listItems indexOf: a) <= (self listItems indexOf: b)]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAdd
	super testAdd.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			add: self newListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAfter
	super testAddAfter.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			add: self newListItem after: self singleListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAfterIndex
	super testAddAfterIndex.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			add: self newListItem afterIndex: 1;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAll
	super testAddAll.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			addAll: (Array with: self newListItem);
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAllFirst
	super testAddAllFirst.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			addAllFirst: (Array with: self newListItem);
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllIfNotPresentTo
	| list listToAdd |

	list := OrderedCollection new.
	listToAdd := self emptyList.
	self
		assert: (listToAdd addAllIfNotPresentTo: list) == listToAdd;
		assert: list isEmpty.

	listToAdd := self listWithItems.
	self
		assert: (listToAdd addAllIfNotPresentTo: list) == listToAdd;
		assert: list = self listItems asOrderedCollection;
		assert: (listToAdd addAllIfNotPresentTo: list) == listToAdd;
		assert: list = self listItems asOrderedCollection.
! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddAllLast
	super testAddAllLast.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			addAllLast: (Array with: self newListItem);
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testAddAllTo
	| list listToAdd |

	list := OrderedCollection new.
	listToAdd := self emptyList.
	self
		assert: (listToAdd addAllTo: list) == listToAdd;
		assert: list isEmpty.

	listToAdd := self listWithItems.
	self
		assert: (listToAdd addAllTo: list) == listToAdd;
		assert: list = self listItems asOrderedCollection;
		assert: (listToAdd addAllTo: list) == listToAdd;
		assert: list = (self listItems, self listItems) asOrderedCollection.
! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddBefore
	super testAddBefore.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			add: self newListItem before: self singleListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddBeforeIndex
	super testAddBeforeIndex.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			add: self newListItem beforeIndex: 1;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddFirst
	super testAddFirst.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			addFirst: self newListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAddLast
	super testAddLast.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			addLast: self newListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:00'!
testAllButFirst
	| list |

	super testAllButFirst.

	list := self listWithSortOrder.
	self
		assertList: list allButFirst
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:01'!
testAllButFirstFew
	| list |

	super testAllButFirstFew.

	list := self listWithSortOrder.
	self
		assertList: (list allButFirst: 1)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:00'!
testAllButLast
	| list |

	super testAllButLast.

	list := self listWithSortOrder.
	self
		assertList: list allButLast
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:02'!
testAllButLastFew
	| list |

	super testAllButLastFew.

	list := self listWithSortOrder.
	self
		assertList: (list allButLast: 1)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2017 00:56'!
testAllButLastReverseDo
	| list |

	list := self emptyList.
	self
		should: [:block | list allButLastReverseDo: block ]
		enumerate: #().

	list := self listWithItems.
	self
		should: [:block | list allButLastReverseDo: block]
		enumerate: self listItems allButLast reversed.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:44'!
testAncestorAxis
	| list result |

	list := self listWithItems.
	result := list %% '*'.
	self
		assertList: result
		copiedFrom: list
		hasNodes: self listItems first ancestorElements.
	self assert: (result %% '*') isEmpty.

	result := list %% 'root'.
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements last.
	self assert: (result %% 'root') isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:44'!
testAncestorAxisPredicates
	| list result |

	list := self listWithItems.
	result := list %% ('*' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements last.
	self assert: (result %% ('*' ?? 1)) isEmpty.

	result := list %% ('root' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements last.
	self assert: (result %% ('root' ?? 1)) isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:44'!
testAncestorOrSelfAxis
	| list result |

	list := self listWithItems.
	result := list %%~ '*'.
	self
		assertList: result
		copiedFrom: list
		hasNodes: self listElements, self listElements first ancestorElements.
	self assert: (result %%~ 'absent') isEmpty.

	result := list %%~ 'root'.
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements last.
	self assert: (result %%~ 'absent') isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:44'!
testAncestorOrSelfAxisPredicates
	| list result |

	list := self listWithItems.
	result := list %%~ ('*' ?? 2).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements first.
	self assert: (result %%~ ('*' ?? 2)) isEmpty.

	result := list %%~ ('root' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listItems first ancestorElements last.
	self assert: (result %%~ ('root' ?? 2)) isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/22/2017 23:54'!
testAsSorted
	| list sorted |

	list := self listWithItems.
	sorted := list asSorted.
	self
		assertList: sorted
		copiedFrom: list
		equals: self listWithItems.
	self
		assertList: sorted
		hasSortOrder: XPathDocumentSortOrder.

	list := self listWithItems sorted.
	sorted := list asSorted.
	self
		assert: sorted = self listWithItems;
		assert: sorted == list.
	self
		assertList: sorted
		hasSortOrder: XPathDocumentSortOrder.

	list := self listWithItems sorted reversed.
	self
		assertList: sorted
		copiedFrom: list
		equals: self listWithItems.
	self
		assertList: sorted
		hasSortOrder: XPathDocumentSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testAsXPathBoolean
	self
		deny: self emptyList asXPathBoolean;
		assert: self listWithSingleItem asXPathBoolean! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 2/11/2017 16:01'!
testAsXPathComparable
	| comparable |

	comparable := self listWithItems asXPathComparable.
	self
		assert: comparable class == XPathNodeSetComparable;
		assert: comparable value = self listWithItems.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 1/25/2017 11:39'!
testAsXPathFilterExpressionLocationPathRoot
	| list |

	list := self emptyList.
	self assert: list asXPathFilterExpressionLocationPathRoot == list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 2/18/2017 03:12'!
testAsXPathFilterExpressionPredicateRoot
	| list filterable |

	list := self listWithItems reversed.
	filterable := list asXPathFilterExpressionPredicateRoot.
	self
		assertList: filterable copiedFrom: list equals: self listWithItems;
		assertList: filterable hasSortOrder: XPathDocumentSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 10/28/2015 16:30'!
testAsXPathNodeSet
	| list |

	list := self emptyList.
	self assert: list asXPathNodeSet == list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 9/22/2016 16:59'!
testAsXPathNumber
	self
		assert: self emptyList asXPathNumber isNaN;
		assert: self listWithItems asXPathNumber isNaN;
		assert: (self listClass with: ' 1.0 ' asXMLStringNode) asXPathNumber = 1.0;
		assert: (self listClass with: ' 1.0 .' asXMLStringNode) asXPathNumber isNaN! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:28'!
testAsXPathString
	self
		assert: self emptyList asXPathString = '';
		assert: self listWithItems asXPathString = self singleListItem stringValue;
		assert: self listWithItems reversed asXPathString = self singleListItem stringValue! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/4/2016 07:54'!
testAsXPathUnionable
	| list |

	list := self emptyList.
	self assert: list asXPathUnionable == list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testAtPut
	super testAtPut.

	self assertListHasUnknownSortOrder:
		(self listWithSortOrder
			at: 1 put: self newListItem;
			yourself).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:38'!
testAttributeAxis
	| element listWithElement |

	element := self newElementWithAttributes.
	listWithElement := self listClass with: element.
	(Array
		with: listWithElement sorted
		with: listWithElement sorted reversed)
		do: [:list | | result |
			result := list @ '*'.
			self
				assertList: result
				copiedFrom: list
				hasNodes: element attributeNodes.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result @ '*') isEmpty.

			result := list @ 'two'.
			self
				assertList: result
				copiedFrom: list
				hasNode: element attributeNodes second.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result @ 'two') isEmpty].! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:40'!
testAttributeAxisPredicates
	| element listWithElement |

	element := self newElementWithAttributes.
	listWithElement := self listClass with: element.
	(Array
		with: listWithElement sorted
		with: listWithElement sorted reversed)
		do: [:list | | result |
			result := list @ ('*' ?? 2).
			self
				assertList: result
				copiedFrom: list
				hasNode: element attributeNodes second.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result @ ('*' ?? 1)) isEmpty.

			result := list @ ('two' ?? 1).
			self
				assertList: result
				copiedFrom: list
				hasNode: element attributeNodes second.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result @ ('two' ?? 1)) isEmpty].! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:42'!
testChildAxis
	| list result |

	list := self listClass with: self singleListItem parent.
	result := list / '*'.
	self
		assertList: result
		copiedFrom: list
		hasNodes: self listElements.
	self
		assertList: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self assert: (result / '*') isEmpty.

	result := list / 'three'.
	self
		assertList: result
		copiedFrom: list
		hasNode: self listElements third.
	self
		assertList: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self assert: (result / 'three') isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/18/2017 22:46'!
testChildAxisPredicates
	| list result |

	list := self listClass with: self singleListItem parent.
	result := list / ('*' ?? 3).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listElements third.
	self
		assertList: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self assert: (result / ('*' ?? 3)) isEmpty.

	result := list / ('three' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: self listElements third.
	self
		assertList: result
		hasSortOrder: XPathLevelDocumentSortOrder.
	self assert: (result / ('three' ?? 1)) isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:49'!
testCopy
	| list |

	super testCopy.

	list := self listWithSortOrder.
	self assertList: list copy hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:53'!
testCopyAfter
	| list |

	super testCopyAfter.

	list := self listWithSortOrder.
	self
		assertList: (list copyAfter: list first)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:54'!
testCopyAfterLast
	| list |

	super testCopyAfterLast.

	list := self listWithSortOrder.
	self
		assertList: (list copyAfterLast: list first)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:32'!
testCopyEmpty
	| list |

	super testCopyEmpty.

	list := self listWithSortOrder.
	self
		assertList: list copyEmpty
		hasSameSortOrderAs: self emptyList.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:52'!
testCopyFromTo
	| list |

	super testCopyFromTo.

	list := self listWithSortOrder.
	self
		assertList: (list copyFrom: 1 to: list size)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyReplaceAllWith
	| list |

	super testCopyReplaceAllWith.

	list := self listWithSortOrder.
	self assertListHasUnknownSortOrder:
		(list
			copyReplaceAll: self listItems
			with: self listItems).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyReplaceFromToWith
	| list |

	super testCopyReplaceFromToWith.

	list := self listWithSortOrder.
	self assertListHasUnknownSortOrder:
		(list
			copyReplaceFrom: 1
			to: list size
			with: self listItems).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:52'!
testCopyUpTo
	| list |

	super testCopyUpTo.

	list := self listWithSortOrder.
	self
		assertList: (list copyUpTo: list last)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 22:52'!
testCopyUpToLast
	| list |

	super testCopyUpToLast.

	list := self listWithSortOrder.
	self
		assertList: (list copyUpToLast: list last)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testCopyWith
	| list |

	super testCopyWith.

	list := self listWithSortOrder.
	self assertListHasUnknownSortOrder: (list copyWith: self newListItem).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testCopyWithFirst
	| list |

	super testCopyWithFirst.

	list := self listWithSortOrder.
	self assertListHasUnknownSortOrder: (list copyWithFirst: self newListItem).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyWithout
	| list |

	super testCopyWithout.

	list := self listWithSortOrder.
	self
		assertList: (list copyWithout: self singleListItem)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testCopyWithoutAll
	| list |

	super testCopyWithoutAll.

	list := self listWithSortOrder.
	self
		assertList: (list copyWithoutAll: (Array with: self singleListItem))
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 19:52'!
testDefaultSortOrder
	self
		assertList: self emptyList hasSortOrder: XPathLevelDocumentSortOrder;
		assertList: self listWithSingleItem hasSortOrder: XPathLevelDocumentSortOrder;
		assertListHasUnknownSortOrder: self listWithItems! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:49'!
testDescendantAxis
	| root list result |

	root := self singleListItem documentRoot.
	list := self listClass with: root.
	result := list // '*'.
	self
		assertList: result
		copiedFrom: list
		hasNodes: root descendantElements.
	self assert: (result // 'absent') isEmpty.

	result := list // 'three'.
	self
		assertList: result
		copiedFrom: list
		hasNode: root descendantElements fourth.
	self assert: (result // 'absent') isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:50'!
testDescendantAxisPredicates
	| root list result |

	root := self singleListItem documentRoot.
	list := self listClass with: root.
	result := list // ('*' ?? 3).
	self
		assertList: result
		copiedFrom: list
		hasNode: root descendantElements third.
	self assert: (result // ('*' ?? 3)) isEmpty.

	result := list // ('three' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: root descendantElements fourth.
	self assert: (result // ('three' ?? 1)) isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:51'!
testDescendantOrSelfAxis
	| root list result |

	root := self singleListItem documentRoot.
	list := self listClass with: root.
	result := list //~ '*'.
	self
		assertList: result
		copiedFrom: list
		hasNodes: root allElements.
	self assert: (result //~ 'absent') isEmpty.

	result := list //~ 'three'.
	self
		assertList: result
		copiedFrom: list
		hasNode: root allElements fourth.
	self assert: (result //~ 'absent') isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:52'!
testDescendantOrSelfAxisPredicates
	| root list result |

	root := self singleListItem documentRoot.
	list := self listClass with: root.
	result := list //~ ('*' ?? 4).
	self
		assertList: result
		copiedFrom: list
		hasNode: root allElements fourth.
	self assert: (result //~ ('*' ?? 4)) isEmpty.

	result := list //~ ('three' ?? 1).
	self
		assertList: result
		copiedFrom: list
		hasNode: root allElements fourth.
	self assert: (result //~ ('three' ?? 4)) isEmpty.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testDifference
	self assert:
		(self listWithItems \ self listWithItems) =
			self emptyList.
	self assert:
		(self listWithItems reversed \ self emptyList) =
			self listWithItems.
	self assert:
		(self listWithItems \ self listWithSingleItem) =
			self listWithItems allButFirst.
	self assert:
		(self listWithItems reversed \
			(self listItems select: [:each | each isElement])) =
				(self listWithItems reject: [:each | each isElement]).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 2/20/2017 04:02'!
testFilterExpressionPositionPredicate
	1 to: self listItems size do: [:i | | item list filtered |
		item := self listItems at: i.

		list := self listWithItems.
		filtered := list ?? i.
		self
			assertList: filtered copiedFrom: list equals: (self listClass with: item);
			assertList: filtered hasSortOrder: XPathDocumentSortOrder.

		list := self listWithItems reversed.
		filtered := list ?? i.
		self
			assertList: filtered copiedFrom: list equals: (self listClass with: item);
			assertList: filtered hasSortOrder: XPathDocumentSortOrder]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 2/20/2017 04:01'!
testFilterExpressionPositionPredicates
	1 to: self listItems size do: [:i | | item list filtered |
		item := self listItems at: i.

		list := self listWithItems.
		filtered := list ?? (Array with: i with: 1).
		self
			assertList: filtered copiedFrom: list equals: (self listClass with: item);
			assertList: filtered hasSortOrder: XPathDocumentSortOrder.

		list := self listWithItems reversed.
		filtered := list ?? (Array with: i with: 1).
		self
			assertList: filtered copiedFrom: list equals: (self listClass with: item);
			assertList: filtered hasSortOrder: XPathDocumentSortOrder]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:17'!
testFirstFew
	| list |

	super testFirstFew.

	list := self listWithSortOrder.
	self
		assertList: (list first: list size)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testFirstInDocumentOrder
	self
		assert: self emptyList firstInDocumentOrder = self defaultValue;
		assert: self listWithSingleItem firstInDocumentOrder = self singleListItem;
		assert: self listWithItems firstInDocumentOrder = self listItems first;
		assert: self listWithItems reversed firstInDocumentOrder = self listItems first! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testIncludes
	| list element namespaceNode |

	list := self emptyList.
	self listItems do: [:each |
		self deny: (list includes: each).
		list add: each.
		self assert: (list includes: each)].

	self listItems do: [:each |
		list remove: each.
		self deny: (list includes: each)].

	element := XMLElement new.
	namespaceNode := XPathNamespaceNode withXMLNamespaceOnElement: element.
	self deny: (list includes: namespaceNode).
	list add: namespaceNode.
	self assert: (list includes: namespaceNode).

	"namespace nodes define ="
	self assert:
		(list includes:
			(XPathNamespaceNode withXMLNamespaceOnElement: element)).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testIntersection
	self assert:
		(self listWithItems reversed & self listWithItems) =
			self listWithItems.
	self assert:
		(self listWithItems & self emptyList) =
			self emptyList.
	self assert:
		(self listWithSingleItem & self listWithItems reversed) =
			self listWithSingleItem.
	self assert:
		(self listWithItems &
			(self listWithItems select: [:each | each isElement])) =
				(self listWithItems select: [:each | each isElement])! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2017 01:22'!
testIsXPathNodeSet
	self
		assert: self emptyList isXPathNodeSet;
		deny: self listSpecies new isXPathNodeSet! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:17'!
testLastFew
	| list |

	super testLastFew.

	list := self listWithSortOrder.
	self
		assertList: (list last: list size)
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 20:00'!
testNamespaceAxis
	| element listWithElement |

	element := self newElementWithNamespaces.
	listWithElement := self listClass with: element.
	(Array
		with: listWithElement sorted
		with: listWithElement sorted reversed)
		do: [:list | | result |
			result := list namespaceAxis: '*'.
			self
				assertList: result
				copiedFrom: list
				equals: (self listClass withAll: element namespaceNodes).
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result namespaceAxis: '*') isEmpty.

			result := list namespaceAxis: 'two'.
			self
				assertList: result
				copiedFrom: list
				"there is an implicit 'xml' namespace node that comes first"
				equals: (self listClass with: element namespaceNodes third).
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result namespaceAxis: 'two') isEmpty].! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 20:00'!
testNamespaceAxisPredicates
	| element listWithElement |

	element := self newElementWithNamespaces.
	listWithElement := self listClass with: element.
	(Array
		with: listWithElement sorted
		with: listWithElement sorted reversed)
		do: [:list | | result |
			result :=
				list
					namespaceAxis: '*'
					predicates: #(3).
			self
				assertList: result
				copiedFrom: list
				"there is an implicit 'xml' namespace node that comes first"
				equals: (self listClass with: element namespaceNodes third).
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert:
				(result
					namespaceAxis: '*'
					predicates: #(1)) isEmpty.

			result :=
				list
					namespaceAxis: 'two'
					predicates: #(1).
			self
				assertList: result
				copiedFrom: list
				"there is an implicit 'xml' namespace node that comes first"
				equals: (self listClass with: element namespaceNodes third).
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert:
				(result
					namespaceAxis: 'two'
					predicates: #(1)) isEmpty].! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:17'!
testParentAxis
	(Array
		with: self listWithSortOrder
		with: self listWithSortOrder reversed)
		do: [:list | | result |
			result := list % '*'.
			self
				assertList: result
				copiedFrom: list
				hasNode: self listItems first parent.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result % 'root') isEmpty.

			result := list % 'root'.
			self
				assertList: result
				copiedFrom: list
				hasNode: self listItems first parent.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result % 'root') isEmpty]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:16'!
testParentAxisPredicates
	(Array
		with: self listWithSortOrder
		with: self listWithSortOrder reversed)
		do: [:list | | result |
			result := list % ('*' ?? 1).
			self
				assertList: result
				copiedFrom: list
				hasNode: self listItems first parent.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result % ('root' ?? 1)) isEmpty.

			result := list % ('root' ?? 1).
			self
				assertList: result
				copiedFrom: list
				hasNode: self listItems first parent.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result % ('root' ??1)) isEmpty]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:36'!
testReject
	| list |

	super testReject.

	list := self listWithSortOrder.
	self
		assertList: (list reject: [:each | false])
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:29'!
testRemoveAll
	| list |

	super testRemoveAll.

	(list := self listWithSortOrder) removeAll.
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:29'!
testRemoveFirst
	| list |

	super testRemoveFirst.

	(list := self listWithSortOrder) removeFirst.
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:28'!
testRemoveFirstFew
	| list |

	super testRemoveFirstFew.

	(list := self listWithSortOrder) removeFirst: 1.
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testRemoveIfAbsent
	| list |

	super testRemoveIfAbsent.

	(list := self listWithSortOrder)
		remove: self absentListItem ifAbsent: [nil];
		remove: self singleListItem ifAbsent: [nil].
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:28'!
testRemoveLast
	| list |

	super testRemoveLast.

	(list := self listWithSortOrder) removeLast.
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:28'!
testRemoveLastFew
	| list |

	super testRemoveLastFew.

	(list := self listWithSortOrder) removeLast: 1.
	self
		assertList: list
		hasSameSortOrderAs: self listWithSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReplaceFromToWith
	| list |

	super testReplaceFromToWith.

	(list := self listWithSortOrder)
		replaceFrom: 1
		to: list size
		with: self listItems.
	self assertListHasUnknownSortOrder: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:25'!
testReplaceFromToWithStartingAt
	| list |

	super testReplaceFromToWithStartingAt.

	(list := self listWithSortOrder)
		replaceFrom: 1
		to: list size
		with: self listItems
		startingAt: 1.
	self assertListHasUnknownSortOrder: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 19:56'!
testReverse
	| list copy |

	super testReverse.

	list := self listWithItems.
	copy := list reverse.
	self
		assertListHasUnknownSortOrder: copy;
		assertList: copy
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reverse).

	list := self listWithSortOrder.
	copy := list reverse.
	self
		assertList: copy hasSortOrder: XPathLevelReverseDocumentSortOrder;
		assertList: copy
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reverse).

	list := copy.
	copy := list reverse.
	self
		assertList: copy hasSortOrder: XPathLevelDocumentSortOrder;
		assertList: copy
		copiedFrom: list
		equals: self listWithItems.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 19:57'!
testReverseInPlace
	| list |

	list := self emptyList.
	self
		assert: list reverseInPlace == list;
		assert: list isEmpty.

	list := self listWithSingleItem.
	self
		assert: list reverseInPlace == list;
		assert: list = self listWithSingleItem;
		assertList: list hasSortOrder: XPathLevelReverseDocumentSortOrder.

	list := self listWithItems.
	self
		assert: list reverseInPlace == list;
		assert: list = (self listClass newFrom: self listItems reversed);
		assertListHasUnknownSortOrder: list.

	list := self listWithSortOrder.
	self
		assert: list reverseInPlace == list;
		assert: list = (self listClass newFrom: self listItems reversed);
		assertList: list hasSortOrder: XPathLevelReverseDocumentSortOrder;
		assert: list reverseInPlace == list;
		assert: list = (self listClass newFrom: self listItems);
		assertList: list hasSortOrder: XPathLevelDocumentSortOrder.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/15/2017 23:02'!
testReversed
	| list copy |

	super testReversed.

	list := self listWithItems.
	copy := list reversed.
	self
		assertListHasUnknownSortOrder: copy;
		assertList: copy
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reversed).

	list := self listWithSortOrder.
	copy := list reversed.
	self
		assertList: copy hasSortOrder: XPathLevelReverseDocumentSortOrder;
		assertList: copy
		copiedFrom: list
		equals: (self listClass newFrom: self listItems reversed).

	list := copy.
	copy := list reversed.
	self
		assertList: copy hasSortOrder: XPathLevelDocumentSortOrder;
		assertList: copy
		copiedFrom: list
		equals: self listWithItems.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2015 23:36'!
testSelect
	| list |

	super testSelect.

	list := self listWithSortOrder.
	self
		assertList: (list select: [:each | true])
		hasSameSortOrderAs: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:18'!
testSelfAxis
	(Array
		with: self listWithSortOrder
		with: self listWithSortOrder reversed)
		do: [:list | | result |
			result := list ~ '*'.
			self
				assertList: result
				copiedFrom: list
				hasNodes: self listElements.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result ~ 'absent') isEmpty.

			result := list ~ 'three'.
			self
				assertList: result
				copiedFrom: list
				hasNode: self listElements third.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result ~ 'absent') isEmpty]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/20/2017 06:20'!
testSelfAxisPredicates
	(Array
		with: self listWithSortOrder
		with: self listWithSortOrder reversed)
		do: [:list | | result |
			result := list ~ ('*' ?? 1).
			self
				assertList: result
				copiedFrom: list
				hasNodes: self listElements.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result ~ ('*' ?? 3)) isEmpty.

			result := list ~ ('three' ?? 1).
			self
				assertList: result
				copiedFrom: list
				hasNode: self listElements third.
			self
				assertList: result
				hasSortOrder: XPathLevelDocumentSortOrder.
			self assert: (result ~ ('three' ?? 3)) isEmpty]! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testSort
	super testSort.

	self
		assertList: self listWithItems sort
		hasSortOrder: XPathDocumentSortOrder.
	self
		should: [(self listWithItems copyWith: self newListItem) sort]
		raise: XPathDOMException.
	self
		shouldnt: [self emptyList sort]
		raise: Error.

	self assertListHasUnknownSortOrder:
		(self listWithItems
			sort;
			sort: self sortBlock).! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:30'!
testSorted
	super testSorted.

	self
		assertList: self listWithItems sorted
		hasSortOrder: XPathDocumentSortOrder.
	self
		should: [(self listWithItems copyWith: self newListItem) sorted]
		raise: XPathDOMException.
	self
		shouldnt: [self emptyList sorted]
		raise: Error.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:23'!
testStringValue
	| firstStringValue |

	self assert: self emptyList stringValue = ''.

	firstStringValue := self listWithItems stringValues first.
	self
		assert: self listWithItems stringValue = firstStringValue;
		assert: (self listWithItems last <<< 'node()') stringValue = firstStringValue.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:28'!
testStringValues
	self
		assert: self emptyList stringValues isEmpty;
		assert:
			self listWithItems stringValues =
				(self listWithItems collect: [:each | each stringValue])! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/25/2017 01:19'!
testStringValuesDo
	| list stringValues |

	list := self emptyList.
	self
		should: [:block | list stringValuesDo: block]
		enumerate: #().

	stringValues := self listWithItems collect: [:each | each stringValue].
	list := self listWithItems.
	self
		should: [:block | list stringValuesDo: block]
		enumerate: stringValues.
	list := self listWithItems reversed.
	self
		should: [:block | list stringValuesDo: block]
		enumerate: stringValues.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 10/18/2015 07:57'!
testSwapWith
	| list |

	super testSwapWith.

	(list := self listWithSortOrder)
		swap: 1
		with: list size.
	self assertListHasUnknownSortOrder: list.! !

!XPathNodeSetTest methodsFor: 'tests' stamp: 'monty 3/30/2016 01:24'!
testUnion
	self assert:
		(self listWithItems | self listWithItems reversed) =
			self listWithItems.
	self assert:
		(self listWithItems | self emptyList) =
			self listWithItems.
	self assert:
		(self listWithSingleItem | self listWithItems reversed) =
			self listWithItems.
	self assert:
		((self listWithItems select: [:each | each isElement]) reversed |
			(self listWithItems reject: [:each | each isElement])) =
				self listWithItems.! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:21'!
testExpandedName
	self assert: self newPIWithTargetAndData expandedName = 'target'! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testHasExpandedName
	self assert: self newNode hasExpandedName! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:22'!
testHasNamespaceURI
	self deny: self newPIWithTargetAndData hasNamespaceURI! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:22'!
testHasPrefix
	self deny: self newPIWithTargetAndData hasPrefix! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:22'!
testLocalName
	self assert: self newPIWithTargetAndData localName = 'target'! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:23'!
testName
	self assert: self newPIWithTargetAndData name = 'target'! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:23'!
testNamespaceURI
	self assert: self newPIWithTargetAndData namespaceURI = ''! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:23'!
testPrefix
	self assert: self newPIWithTargetAndData prefix = ''! !

!XMLPITest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:23'!
testStringValue
	super testStringValue.

	self assert: self newPIWithTargetAndData stringValue = 'data'.! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:43'!
testAncestorAxis
	| nodeWithElements |

	super testAncestorAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result |
		result := each %% 'node()'.
		self
			assertNodeSet: result
			hasNodes: each ancestorNodes.

		result := each %% '*'.
		self
			assertNodeSet: result
			hasNodes: each ancestorElements].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:50'!
testAncestorOrSelfAxis
	| nodeWithElements |

	super testAncestorOrSelfAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result |
		result := each %%~ 'node()'.
		self
			assertNodeSet: result
			hasNodes: (each ancestorNodes copyWith: each).

		result := each %%~ '*'.
		each isElement
			ifTrue: [
				self
					assertNodeSet: result
					hasNodes: (each ancestorElements copyWith: each)]
			ifFalse: [
				self
					assertNodeSet: result
					hasNodes: each ancestorElements]].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:47'!
testChildAxis
	| nodeWithElements |

	super testChildAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		each hasChildren
			ifTrue: [| result |
				result := each / 'node()'.
				self
					assertNodeSet: result
					hasNodes: each nodes.
				self
					assertNodeSet: result
					hasSortOrder: XPathLevelDocumentSortOrder.

				result := each / '*'.
				self
					assertNodeSet: result
					hasNodes: each elements.
				self
					assertNodeSet: result
					hasSortOrder: XPathLevelDocumentSortOrder]
			ifFalse: [
				self
					assert: (each / 'node()') isEmpty;
					assert: (each / '*') isEmpty]].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:51'!
testDescendantAxis
	| nodeWithElements |

	super testDescendantAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		each hasChildren
			ifTrue: [| result |
				result := each // 'node()'.
				self
					assertNodeSet: result
					hasNodes: each descendantNodes.

				result := each // '*'.
				self
					assertNodeSet: result
					hasNodes: each descendantElements]
			ifFalse: [
				self
					assert: (each // 'node()') isEmpty;
					assert: (each // '*') isEmpty]].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:53'!
testDescendantOrSelfAxis
	| nodeWithElements |

	super testDescendantOrSelfAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each |
		each hasChildren
			ifTrue: [| result |
				result := each //~ 'node()'.
				self
					assertNodeSet: result
					hasNodes: each allNodes.

				result := each //~ '*'.
				each isElement
					ifTrue: [
						self
							assertNodeSet: result
							hasNodes: each allElements]
					ifFalse: [
						self
							assertNodeSet: result
							hasNodes: each descendantElements]]
			ifFalse: [
				self
					assertNodeSet: (each //~ 'node()')
					hasNode: each.
				each isElement
					ifTrue: [
						self
							assertNodeSet: (each //~ '*')
							hasNode: each]
					ifFalse: [self assert: (each //~ '*') isEmpty]]].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:42'!
testFollowingAxis
	| nodeWithElements |

	super testFollowingAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result followingNodes |
		result := each >> 'node()'.
		followingNodes := 
			each hasParent
				ifTrue: [
					each parent descendantNodes copyAfter:
						(each hasChildren
							ifTrue: [each descendantNodes last]
							ifFalse: [each])]
				ifFalse: [self newNodeSet].
		self
			assertNodeSet: result
			hasNodes: followingNodes.

		result := each >> '*'.
		self
			assertNodeSet: result
			hasNodes: followingNodes elements].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:41'!
testFollowingSiblingAxis
	| nodeWithElements |

	super testFollowingSiblingAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result followingSiblings |
		result := each >>> 'node()'.
		followingSiblings :=
			each hasParent
				ifTrue: [each parent nodes copyAfter: each]
				ifFalse: [self newNodeSet].
		self
			assertNodeSet: result
			hasNodes: followingSiblings.
		self
			assertNodeSet: result
			hasSortOrder: XPathLevelDocumentSortOrder.

		result := each >>> '*'.
		self
			assertNodeSet: result
			hasNodes: followingSiblings elements.
		self
			assertNodeSet: result
			hasSortOrder: XPathLevelDocumentSortOrder].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:41'!
testPrecedingAxis
	| nodeWithElements |

	super testPrecedingAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result precedingNodes |
		result := each << 'node()'.
		precedingNodes :=
			each hasParent
				ifTrue: [each parent descendantNodes copyUpTo: each]
				ifFalse: [self newNodeSet].
		self
			assertNodeSet: result
			hasNodes: precedingNodes.

		result := each << '*'.
		self
			assertNodeSet: result
			hasNodes: precedingNodes elements].! !

!XMLNodeWithElementsTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:40'!
testPrecedingSiblingAxis
	| nodeWithElements |

	super testPrecedingSiblingAxis.

	nodeWithElements := self newNodeWithElements.
	nodeWithElements allNodesDo: [:each | | result precedingSiblings |
		result := each <<< 'node()'.
		precedingSiblings :=
			each hasParent
				ifTrue: [each parent nodes copyUpTo: each]
				ifFalse: [self newNodeSet].
		self
			assertNodeSet: result
			hasNodes: precedingSiblings.
		self
			assertNodeSet: result
			hasSortOrder: XPathLevelDocumentSortOrder.

		result := each <<< '*'.
		self
			assertNodeSet: result
			hasNodes: precedingSiblings elements.
		self
			assertNodeSet: result
			hasSortOrder: XPathLevelDocumentSortOrder].! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:05'!
testAttributeAxis
	| element list |

	super testAttributeAxis.

	element := self newElementWithAttributes.
	list := element @ '*'.
	self
		assert: list = (self nodeSetClass newFrom: element attributeNodes);
		assertNodeSet: list hasSortOrder: XPathLevelDocumentSortOrder.

	element := self newNode.
	self assert: (element @ 'node()') isEmpty.! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testHasExpandedName
	self assert: self newNode hasExpandedName! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testHasNamespaceNodes
	| element |

	element := self newNode.
	self assert: element hasNamespaceNodes.

	element declareNamespaces: self namespaces.
	self assert: element hasNamespaceNodes.

	element configuration usesNamespaces: false.
	self deny: element hasNamespaceNodes.! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:05'!
testNamespaceAxis
	| element list |

	element := self newNode.
	element declareNamespaces: self namespaces.
	list := element namespaceAxis: '*'.
	self
		assert: list = (self nodeSetClass newFrom: element namespaceNodes);
		assertNodeSet: list hasSortOrder: XPathLevelDocumentSortOrder.

	element := self newNode.
	element configuration usesNamespaces: false.
	self assert: (element namespaceAxis: 'node()') isEmpty.! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testNamespaceNodes
	| element nodes |

	element := self newNode.
	nodes :=
		XMLNodeList with:
			(XPathNamespaceNode withXMLNamespaceOnElement: element).
	self assert: element namespaceNodes = nodes.

	element configuration usesNamespaces: false.
	self assert: element namespaceNodes isEmpty.

	element configuration usesNamespaces: true.
	element declareNamespaces: self namespaces.
	self namespaces keysAndValuesDo: [:prefix :uri |
		nodes addLast:
			(XPathNamespaceNode
				element: element
				name: prefix
				uri: uri)].
	self assert: element namespaceNodes = nodes.

	element declarePrefix: 'xml' uri: XMLNamespaceScope xmlNamespaceURI.
	nodes addLast: nodes removeFirst.
	self assert: element namespaceNodes = nodes.! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testNamespaceNodesDo
	| element |

	element := self newNode.
	self
		should: [:block | element namespaceNodesDo: block]
		enumerate: element namespaceNodes.

	element configuration usesNamespaces: false.
	self
		should: [:block | element namespaceNodesDo: block]
		enumerate: #().

	element configuration usesNamespaces: true.
	element declareNamespaces: self namespaces.
	self
		should: [:block | element namespaceNodesDo: block]
		enumerate: element namespaceNodes.

	element declarePrefix: 'xml' uri: XMLNamespaceScope xmlNamespaceURI.
	self
		should: [:block | element namespaceNodesDo: block]
		enumerate: element namespaceNodes.! !

!XMLElementTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testStringValue
	super testStringValue.

	self assert:
		(self newNode
			addString: 'before';
			addNode:
				((self nodeClass named: 'element')
					addString: 'content';
					yourself);
			addString: 'after';
			yourself) stringValue = 'beforecontentafter'.! !

!XMLStringTest methodsFor: '*XPath-Tests' stamp: 'monty 3/26/2015 18:14'!
testStringValue
	super testStringValue.

	self assert:
		(self nodeClass string: self markupString) stringValue =
			self markupString.! !

!XMLCommentTest methodsFor: '*XPath-Tests' stamp: 'monty 3/26/2015 18:15'!
testStringValue
	super testStringValue.

	self assert: (self nodeClass string: 'test') stringValue = 'test'.! !

!XMLAttributeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testHasExpandedName
	self assert: self newNode hasExpandedName! !

!XMLAttributeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/26/2015 18:14'!
testStringValue
	super testStringValue.

	self assert:
		(self nodeClass
			name: 'name'
			value: 'value') stringValue = 'value'! !

XMLAbstractSetTest subclass: #XPathFunctionSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathFunctionSetTest class methodsFor: 'testing' stamp: 'monty 3/29/2016 07:47'!
isAbstract
	^ false! !

!XPathFunctionSetTest methodsFor: 'accessing' stamp: 'monty 3/30/2016 01:32'!
absentSetElement
	^ XPathStringFunction! !

!XPathFunctionSetTest methodsFor: 'accessing' stamp: 'monty 3/29/2016 08:00'!
disjointSetElements
	^ Array
		with: XPathSubstringFunction
		with: XPathSubstringBeforeFunction;
		with: XPathSubstringAfterFunction! !

!XPathFunctionSetTest methodsFor: 'accessing' stamp: 'monty 1/19/2015 15:15'!
setClass
	^ XPathFunctionSet! !

!XPathFunctionSetTest methodsFor: 'accessing' stamp: 'monty 1/25/2017 14:31'!
setElements
	^ Array
		with: XPathCeilingFunction
		with: XPathFloorFunction
		with: XPathRoundFunction
		with: XPathSumFunction! !

!XPathFunctionSetTest methodsFor: 'asserting' stamp: 'monty 3/6/2016 14:39'!
should: aBlock add: aFirstObject and: aSecondObject equaling: anExpectedSum
	| firstCopy secondCopy sum |

	firstCopy := aFirstObject asXPathFunctionSet copy.
	secondCopy := aSecondObject asXPathFunctionSet copy.
	sum := aBlock value.
	self
		assert: sum = anExpectedSum;
		deny: sum == aFirstObject;
		deny: sum == aSecondObject;
		assert: firstCopy = aFirstObject asXPathFunctionSet;
		assert: secondCopy = aSecondObject asXPathFunctionSet.! !

!XPathFunctionSetTest methodsFor: 'asserting' stamp: 'monty 3/6/2016 14:39'!
should: aBlock subtract: aFirstObject from: aSecondObject equaling: anExpectedDifference
	| firstCopy secondCopy difference |

	firstCopy := aFirstObject asXPathFunctionSet copy.
	secondCopy := aSecondObject asXPathFunctionSet copy.
	difference := aBlock value.
	self
		assert: difference = anExpectedDifference;
		deny: difference == aFirstObject;
		deny: difference == aSecondObject;
		assert: firstCopy = aFirstObject asXPathFunctionSet;
		assert: secondCopy = aSecondObject asXPathFunctionSet.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:44'!
testAsFunctionSet
	| set function |

	set := self setClass new.
	function := self setElements anyOne.
	self
		assert: set asXPathFunctionSet == set;
		assert: (function asXPathFunctionSet) = (self setClass with: function);
		assert: self setElements asXPathFunctionSet = self setWithElements.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 9/6/2016 02:25'!
testCopy
	| set copy |

	super testCopy.

	set := self setWithElements.
	copy := set copy.
	self
		assert: set functionsByName = copy functionsByName;
		deny: set functionsByName == copy functionsByName.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 1/9/2017 09:48'!
testFunctionNamed
	| set |

	set := self setWithElements.
	self setElements do: [:each |
		self assert: (set functionNamed: each prototypeName) == each].

	self
		shouldnt: [set functionNamed: self absentSetElement prototypeName]
		raise: Error.
	self assert: (set functionNamed: self absentSetElement prototypeName) isNil.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 1/9/2017 09:48'!
testFunctionNamedIfAbsent
	| set |

	set := self setWithElements.
	self setElements do: [:each |
		self assert:
			(set
				functionNamed: each prototypeName
				ifAbsent: [self absentSetElement]) == each].
	self assert:
		(set
			functionNamed: self absentSetElement prototypeName
			ifAbsent: [self absentSetElement]) == self absentSetElement.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 1/9/2017 09:48'!
testIncludesFunctionNamed
	| set |

	set := self emptySet.
	self setElements do: [:each |
		self deny: (set includesFunctionNamed: each prototypeName)].

	set := self setWithElements.
	self setElements do: [:each |
		self assert: (set includesFunctionNamed: each prototypeName)].
	self disjointSetElements do: [:each |
		self deny: (set includesFunctionNamed: each prototypeName)].

	set := self setWithDisjointElements.
	self disjointSetElements do: [:each |
		self assert: (set includesFunctionNamed: each prototypeName)].! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 08:00'!
testMinusFunction
	| set |

	set := self setWithElements.
	self setElements do: [:each |
		self
			should: [set - each]
			subtract: each
			from: set
			equaling: (self setClass newFrom: (self setElements copyWithout: each))].

	self disjointSetElements do: [:each |
		self
			should: [set - each]
			subtract: each
			from: set
			equaling: self setWithElements].

	self assert:
		(self setElements first - self setElements second) =
			(self setClass with: self setElements first).
	self assert:
		(self setElements first - self setElements first) =
			self emptySet.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:43'!
testMinusSet
	| firstSet secondSet |

	firstSet := self setWithElements.
	secondSet := self emptySet.
	self
		should: [firstSet - secondSet]
		subtract: secondSet
		from: firstSet
		equaling: self setWithElements.

	secondSet := self setWithDisjointElements.
	self
		should: [firstSet - secondSet]
		subtract: secondSet
		from: firstSet
		equaling: self setWithElements.
	self
		should: [firstSet - firstSet]
		subtract: firstSet
		from: firstSet
		equaling: self emptySet.! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 08:00'!
testPlusFunction
	| set |

	set := self setWithElements.
	self setElements do: [:each |
		self
			should: [set + each]
			add: each
			and: set
			equaling: self setWithElements].

	set := self setWithElements.
	self disjointSetElements do: [:each |
		self
			should: [set + each]
			add: each
			and: set
			equaling: (self setClass newFrom: (self setElements copyWith: each))].

	self assert:
		(self setElements first + self setElements second) =
			(self setClass
				with: self setElements first
				with: self setElements second).

	self assert:
		(self setElements first + self setElements first) =
			(self setClass with: self setElements first).! !

!XPathFunctionSetTest methodsFor: 'tests' stamp: 'monty 3/29/2016 07:43'!
testPlusSet
	| firstSet secondSet |

	firstSet := self setWithElements.
	secondSet := self emptySet.
	self
		should: [firstSet + secondSet]
		add: firstSet
		and: secondSet
		equaling: self setWithElements.
	self
		should: [firstSet + firstSet]
		add: firstSet
		and: firstSet
		equaling: self setWithElements.

	secondSet := self setWithDisjointElements.
	self
		should: [firstSet + secondSet]
		add: firstSet
		and: secondSet
		equaling:
			(self setClass newFrom:
				self setWithDisjointElements, self setWithElements).! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 4/3/2015 07:50'!
testAllNodesReverseDo
	| nodeWithNodes |

	super testAllNodesReverseDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each allNodesReverseDo: block]
			enumerate:
				(each hasChildren
					ifTrue: [each allNodes reversed]
					ifFalse: [Array with: each])].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:30'!
testFollowingNodes
	| nodeWithNodes |

	super testFollowingNodes.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each | | following |
		following := each followingNodes.
		each hasParent
			ifTrue: [
				self assert:
					following =
						(each parent descendantNodes copyAfter:
							(each hasChildren
								ifTrue: [each descendantNodes last]
								ifFalse: [each]))]
			ifFalse: [
				self assert: following isEmpty]].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/27/2016 13:38'!
testFollowingNodesDo
	| nodeWithNodes |

	super testFollowingNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each followingNodesDo: block]
			enumerate:
				(each hasParent
					ifTrue: [
						each parent descendantNodes copyAfter:
							(each hasChildren
								ifTrue: [each descendantNodes last]
								ifFalse: [each])]
					ifFalse: [#()])].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:30'!
testFollowingSiblingNodes
	| nodeWithNodes |

	super testFollowingSiblingNodes.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each | | followingSiblings |
		followingSiblings := each followingSiblingNodes.
		each hasParent
			ifTrue: [
				self assert:
					followingSiblings =
						(each parent nodes copyAfter: each)]
			ifFalse: [
				self assert: followingSiblings isEmpty]].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 4/1/2015 23:55'!
testFollowingSiblingNodesDo
	| nodeWithNodes |

	super testFollowingSiblingNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each followingSiblingNodesDo: block]
			enumerate:
				(each hasParent
					ifTrue: [each parent nodes copyAfter: each]
					ifFalse: [#()])].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:25'!
testPrecedingNodes
	| nodeWithNodes |

	super testPrecedingNodes.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each | | preceding |
		preceding := each precedingNodes.
		each hasParent
			ifTrue: [
				self assert:
					preceding =
						(each parent descendantNodes copyUpTo: each) reversed]
			ifFalse: [
				self assert: preceding isEmpty]].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/27/2016 13:38'!
testPrecedingNodesDo
	| nodeWithNodes |

	super testPrecedingNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each precedingNodesDo: block]
			enumerate:
				(each hasParent
					ifTrue: [(each parent descendantNodes copyUpTo: each) reversed]
					ifFalse: [#()])].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:24'!
testPrecedingSiblingNodes
	| nodeWithNodes |

	super testPrecedingSiblingNodes.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each | | precedingSiblings |
		precedingSiblings := each precedingSiblingNodes.
		each hasParent
			ifTrue: [
				self assert:
					precedingSiblings =
						(each parent nodes copyUpTo: each) reversed]
			ifFalse: [
				self assert: precedingSiblings isEmpty]].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 4/1/2015 23:57'!
testPrecedingSiblingNodesDo
	| nodeWithNodes |

	super testPrecedingSiblingNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each precedingSiblingNodesDo: block]
			enumerate:
				(each hasParent
					ifTrue: [(each parent nodes copyUpTo: each) reversed]
					ifFalse: [#()])].! !

!XMLNodeWithChildrenTest methodsFor: '*XPath-Tests' stamp: 'monty 2/20/2017 04:18'!
testWithAncestorNodesDo
	| nodeWithNodes |

	super testWithAncestorNodesDo.

	nodeWithNodes := self newNodeWithNodes.
	nodeWithNodes allNodesDo: [:each |
		self
			should: [:block | each withAncestorNodesDo: block]
			enumerate: (each ancestorNodes copyWithFirst: each)].! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:32'!
assertNodeSet: aNodeSet hasNode: aNode
	self
		assertNodeSet: aNodeSet
		hasNodes: (self nodeSetClass with: aNode)! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:34'!
assertNodeSet: aNodeSet hasNodes: aNodeCollection
	self
		assert: aNodeSet size = aNodeCollection size;
		assert: aNodeSet = (XPathNodeSet newFrom: aNodeCollection) sort;
		assert: (aNodeSet sortOrder isKindOf: XPathDocumentSortOrder)! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/25/2017 02:49'!
assertNodeSet: aNodeSet hasSortOrder: aSortOrder
	self assert: aNodeSet sortOrder class == aSortOrder! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 9/22/2016 17:32'!
contextClass
	^ XPathContext! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 9/22/2016 17:32'!
newContext
	^ self contextClass new! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 9/22/2016 17:03'!
newNodeSet
	^ self nodeSetClass new! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 9/22/2016 17:03'!
nodeSetClass
	^ XPathNodeSet! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testAllNodesReverseDo
	| node |

	node := self newNode.
	self
		should: [:block | node allNodesReverseDo: block]
		enumerate: (Array with: node).! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testAncestorAxis
	self
		assert: (self newNode %% 'node()') isEmpty;
		assert: (self newNode %% '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:35'!
testAncestorOrSelfAxis
	| node result |

	node := self newNode.
	result := node %%~ 'node()'.
	self
		assertNodeSet: result
		hasNode: node.

	result := node %%~ '*'.
	node isElement
		ifTrue: [
			self
				assertNodeSet: result
				hasNode: node]
		ifFalse: [self assert: result isEmpty].! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 1/25/2017 11:39'!
testAsXPathFilterExpressionLocationPathRoot
	| node |

	node := self newNode.
	self assert: node asXPathFilterExpressionLocationPathRoot == node.! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 1/29/2017 13:48'!
testAsXPathNodeSet
	self
		should: [self newNode asXPathNodeSet]
		raise: XPathTypeException! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testAttributeAxis
	self
		assert: (self newNode @ 'node()') isEmpty;
		assert: (self newNode @ '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testChildAxis
	self
		assert: (self newNode / 'node()') isEmpty;
		assert: (self newNode / '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testDescendantAxis
	self
		assert: (self newNode // 'node()') isEmpty;
		assert: (self newNode // '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:32'!
testDescendantOrSelfAxis
	| node result |

	node := self newNode.
	result := node //~ 'node()'.
	self
		assertNodeSet: result
		hasNode: node.

	result := node //~ '*'.
	node isElement
		ifTrue: [
			self
				assertNodeSet: result
				hasNode: node]
		ifFalse: [self assert: result isEmpty].! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testFollowingAxis
	self
		assert: (self newNode >> 'node()') isEmpty;
		assert: (self newNode >> '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:27'!
testFollowingNodes
	self assert: self newNode followingNodes isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testFollowingNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node followingNodesDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testFollowingSiblingAxis
	self
		assert: (self newNode >>> 'node()') isEmpty;
		assert: (self newNode >>> '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:26'!
testFollowingSiblingNodes
	self assert: self newNode followingSiblingNodes isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testFollowingSiblingNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node followingSiblingNodesDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testHasExpandedName
	self deny: self newNode hasExpandedName! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testIsNamespace
	self deny: self newNode isNamespace! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/14/2017 22:24'!
testNamespaceAxis
	self
		assert: (self newNode namespaceAxis: 'node()') isEmpty;
		assert: (self newNode namespaceAxis: '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testParentAxis
	self
		assert: (self newNode % 'node()') isEmpty;
		assert: (self newNode % '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testPrecedingAxis
	self
		assert: (self newNode << 'node()') isEmpty;
		assert: (self newNode << '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:20'!
testPrecedingNodes
	self assert: self newNode precedingNodes isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testPrecedingNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node precedingNodesDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testPrecedingSiblingAxis
	self
		assert: (self newNode <<< 'node()') isEmpty;
		assert: (self newNode <<< '*') isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 2/19/2017 23:26'!
testPrecedingSiblingNodes
	self assert: self newNode precedingSiblingNodes isEmpty! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 8/27/2016 17:20'!
testPrecedingSiblingNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node precedingSiblingNodesDo: block]
		enumerate: #().! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/17/2017 23:32'!
testSelfAxis
	| node result |

	node := self newNode.
	result := node ~ 'node()'.
	self
		assertNodeSet: result
		hasNode: node.
	self
		assertNodeSet: result
		hasSortOrder: XPathLevelDocumentSortOrder.

	result := node ~ '*'.
	node isElement
		ifTrue: [
			self
				assertNodeSet: result
				hasNode: node.
			self
				assertNodeSet: result
				hasSortOrder: XPathLevelDocumentSortOrder]
		ifFalse: [self assert: result isEmpty].! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 9/5/2016 21:24'!
testStringValue
	self assert: self newNode stringValue = ''! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 2/20/2017 04:16'!
testWithAncestorNodesDo
	| node |

	node := self newNode.
	self
		should: [:block | node withAncestorNodesDo: block]
		enumerate: (Array with: node)! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/14/2017 22:25'!
testXPath
	| node |

	node := self newNode.
	self
		assert: (node xpath: '.') = (self nodeSetClass with: node);
		assert: (node xpath: (XPath for: '.')) = (self nodeSetClass with: node).! !

!XMLNodeTest methodsFor: '*XPath-Tests' stamp: 'monty 3/14/2017 22:25'!
testXPathContext
	| node context |

	node := self newNode.
	context := self newContext.
	context
		variableAt: 'var'
		put: 'test'.
	self
		assert: (node xpath: '$var' context: context) = 'test';
		assert: (node xpath: (XPath for: '$var') context: context) = 'test'.! !

XMLNodeTest subclass: #XPathNamespaceNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPath-Tests'!

!XPathNamespaceNodeTest methodsFor: 'instance creation' stamp: 'monty 3/26/2015 23:21'!
newElementWithNamespaceNode
	^ self newElementWithAttributes
		declarePrefix: 'prefix'
		uri: 'prefixNS'! !

!XPathNamespaceNodeTest methodsFor: 'instance creation' stamp: 'monty 3/10/2015 13:50'!
newNamespaceNode
	^ self nodeClass
		element: self newElementWithAttributes
		name: 'prefix'
		uri: 'prefixNS'! !

!XPathNamespaceNodeTest methodsFor: 'accessing' stamp: 'monty 2/13/2015 08:40'!
nodeClass
	^ XPathNamespaceNode! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 13:53'!
testEquals
	| firstNamespace secondNamespace |

	firstNamespace := self newNamespaceNode.
	self assert: firstNamespace = firstNamespace.

	secondNamespace :=
		self nodeClass
			element: firstNamespace element
			name: firstNamespace name
			uri: firstNamespace uri.
	self assert: firstNamespace = secondNamespace.

	secondNamespace :=
		self nodeClass
			element: self newElementWithAttributes
			name: firstNamespace name
			uri: firstNamespace uri.
	self deny: firstNamespace = secondNamespace.

	secondNamespace :=
		self nodeClass
			element: firstNamespace element
			name: 'newPrefix'
			uri: firstNamespace uri.
	self deny: firstNamespace = secondNamespace.

	secondNamespace :=
		self nodeClass
			element: firstNamespace element
			name: firstNamespace name
			uri: 'newURI'.
	self deny: firstNamespace = secondNamespace.! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 14:09'!
testExpandedName
	self assert: self newNamespaceNode expandedName = 'prefix'! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testHasExpandedName
	self assert: self newNode hasExpandedName! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 13:08'!
testHasNamespaceURI
	self deny: self newNamespaceNode hasNamespaceURI! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 13:45'!
testHasPrefix
	self deny: self newNamespaceNode hasPrefix! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 8/27/2016 17:20'!
testIsNamespace
	self assert: self newNode isNamespace! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 14:09'!
testLocalName
	self assert: self newNamespaceNode localName = 'prefix'! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 14:09'!
testName
	self assert: self newNamespaceNode name = 'prefix'! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:17'!
testNamespaceURI
	self assert: self newNamespaceNode namespaceURI = ''! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 9/5/2016 21:16'!
testPrefix
	"namespace nodes model prefixes, but cannot be prefixed themselves"
	self assert: self newNamespaceNode prefix = ''! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/26/2015 18:14'!
testStringValue
	super testStringValue.

	self assert: self newNamespaceNode stringValue = 'prefixNS'.! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 14:16'!
testURI
	self assert: self newNamespaceNode uri = 'prefixNS'! !

!XPathNamespaceNodeTest methodsFor: 'tests' stamp: 'monty 3/10/2015 14:28'!
testWriteXMLOn
	self assert: self newNamespaceNode printString = 'xmlns:prefix="prefixNS"'.
	self assert:
		(self nodeClass withXMLNamespaceOnElement: nil) printString =
			('xmlns:xml="', XMLNamespaceScope xmlNamespaceURI, '"').
	self assert:
		(self nodeClass
			element: nil
			name: ''
			uri: 'defaultNS') printString = 'xmlns="defaultNS"'.! !
